# This file was automatically generated by SWIG (http://www.swig.org).
# Version 3.0.12
#
# Do not make changes to this file unless you know what you are doing--modify
# the SWIG interface file instead.

"""The TimeTagger module measures timing events very accurately."""



# The Time Tagger library uses numpy to return array values
import numpy

try:
    import _TimeTagger
except:
    import platform
    import sys
    import os

    assert 'TIMETAGGER_INSTALL_PATH' in os.environ, 'The Time Tagger installation was not found. Please reinstall the Time Tagger Software suite.'

    # detect bitness and python version
    arch = 'x64' if platform.architecture()[0] == '64bit' else 'x86'
    version = str(sys.version_info.major) + '.' + str(sys.version_info.minor)

    # absolute path for the TimeTagger module
    path = os.environ['TIMETAGGER_INSTALL_PATH'] + '\\driver\\' + arch + '\\python' + version

    # add the new path
    if not path in sys.path:
        sys.path.append(path)

    try:
        import _TimeTagger
    except:
        assert version in ['3.6', '3.7', '3.8', '3.9', '3.10'], 'This Python version is not supported by the Time Tagger software suite.'
        raise

    # clear all local variables
    del platform, sys, os, arch, version, path


try:
    _swig_property = property
except NameError:
    pass  # Python < 2.2 doesn't have 'property'.

try:
    import builtins as __builtin__
except ImportError:
    import __builtin__

def _swig_setattr_nondynamic(self, class_type, name, value, static=1):
    if (name == "thisown"):
        return self.this.own(value)
    if (name == "this"):
        if type(value).__name__ == 'SwigPyObject':
            self.__dict__[name] = value
            return
    method = class_type.__swig_setmethods__.get(name, None)
    if method:
        return method(self, value)
    if (not static):
        if _newclass:
            object.__setattr__(self, name, value)
        else:
            self.__dict__[name] = value
    else:
        raise AttributeError("You cannot add attributes to %s" % self)


def _swig_setattr(self, class_type, name, value):
    return _swig_setattr_nondynamic(self, class_type, name, value, 0)


def _swig_getattr(self, class_type, name):
    if (name == "thisown"):
        return self.this.own()
    method = class_type.__swig_getmethods__.get(name, None)
    if method:
        return method(self)
    raise AttributeError("'%s' object has no attribute '%s'" % (class_type.__name__, name))


def _swig_repr(self):
    try:
        strthis = "proxy of " + self.this.__repr__()
    except __builtin__.Exception:
        strthis = ""
    return "<%s.%s; %s >" % (self.__class__.__module__, self.__class__.__name__, strthis,)

try:
    _object = object
    _newclass = 1
except __builtin__.Exception:
    class _object:
        pass
    _newclass = 0

try:
    import weakref
    weakref_proxy = weakref.proxy
except __builtin__.Exception:
    weakref_proxy = lambda x: x


class SwigPyIterator(_object):
    """Proxy of C++ swig::SwigPyIterator class."""

    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, SwigPyIterator, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, SwigPyIterator, name)

    def __init__(self, *args, **kwargs):
        raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _TimeTagger.delete_SwigPyIterator
    __del__ = lambda self: None

    def value(self) -> "PyObject *":
        """value(self) -> PyObject *"""
        return _TimeTagger.SwigPyIterator_value(self)


    def incr(self, n: 'size_t'=1) -> "swig::SwigPyIterator *":
        """incr(self, n=1) -> SwigPyIterator"""
        return _TimeTagger.SwigPyIterator_incr(self, n)


    def decr(self, n: 'size_t'=1) -> "swig::SwigPyIterator *":
        """decr(self, n=1) -> SwigPyIterator"""
        return _TimeTagger.SwigPyIterator_decr(self, n)


    def distance(self, x: 'SwigPyIterator') -> "ptrdiff_t":
        """distance(self, x) -> ptrdiff_t"""
        return _TimeTagger.SwigPyIterator_distance(self, x)


    def equal(self, x: 'SwigPyIterator') -> "bool":
        """equal(self, x) -> bool"""
        return _TimeTagger.SwigPyIterator_equal(self, x)


    def copy(self) -> "swig::SwigPyIterator *":
        """copy(self) -> SwigPyIterator"""
        return _TimeTagger.SwigPyIterator_copy(self)


    def next(self) -> "PyObject *":
        """next(self) -> PyObject *"""
        return _TimeTagger.SwigPyIterator_next(self)


    def __next__(self) -> "PyObject *":
        """__next__(self) -> PyObject *"""
        return _TimeTagger.SwigPyIterator___next__(self)


    def previous(self) -> "PyObject *":
        """previous(self) -> PyObject *"""
        return _TimeTagger.SwigPyIterator_previous(self)


    def advance(self, n: 'ptrdiff_t') -> "swig::SwigPyIterator *":
        """advance(self, n) -> SwigPyIterator"""
        return _TimeTagger.SwigPyIterator_advance(self, n)


    def __eq__(self, x: 'SwigPyIterator') -> "bool":
        """__eq__(self, x) -> bool"""
        return _TimeTagger.SwigPyIterator___eq__(self, x)


    def __ne__(self, x: 'SwigPyIterator') -> "bool":
        """__ne__(self, x) -> bool"""
        return _TimeTagger.SwigPyIterator___ne__(self, x)


    def __iadd__(self, n: 'ptrdiff_t') -> "swig::SwigPyIterator &":
        """__iadd__(self, n) -> SwigPyIterator"""
        return _TimeTagger.SwigPyIterator___iadd__(self, n)


    def __isub__(self, n: 'ptrdiff_t') -> "swig::SwigPyIterator &":
        """__isub__(self, n) -> SwigPyIterator"""
        return _TimeTagger.SwigPyIterator___isub__(self, n)


    def __add__(self, n: 'ptrdiff_t') -> "swig::SwigPyIterator *":
        """__add__(self, n) -> SwigPyIterator"""
        return _TimeTagger.SwigPyIterator___add__(self, n)


    def __sub__(self, *args) -> "ptrdiff_t":
        """
        __sub__(self, n) -> SwigPyIterator
        __sub__(self, x) -> ptrdiff_t
        """
        return _TimeTagger.SwigPyIterator___sub__(self, *args)

    def __iter__(self):
        return self
SwigPyIterator_swigregister = _TimeTagger.SwigPyIterator_swigregister
SwigPyIterator_swigregister(SwigPyIterator)


def _timeout_handler(callback, timeout):
    r"""
        helper for splitting up timeouts in smaller calls. So CTRL-C will be able to interrupt blocking calls.
        timeout is in milliseconds, 0 means non-blocking, negative means no timeout.
        returns True on success and False on timeout.
    """
    import sys
    if sys.version_info.major < 3 or timeout == 0:
        return callback(timeout)

    maximum_timeout = 20

    if timeout < 0:
        while not callback(maximum_timeout):
            pass
        return True

    import time
    original_time = time.monotonic()
    while True:
        remaining_timeout = max(0,min(maximum_timeout, timeout - round((time.monotonic() - original_time)*1000)))
        if callback(remaining_timeout):
            return True
        if remaining_timeout == 0:
            return False


def getTimeTaggerServerInfo(*args, **kargs):
    r"""getTimeTaggerServerInfo(...) -> json"""
    import json
    return json.loads(__getTimeTaggerServerInfo(*args, **kargs))


def extractDeviceLicense(*args, **kargs):
    r"""extractDeviceLicense(...) -> json"""
    import json
    return json.loads(__extractDeviceLicense(*args, **kargs))

class UCharVector(_object):
    """Proxy of C++ std::vector<(unsigned char)> class."""

    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, UCharVector, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, UCharVector, name)
    __repr__ = _swig_repr

    def iterator(self) -> "swig::SwigPyIterator *":
        """iterator(self) -> SwigPyIterator"""
        return _TimeTagger.UCharVector_iterator(self)

    def __iter__(self):
        return self.iterator()

    def __nonzero__(self) -> "bool":
        """__nonzero__(self) -> bool"""
        return _TimeTagger.UCharVector___nonzero__(self)


    def __bool__(self) -> "bool":
        """__bool__(self) -> bool"""
        return _TimeTagger.UCharVector___bool__(self)


    def __len__(self) -> "std::vector< unsigned char >::size_type":
        """__len__(self) -> std::vector< unsigned char >::size_type"""
        return _TimeTagger.UCharVector___len__(self)


    def __getslice__(self, i: 'std::vector< unsigned char >::difference_type', j: 'std::vector< unsigned char >::difference_type') -> "std::vector< unsigned char,std::allocator< unsigned char > > *":
        """__getslice__(self, i, j) -> UCharVector"""
        return _TimeTagger.UCharVector___getslice__(self, i, j)


    def __setslice__(self, *args) -> "void":
        """
        __setslice__(self, i, j)
        __setslice__(self, i, j, v)
        """
        return _TimeTagger.UCharVector___setslice__(self, *args)


    def __delslice__(self, i: 'std::vector< unsigned char >::difference_type', j: 'std::vector< unsigned char >::difference_type') -> "void":
        """__delslice__(self, i, j)"""
        return _TimeTagger.UCharVector___delslice__(self, i, j)


    def __delitem__(self, *args) -> "void":
        """
        __delitem__(self, i)
        __delitem__(self, slice)
        """
        return _TimeTagger.UCharVector___delitem__(self, *args)


    def __getitem__(self, *args) -> "std::vector< unsigned char >::value_type const &":
        """
        __getitem__(self, slice) -> UCharVector
        __getitem__(self, i) -> std::vector< unsigned char >::value_type const &
        """
        return _TimeTagger.UCharVector___getitem__(self, *args)


    def __setitem__(self, *args) -> "void":
        """
        __setitem__(self, slice, v)
        __setitem__(self, slice)
        __setitem__(self, i, x)
        """
        return _TimeTagger.UCharVector___setitem__(self, *args)


    def pop(self) -> "std::vector< unsigned char >::value_type":
        """pop(self) -> std::vector< unsigned char >::value_type"""
        return _TimeTagger.UCharVector_pop(self)


    def append(self, x: 'std::vector< unsigned char >::value_type const &') -> "void":
        """append(self, x)"""
        return _TimeTagger.UCharVector_append(self, x)


    def empty(self) -> "bool":
        """empty(self) -> bool"""
        return _TimeTagger.UCharVector_empty(self)


    def size(self) -> "std::vector< unsigned char >::size_type":
        """size(self) -> std::vector< unsigned char >::size_type"""
        return _TimeTagger.UCharVector_size(self)


    def swap(self, v: 'UCharVector') -> "void":
        """swap(self, v)"""
        return _TimeTagger.UCharVector_swap(self, v)


    def begin(self) -> "std::vector< unsigned char >::iterator":
        """begin(self) -> std::vector< unsigned char >::iterator"""
        return _TimeTagger.UCharVector_begin(self)


    def end(self) -> "std::vector< unsigned char >::iterator":
        """end(self) -> std::vector< unsigned char >::iterator"""
        return _TimeTagger.UCharVector_end(self)


    def rbegin(self) -> "std::vector< unsigned char >::reverse_iterator":
        """rbegin(self) -> std::vector< unsigned char >::reverse_iterator"""
        return _TimeTagger.UCharVector_rbegin(self)


    def rend(self) -> "std::vector< unsigned char >::reverse_iterator":
        """rend(self) -> std::vector< unsigned char >::reverse_iterator"""
        return _TimeTagger.UCharVector_rend(self)


    def clear(self) -> "void":
        """clear(self)"""
        return _TimeTagger.UCharVector_clear(self)


    def get_allocator(self) -> "std::vector< unsigned char >::allocator_type":
        """get_allocator(self) -> std::vector< unsigned char >::allocator_type"""
        return _TimeTagger.UCharVector_get_allocator(self)


    def pop_back(self) -> "void":
        """pop_back(self)"""
        return _TimeTagger.UCharVector_pop_back(self)


    def erase(self, *args) -> "std::vector< unsigned char >::iterator":
        """
        erase(self, pos) -> std::vector< unsigned char >::iterator
        erase(self, first, last) -> std::vector< unsigned char >::iterator
        """
        return _TimeTagger.UCharVector_erase(self, *args)


    def __init__(self, *args):
        """
        __init__(self) -> UCharVector
        __init__(self, arg2) -> UCharVector
        __init__(self, size) -> UCharVector
        __init__(self, size, value) -> UCharVector
        """
        this = _TimeTagger.new_UCharVector(*args)
        try:
            self.this.append(this)
        except __builtin__.Exception:
            self.this = this

    def push_back(self, x: 'std::vector< unsigned char >::value_type const &') -> "void":
        """push_back(self, x)"""
        return _TimeTagger.UCharVector_push_back(self, x)


    def front(self) -> "std::vector< unsigned char >::value_type const &":
        """front(self) -> std::vector< unsigned char >::value_type const &"""
        return _TimeTagger.UCharVector_front(self)


    def back(self) -> "std::vector< unsigned char >::value_type const &":
        """back(self) -> std::vector< unsigned char >::value_type const &"""
        return _TimeTagger.UCharVector_back(self)


    def assign(self, n: 'std::vector< unsigned char >::size_type', x: 'std::vector< unsigned char >::value_type const &') -> "void":
        """assign(self, n, x)"""
        return _TimeTagger.UCharVector_assign(self, n, x)


    def resize(self, *args) -> "void":
        """
        resize(self, new_size)
        resize(self, new_size, x)
        """
        return _TimeTagger.UCharVector_resize(self, *args)


    def insert(self, *args) -> "void":
        """
        insert(self, pos, x) -> std::vector< unsigned char >::iterator
        insert(self, pos, n, x)
        """
        return _TimeTagger.UCharVector_insert(self, *args)


    def reserve(self, n: 'std::vector< unsigned char >::size_type') -> "void":
        """reserve(self, n)"""
        return _TimeTagger.UCharVector_reserve(self, n)


    def capacity(self) -> "std::vector< unsigned char >::size_type":
        """capacity(self) -> std::vector< unsigned char >::size_type"""
        return _TimeTagger.UCharVector_capacity(self)

    __swig_destroy__ = _TimeTagger.delete_UCharVector
    __del__ = lambda self: None
UCharVector_swigregister = _TimeTagger.UCharVector_swigregister
UCharVector_swigregister(UCharVector)

class IntVector(_object):
    """Proxy of C++ std::vector<(int)> class."""

    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, IntVector, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, IntVector, name)
    __repr__ = _swig_repr

    def iterator(self) -> "swig::SwigPyIterator *":
        """iterator(self) -> SwigPyIterator"""
        return _TimeTagger.IntVector_iterator(self)

    def __iter__(self):
        return self.iterator()

    def __nonzero__(self) -> "bool":
        """__nonzero__(self) -> bool"""
        return _TimeTagger.IntVector___nonzero__(self)


    def __bool__(self) -> "bool":
        """__bool__(self) -> bool"""
        return _TimeTagger.IntVector___bool__(self)


    def __len__(self) -> "std::vector< int >::size_type":
        """__len__(self) -> std::vector< int >::size_type"""
        return _TimeTagger.IntVector___len__(self)


    def __getslice__(self, i: 'std::vector< int >::difference_type', j: 'std::vector< int >::difference_type') -> "std::vector< int,std::allocator< int > > *":
        """__getslice__(self, i, j) -> IntVector"""
        return _TimeTagger.IntVector___getslice__(self, i, j)


    def __setslice__(self, *args) -> "void":
        """
        __setslice__(self, i, j)
        __setslice__(self, i, j, v)
        """
        return _TimeTagger.IntVector___setslice__(self, *args)


    def __delslice__(self, i: 'std::vector< int >::difference_type', j: 'std::vector< int >::difference_type') -> "void":
        """__delslice__(self, i, j)"""
        return _TimeTagger.IntVector___delslice__(self, i, j)


    def __delitem__(self, *args) -> "void":
        """
        __delitem__(self, i)
        __delitem__(self, slice)
        """
        return _TimeTagger.IntVector___delitem__(self, *args)


    def __getitem__(self, *args) -> "std::vector< int >::value_type const &":
        """
        __getitem__(self, slice) -> IntVector
        __getitem__(self, i) -> std::vector< int >::value_type const &
        """
        return _TimeTagger.IntVector___getitem__(self, *args)


    def __setitem__(self, *args) -> "void":
        """
        __setitem__(self, slice, v)
        __setitem__(self, slice)
        __setitem__(self, i, x)
        """
        return _TimeTagger.IntVector___setitem__(self, *args)


    def pop(self) -> "std::vector< int >::value_type":
        """pop(self) -> std::vector< int >::value_type"""
        return _TimeTagger.IntVector_pop(self)


    def append(self, x: 'std::vector< int >::value_type const &') -> "void":
        """append(self, x)"""
        return _TimeTagger.IntVector_append(self, x)


    def empty(self) -> "bool":
        """empty(self) -> bool"""
        return _TimeTagger.IntVector_empty(self)


    def size(self) -> "std::vector< int >::size_type":
        """size(self) -> std::vector< int >::size_type"""
        return _TimeTagger.IntVector_size(self)


    def swap(self, v: 'IntVector') -> "void":
        """swap(self, v)"""
        return _TimeTagger.IntVector_swap(self, v)


    def begin(self) -> "std::vector< int >::iterator":
        """begin(self) -> std::vector< int >::iterator"""
        return _TimeTagger.IntVector_begin(self)


    def end(self) -> "std::vector< int >::iterator":
        """end(self) -> std::vector< int >::iterator"""
        return _TimeTagger.IntVector_end(self)


    def rbegin(self) -> "std::vector< int >::reverse_iterator":
        """rbegin(self) -> std::vector< int >::reverse_iterator"""
        return _TimeTagger.IntVector_rbegin(self)


    def rend(self) -> "std::vector< int >::reverse_iterator":
        """rend(self) -> std::vector< int >::reverse_iterator"""
        return _TimeTagger.IntVector_rend(self)


    def clear(self) -> "void":
        """clear(self)"""
        return _TimeTagger.IntVector_clear(self)


    def get_allocator(self) -> "std::vector< int >::allocator_type":
        """get_allocator(self) -> std::vector< int >::allocator_type"""
        return _TimeTagger.IntVector_get_allocator(self)


    def pop_back(self) -> "void":
        """pop_back(self)"""
        return _TimeTagger.IntVector_pop_back(self)


    def erase(self, *args) -> "std::vector< int >::iterator":
        """
        erase(self, pos) -> std::vector< int >::iterator
        erase(self, first, last) -> std::vector< int >::iterator
        """
        return _TimeTagger.IntVector_erase(self, *args)


    def __init__(self, *args):
        """
        __init__(self) -> IntVector
        __init__(self, arg2) -> IntVector
        __init__(self, size) -> IntVector
        __init__(self, size, value) -> IntVector
        """
        this = _TimeTagger.new_IntVector(*args)
        try:
            self.this.append(this)
        except __builtin__.Exception:
            self.this = this

    def push_back(self, x: 'std::vector< int >::value_type const &') -> "void":
        """push_back(self, x)"""
        return _TimeTagger.IntVector_push_back(self, x)


    def front(self) -> "std::vector< int >::value_type const &":
        """front(self) -> std::vector< int >::value_type const &"""
        return _TimeTagger.IntVector_front(self)


    def back(self) -> "std::vector< int >::value_type const &":
        """back(self) -> std::vector< int >::value_type const &"""
        return _TimeTagger.IntVector_back(self)


    def assign(self, n: 'std::vector< int >::size_type', x: 'std::vector< int >::value_type const &') -> "void":
        """assign(self, n, x)"""
        return _TimeTagger.IntVector_assign(self, n, x)


    def resize(self, *args) -> "void":
        """
        resize(self, new_size)
        resize(self, new_size, x)
        """
        return _TimeTagger.IntVector_resize(self, *args)


    def insert(self, *args) -> "void":
        """
        insert(self, pos, x) -> std::vector< int >::iterator
        insert(self, pos, n, x)
        """
        return _TimeTagger.IntVector_insert(self, *args)


    def reserve(self, n: 'std::vector< int >::size_type') -> "void":
        """reserve(self, n)"""
        return _TimeTagger.IntVector_reserve(self, n)


    def capacity(self) -> "std::vector< int >::size_type":
        """capacity(self) -> std::vector< int >::size_type"""
        return _TimeTagger.IntVector_capacity(self)

    __swig_destroy__ = _TimeTagger.delete_IntVector
    __del__ = lambda self: None
IntVector_swigregister = _TimeTagger.IntVector_swigregister
IntVector_swigregister(IntVector)

class UIntVector(_object):
    """Proxy of C++ std::vector<(unsigned int)> class."""

    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, UIntVector, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, UIntVector, name)
    __repr__ = _swig_repr

    def iterator(self) -> "swig::SwigPyIterator *":
        """iterator(self) -> SwigPyIterator"""
        return _TimeTagger.UIntVector_iterator(self)

    def __iter__(self):
        return self.iterator()

    def __nonzero__(self) -> "bool":
        """__nonzero__(self) -> bool"""
        return _TimeTagger.UIntVector___nonzero__(self)


    def __bool__(self) -> "bool":
        """__bool__(self) -> bool"""
        return _TimeTagger.UIntVector___bool__(self)


    def __len__(self) -> "std::vector< unsigned int >::size_type":
        """__len__(self) -> std::vector< unsigned int >::size_type"""
        return _TimeTagger.UIntVector___len__(self)


    def __getslice__(self, i: 'std::vector< unsigned int >::difference_type', j: 'std::vector< unsigned int >::difference_type') -> "std::vector< unsigned int,std::allocator< unsigned int > > *":
        """__getslice__(self, i, j) -> UIntVector"""
        return _TimeTagger.UIntVector___getslice__(self, i, j)


    def __setslice__(self, *args) -> "void":
        """
        __setslice__(self, i, j)
        __setslice__(self, i, j, v)
        """
        return _TimeTagger.UIntVector___setslice__(self, *args)


    def __delslice__(self, i: 'std::vector< unsigned int >::difference_type', j: 'std::vector< unsigned int >::difference_type') -> "void":
        """__delslice__(self, i, j)"""
        return _TimeTagger.UIntVector___delslice__(self, i, j)


    def __delitem__(self, *args) -> "void":
        """
        __delitem__(self, i)
        __delitem__(self, slice)
        """
        return _TimeTagger.UIntVector___delitem__(self, *args)


    def __getitem__(self, *args) -> "std::vector< unsigned int >::value_type const &":
        """
        __getitem__(self, slice) -> UIntVector
        __getitem__(self, i) -> std::vector< unsigned int >::value_type const &
        """
        return _TimeTagger.UIntVector___getitem__(self, *args)


    def __setitem__(self, *args) -> "void":
        """
        __setitem__(self, slice, v)
        __setitem__(self, slice)
        __setitem__(self, i, x)
        """
        return _TimeTagger.UIntVector___setitem__(self, *args)


    def pop(self) -> "std::vector< unsigned int >::value_type":
        """pop(self) -> std::vector< unsigned int >::value_type"""
        return _TimeTagger.UIntVector_pop(self)


    def append(self, x: 'std::vector< unsigned int >::value_type const &') -> "void":
        """append(self, x)"""
        return _TimeTagger.UIntVector_append(self, x)


    def empty(self) -> "bool":
        """empty(self) -> bool"""
        return _TimeTagger.UIntVector_empty(self)


    def size(self) -> "std::vector< unsigned int >::size_type":
        """size(self) -> std::vector< unsigned int >::size_type"""
        return _TimeTagger.UIntVector_size(self)


    def swap(self, v: 'UIntVector') -> "void":
        """swap(self, v)"""
        return _TimeTagger.UIntVector_swap(self, v)


    def begin(self) -> "std::vector< unsigned int >::iterator":
        """begin(self) -> std::vector< unsigned int >::iterator"""
        return _TimeTagger.UIntVector_begin(self)


    def end(self) -> "std::vector< unsigned int >::iterator":
        """end(self) -> std::vector< unsigned int >::iterator"""
        return _TimeTagger.UIntVector_end(self)


    def rbegin(self) -> "std::vector< unsigned int >::reverse_iterator":
        """rbegin(self) -> std::vector< unsigned int >::reverse_iterator"""
        return _TimeTagger.UIntVector_rbegin(self)


    def rend(self) -> "std::vector< unsigned int >::reverse_iterator":
        """rend(self) -> std::vector< unsigned int >::reverse_iterator"""
        return _TimeTagger.UIntVector_rend(self)


    def clear(self) -> "void":
        """clear(self)"""
        return _TimeTagger.UIntVector_clear(self)


    def get_allocator(self) -> "std::vector< unsigned int >::allocator_type":
        """get_allocator(self) -> std::vector< unsigned int >::allocator_type"""
        return _TimeTagger.UIntVector_get_allocator(self)


    def pop_back(self) -> "void":
        """pop_back(self)"""
        return _TimeTagger.UIntVector_pop_back(self)


    def erase(self, *args) -> "std::vector< unsigned int >::iterator":
        """
        erase(self, pos) -> std::vector< unsigned int >::iterator
        erase(self, first, last) -> std::vector< unsigned int >::iterator
        """
        return _TimeTagger.UIntVector_erase(self, *args)


    def __init__(self, *args):
        """
        __init__(self) -> UIntVector
        __init__(self, arg2) -> UIntVector
        __init__(self, size) -> UIntVector
        __init__(self, size, value) -> UIntVector
        """
        this = _TimeTagger.new_UIntVector(*args)
        try:
            self.this.append(this)
        except __builtin__.Exception:
            self.this = this

    def push_back(self, x: 'std::vector< unsigned int >::value_type const &') -> "void":
        """push_back(self, x)"""
        return _TimeTagger.UIntVector_push_back(self, x)


    def front(self) -> "std::vector< unsigned int >::value_type const &":
        """front(self) -> std::vector< unsigned int >::value_type const &"""
        return _TimeTagger.UIntVector_front(self)


    def back(self) -> "std::vector< unsigned int >::value_type const &":
        """back(self) -> std::vector< unsigned int >::value_type const &"""
        return _TimeTagger.UIntVector_back(self)


    def assign(self, n: 'std::vector< unsigned int >::size_type', x: 'std::vector< unsigned int >::value_type const &') -> "void":
        """assign(self, n, x)"""
        return _TimeTagger.UIntVector_assign(self, n, x)


    def resize(self, *args) -> "void":
        """
        resize(self, new_size)
        resize(self, new_size, x)
        """
        return _TimeTagger.UIntVector_resize(self, *args)


    def insert(self, *args) -> "void":
        """
        insert(self, pos, x) -> std::vector< unsigned int >::iterator
        insert(self, pos, n, x)
        """
        return _TimeTagger.UIntVector_insert(self, *args)


    def reserve(self, n: 'std::vector< unsigned int >::size_type') -> "void":
        """reserve(self, n)"""
        return _TimeTagger.UIntVector_reserve(self, n)


    def capacity(self) -> "std::vector< unsigned int >::size_type":
        """capacity(self) -> std::vector< unsigned int >::size_type"""
        return _TimeTagger.UIntVector_capacity(self)

    __swig_destroy__ = _TimeTagger.delete_UIntVector
    __del__ = lambda self: None
UIntVector_swigregister = _TimeTagger.UIntVector_swigregister
UIntVector_swigregister(UIntVector)

class LongVector(_object):
    """Proxy of C++ std::vector<(long)> class."""

    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, LongVector, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, LongVector, name)
    __repr__ = _swig_repr

    def iterator(self) -> "swig::SwigPyIterator *":
        """iterator(self) -> SwigPyIterator"""
        return _TimeTagger.LongVector_iterator(self)

    def __iter__(self):
        return self.iterator()

    def __nonzero__(self) -> "bool":
        """__nonzero__(self) -> bool"""
        return _TimeTagger.LongVector___nonzero__(self)


    def __bool__(self) -> "bool":
        """__bool__(self) -> bool"""
        return _TimeTagger.LongVector___bool__(self)


    def __len__(self) -> "std::vector< long >::size_type":
        """__len__(self) -> std::vector< long >::size_type"""
        return _TimeTagger.LongVector___len__(self)


    def __getslice__(self, i: 'std::vector< long >::difference_type', j: 'std::vector< long >::difference_type') -> "std::vector< long,std::allocator< long > > *":
        """__getslice__(self, i, j) -> LongVector"""
        return _TimeTagger.LongVector___getslice__(self, i, j)


    def __setslice__(self, *args) -> "void":
        """
        __setslice__(self, i, j)
        __setslice__(self, i, j, v)
        """
        return _TimeTagger.LongVector___setslice__(self, *args)


    def __delslice__(self, i: 'std::vector< long >::difference_type', j: 'std::vector< long >::difference_type') -> "void":
        """__delslice__(self, i, j)"""
        return _TimeTagger.LongVector___delslice__(self, i, j)


    def __delitem__(self, *args) -> "void":
        """
        __delitem__(self, i)
        __delitem__(self, slice)
        """
        return _TimeTagger.LongVector___delitem__(self, *args)


    def __getitem__(self, *args) -> "std::vector< long >::value_type const &":
        """
        __getitem__(self, slice) -> LongVector
        __getitem__(self, i) -> std::vector< long >::value_type const &
        """
        return _TimeTagger.LongVector___getitem__(self, *args)


    def __setitem__(self, *args) -> "void":
        """
        __setitem__(self, slice, v)
        __setitem__(self, slice)
        __setitem__(self, i, x)
        """
        return _TimeTagger.LongVector___setitem__(self, *args)


    def pop(self) -> "std::vector< long >::value_type":
        """pop(self) -> std::vector< long >::value_type"""
        return _TimeTagger.LongVector_pop(self)


    def append(self, x: 'std::vector< long >::value_type const &') -> "void":
        """append(self, x)"""
        return _TimeTagger.LongVector_append(self, x)


    def empty(self) -> "bool":
        """empty(self) -> bool"""
        return _TimeTagger.LongVector_empty(self)


    def size(self) -> "std::vector< long >::size_type":
        """size(self) -> std::vector< long >::size_type"""
        return _TimeTagger.LongVector_size(self)


    def swap(self, v: 'LongVector') -> "void":
        """swap(self, v)"""
        return _TimeTagger.LongVector_swap(self, v)


    def begin(self) -> "std::vector< long >::iterator":
        """begin(self) -> std::vector< long >::iterator"""
        return _TimeTagger.LongVector_begin(self)


    def end(self) -> "std::vector< long >::iterator":
        """end(self) -> std::vector< long >::iterator"""
        return _TimeTagger.LongVector_end(self)


    def rbegin(self) -> "std::vector< long >::reverse_iterator":
        """rbegin(self) -> std::vector< long >::reverse_iterator"""
        return _TimeTagger.LongVector_rbegin(self)


    def rend(self) -> "std::vector< long >::reverse_iterator":
        """rend(self) -> std::vector< long >::reverse_iterator"""
        return _TimeTagger.LongVector_rend(self)


    def clear(self) -> "void":
        """clear(self)"""
        return _TimeTagger.LongVector_clear(self)


    def get_allocator(self) -> "std::vector< long >::allocator_type":
        """get_allocator(self) -> std::vector< long >::allocator_type"""
        return _TimeTagger.LongVector_get_allocator(self)


    def pop_back(self) -> "void":
        """pop_back(self)"""
        return _TimeTagger.LongVector_pop_back(self)


    def erase(self, *args) -> "std::vector< long >::iterator":
        """
        erase(self, pos) -> std::vector< long >::iterator
        erase(self, first, last) -> std::vector< long >::iterator
        """
        return _TimeTagger.LongVector_erase(self, *args)


    def __init__(self, *args):
        """
        __init__(self) -> LongVector
        __init__(self, arg2) -> LongVector
        __init__(self, size) -> LongVector
        __init__(self, size, value) -> LongVector
        """
        this = _TimeTagger.new_LongVector(*args)
        try:
            self.this.append(this)
        except __builtin__.Exception:
            self.this = this

    def push_back(self, x: 'std::vector< long >::value_type const &') -> "void":
        """push_back(self, x)"""
        return _TimeTagger.LongVector_push_back(self, x)


    def front(self) -> "std::vector< long >::value_type const &":
        """front(self) -> std::vector< long >::value_type const &"""
        return _TimeTagger.LongVector_front(self)


    def back(self) -> "std::vector< long >::value_type const &":
        """back(self) -> std::vector< long >::value_type const &"""
        return _TimeTagger.LongVector_back(self)


    def assign(self, n: 'std::vector< long >::size_type', x: 'std::vector< long >::value_type const &') -> "void":
        """assign(self, n, x)"""
        return _TimeTagger.LongVector_assign(self, n, x)


    def resize(self, *args) -> "void":
        """
        resize(self, new_size)
        resize(self, new_size, x)
        """
        return _TimeTagger.LongVector_resize(self, *args)


    def insert(self, *args) -> "void":
        """
        insert(self, pos, x) -> std::vector< long >::iterator
        insert(self, pos, n, x)
        """
        return _TimeTagger.LongVector_insert(self, *args)


    def reserve(self, n: 'std::vector< long >::size_type') -> "void":
        """reserve(self, n)"""
        return _TimeTagger.LongVector_reserve(self, n)


    def capacity(self) -> "std::vector< long >::size_type":
        """capacity(self) -> std::vector< long >::size_type"""
        return _TimeTagger.LongVector_capacity(self)

    __swig_destroy__ = _TimeTagger.delete_LongVector
    __del__ = lambda self: None
LongVector_swigregister = _TimeTagger.LongVector_swigregister
LongVector_swigregister(LongVector)

class ULongVector(_object):
    """Proxy of C++ std::vector<(unsigned long)> class."""

    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, ULongVector, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, ULongVector, name)
    __repr__ = _swig_repr

    def iterator(self) -> "swig::SwigPyIterator *":
        """iterator(self) -> SwigPyIterator"""
        return _TimeTagger.ULongVector_iterator(self)

    def __iter__(self):
        return self.iterator()

    def __nonzero__(self) -> "bool":
        """__nonzero__(self) -> bool"""
        return _TimeTagger.ULongVector___nonzero__(self)


    def __bool__(self) -> "bool":
        """__bool__(self) -> bool"""
        return _TimeTagger.ULongVector___bool__(self)


    def __len__(self) -> "std::vector< unsigned long >::size_type":
        """__len__(self) -> std::vector< unsigned long >::size_type"""
        return _TimeTagger.ULongVector___len__(self)


    def __getslice__(self, i: 'std::vector< unsigned long >::difference_type', j: 'std::vector< unsigned long >::difference_type') -> "std::vector< unsigned long,std::allocator< unsigned long > > *":
        """__getslice__(self, i, j) -> ULongVector"""
        return _TimeTagger.ULongVector___getslice__(self, i, j)


    def __setslice__(self, *args) -> "void":
        """
        __setslice__(self, i, j)
        __setslice__(self, i, j, v)
        """
        return _TimeTagger.ULongVector___setslice__(self, *args)


    def __delslice__(self, i: 'std::vector< unsigned long >::difference_type', j: 'std::vector< unsigned long >::difference_type') -> "void":
        """__delslice__(self, i, j)"""
        return _TimeTagger.ULongVector___delslice__(self, i, j)


    def __delitem__(self, *args) -> "void":
        """
        __delitem__(self, i)
        __delitem__(self, slice)
        """
        return _TimeTagger.ULongVector___delitem__(self, *args)


    def __getitem__(self, *args) -> "std::vector< unsigned long >::value_type const &":
        """
        __getitem__(self, slice) -> ULongVector
        __getitem__(self, i) -> std::vector< unsigned long >::value_type const &
        """
        return _TimeTagger.ULongVector___getitem__(self, *args)


    def __setitem__(self, *args) -> "void":
        """
        __setitem__(self, slice, v)
        __setitem__(self, slice)
        __setitem__(self, i, x)
        """
        return _TimeTagger.ULongVector___setitem__(self, *args)


    def pop(self) -> "std::vector< unsigned long >::value_type":
        """pop(self) -> std::vector< unsigned long >::value_type"""
        return _TimeTagger.ULongVector_pop(self)


    def append(self, x: 'std::vector< unsigned long >::value_type const &') -> "void":
        """append(self, x)"""
        return _TimeTagger.ULongVector_append(self, x)


    def empty(self) -> "bool":
        """empty(self) -> bool"""
        return _TimeTagger.ULongVector_empty(self)


    def size(self) -> "std::vector< unsigned long >::size_type":
        """size(self) -> std::vector< unsigned long >::size_type"""
        return _TimeTagger.ULongVector_size(self)


    def swap(self, v: 'ULongVector') -> "void":
        """swap(self, v)"""
        return _TimeTagger.ULongVector_swap(self, v)


    def begin(self) -> "std::vector< unsigned long >::iterator":
        """begin(self) -> std::vector< unsigned long >::iterator"""
        return _TimeTagger.ULongVector_begin(self)


    def end(self) -> "std::vector< unsigned long >::iterator":
        """end(self) -> std::vector< unsigned long >::iterator"""
        return _TimeTagger.ULongVector_end(self)


    def rbegin(self) -> "std::vector< unsigned long >::reverse_iterator":
        """rbegin(self) -> std::vector< unsigned long >::reverse_iterator"""
        return _TimeTagger.ULongVector_rbegin(self)


    def rend(self) -> "std::vector< unsigned long >::reverse_iterator":
        """rend(self) -> std::vector< unsigned long >::reverse_iterator"""
        return _TimeTagger.ULongVector_rend(self)


    def clear(self) -> "void":
        """clear(self)"""
        return _TimeTagger.ULongVector_clear(self)


    def get_allocator(self) -> "std::vector< unsigned long >::allocator_type":
        """get_allocator(self) -> std::vector< unsigned long >::allocator_type"""
        return _TimeTagger.ULongVector_get_allocator(self)


    def pop_back(self) -> "void":
        """pop_back(self)"""
        return _TimeTagger.ULongVector_pop_back(self)


    def erase(self, *args) -> "std::vector< unsigned long >::iterator":
        """
        erase(self, pos) -> std::vector< unsigned long >::iterator
        erase(self, first, last) -> std::vector< unsigned long >::iterator
        """
        return _TimeTagger.ULongVector_erase(self, *args)


    def __init__(self, *args):
        """
        __init__(self) -> ULongVector
        __init__(self, arg2) -> ULongVector
        __init__(self, size) -> ULongVector
        __init__(self, size, value) -> ULongVector
        """
        this = _TimeTagger.new_ULongVector(*args)
        try:
            self.this.append(this)
        except __builtin__.Exception:
            self.this = this

    def push_back(self, x: 'std::vector< unsigned long >::value_type const &') -> "void":
        """push_back(self, x)"""
        return _TimeTagger.ULongVector_push_back(self, x)


    def front(self) -> "std::vector< unsigned long >::value_type const &":
        """front(self) -> std::vector< unsigned long >::value_type const &"""
        return _TimeTagger.ULongVector_front(self)


    def back(self) -> "std::vector< unsigned long >::value_type const &":
        """back(self) -> std::vector< unsigned long >::value_type const &"""
        return _TimeTagger.ULongVector_back(self)


    def assign(self, n: 'std::vector< unsigned long >::size_type', x: 'std::vector< unsigned long >::value_type const &') -> "void":
        """assign(self, n, x)"""
        return _TimeTagger.ULongVector_assign(self, n, x)


    def resize(self, *args) -> "void":
        """
        resize(self, new_size)
        resize(self, new_size, x)
        """
        return _TimeTagger.ULongVector_resize(self, *args)


    def insert(self, *args) -> "void":
        """
        insert(self, pos, x) -> std::vector< unsigned long >::iterator
        insert(self, pos, n, x)
        """
        return _TimeTagger.ULongVector_insert(self, *args)


    def reserve(self, n: 'std::vector< unsigned long >::size_type') -> "void":
        """reserve(self, n)"""
        return _TimeTagger.ULongVector_reserve(self, n)


    def capacity(self) -> "std::vector< unsigned long >::size_type":
        """capacity(self) -> std::vector< unsigned long >::size_type"""
        return _TimeTagger.ULongVector_capacity(self)

    __swig_destroy__ = _TimeTagger.delete_ULongVector
    __del__ = lambda self: None
ULongVector_swigregister = _TimeTagger.ULongVector_swigregister
ULongVector_swigregister(ULongVector)

class LongLongVector(_object):
    """Proxy of C++ std::vector<(long long)> class."""

    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, LongLongVector, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, LongLongVector, name)
    __repr__ = _swig_repr

    def iterator(self) -> "swig::SwigPyIterator *":
        """iterator(self) -> SwigPyIterator"""
        return _TimeTagger.LongLongVector_iterator(self)

    def __iter__(self):
        return self.iterator()

    def __nonzero__(self) -> "bool":
        """__nonzero__(self) -> bool"""
        return _TimeTagger.LongLongVector___nonzero__(self)


    def __bool__(self) -> "bool":
        """__bool__(self) -> bool"""
        return _TimeTagger.LongLongVector___bool__(self)


    def __len__(self) -> "std::vector< long long >::size_type":
        """__len__(self) -> std::vector< long long >::size_type"""
        return _TimeTagger.LongLongVector___len__(self)


    def __getslice__(self, i: 'std::vector< long long >::difference_type', j: 'std::vector< long long >::difference_type') -> "std::vector< long long,std::allocator< long long > > *":
        """__getslice__(self, i, j) -> LongLongVector"""
        return _TimeTagger.LongLongVector___getslice__(self, i, j)


    def __setslice__(self, *args) -> "void":
        """
        __setslice__(self, i, j)
        __setslice__(self, i, j, v)
        """
        return _TimeTagger.LongLongVector___setslice__(self, *args)


    def __delslice__(self, i: 'std::vector< long long >::difference_type', j: 'std::vector< long long >::difference_type') -> "void":
        """__delslice__(self, i, j)"""
        return _TimeTagger.LongLongVector___delslice__(self, i, j)


    def __delitem__(self, *args) -> "void":
        """
        __delitem__(self, i)
        __delitem__(self, slice)
        """
        return _TimeTagger.LongLongVector___delitem__(self, *args)


    def __getitem__(self, *args) -> "std::vector< long long >::value_type const &":
        """
        __getitem__(self, slice) -> LongLongVector
        __getitem__(self, i) -> std::vector< long long >::value_type const &
        """
        return _TimeTagger.LongLongVector___getitem__(self, *args)


    def __setitem__(self, *args) -> "void":
        """
        __setitem__(self, slice, v)
        __setitem__(self, slice)
        __setitem__(self, i, x)
        """
        return _TimeTagger.LongLongVector___setitem__(self, *args)


    def pop(self) -> "std::vector< long long >::value_type":
        """pop(self) -> std::vector< long long >::value_type"""
        return _TimeTagger.LongLongVector_pop(self)


    def append(self, x: 'std::vector< long long >::value_type const &') -> "void":
        """append(self, x)"""
        return _TimeTagger.LongLongVector_append(self, x)


    def empty(self) -> "bool":
        """empty(self) -> bool"""
        return _TimeTagger.LongLongVector_empty(self)


    def size(self) -> "std::vector< long long >::size_type":
        """size(self) -> std::vector< long long >::size_type"""
        return _TimeTagger.LongLongVector_size(self)


    def swap(self, v: 'LongLongVector') -> "void":
        """swap(self, v)"""
        return _TimeTagger.LongLongVector_swap(self, v)


    def begin(self) -> "std::vector< long long >::iterator":
        """begin(self) -> std::vector< long long >::iterator"""
        return _TimeTagger.LongLongVector_begin(self)


    def end(self) -> "std::vector< long long >::iterator":
        """end(self) -> std::vector< long long >::iterator"""
        return _TimeTagger.LongLongVector_end(self)


    def rbegin(self) -> "std::vector< long long >::reverse_iterator":
        """rbegin(self) -> std::vector< long long >::reverse_iterator"""
        return _TimeTagger.LongLongVector_rbegin(self)


    def rend(self) -> "std::vector< long long >::reverse_iterator":
        """rend(self) -> std::vector< long long >::reverse_iterator"""
        return _TimeTagger.LongLongVector_rend(self)


    def clear(self) -> "void":
        """clear(self)"""
        return _TimeTagger.LongLongVector_clear(self)


    def get_allocator(self) -> "std::vector< long long >::allocator_type":
        """get_allocator(self) -> std::vector< long long >::allocator_type"""
        return _TimeTagger.LongLongVector_get_allocator(self)


    def pop_back(self) -> "void":
        """pop_back(self)"""
        return _TimeTagger.LongLongVector_pop_back(self)


    def erase(self, *args) -> "std::vector< long long >::iterator":
        """
        erase(self, pos) -> std::vector< long long >::iterator
        erase(self, first, last) -> std::vector< long long >::iterator
        """
        return _TimeTagger.LongLongVector_erase(self, *args)


    def __init__(self, *args):
        """
        __init__(self) -> LongLongVector
        __init__(self, arg2) -> LongLongVector
        __init__(self, size) -> LongLongVector
        __init__(self, size, value) -> LongLongVector
        """
        this = _TimeTagger.new_LongLongVector(*args)
        try:
            self.this.append(this)
        except __builtin__.Exception:
            self.this = this

    def push_back(self, x: 'std::vector< long long >::value_type const &') -> "void":
        """push_back(self, x)"""
        return _TimeTagger.LongLongVector_push_back(self, x)


    def front(self) -> "std::vector< long long >::value_type const &":
        """front(self) -> std::vector< long long >::value_type const &"""
        return _TimeTagger.LongLongVector_front(self)


    def back(self) -> "std::vector< long long >::value_type const &":
        """back(self) -> std::vector< long long >::value_type const &"""
        return _TimeTagger.LongLongVector_back(self)


    def assign(self, n: 'std::vector< long long >::size_type', x: 'std::vector< long long >::value_type const &') -> "void":
        """assign(self, n, x)"""
        return _TimeTagger.LongLongVector_assign(self, n, x)


    def resize(self, *args) -> "void":
        """
        resize(self, new_size)
        resize(self, new_size, x)
        """
        return _TimeTagger.LongLongVector_resize(self, *args)


    def insert(self, *args) -> "void":
        """
        insert(self, pos, x) -> std::vector< long long >::iterator
        insert(self, pos, n, x)
        """
        return _TimeTagger.LongLongVector_insert(self, *args)


    def reserve(self, n: 'std::vector< long long >::size_type') -> "void":
        """reserve(self, n)"""
        return _TimeTagger.LongLongVector_reserve(self, n)


    def capacity(self) -> "std::vector< long long >::size_type":
        """capacity(self) -> std::vector< long long >::size_type"""
        return _TimeTagger.LongLongVector_capacity(self)

    __swig_destroy__ = _TimeTagger.delete_LongLongVector
    __del__ = lambda self: None
LongLongVector_swigregister = _TimeTagger.LongLongVector_swigregister
LongLongVector_swigregister(LongLongVector)

class ULongLongVector(_object):
    """Proxy of C++ std::vector<(unsigned long long)> class."""

    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, ULongLongVector, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, ULongLongVector, name)
    __repr__ = _swig_repr

    def iterator(self) -> "swig::SwigPyIterator *":
        """iterator(self) -> SwigPyIterator"""
        return _TimeTagger.ULongLongVector_iterator(self)

    def __iter__(self):
        return self.iterator()

    def __nonzero__(self) -> "bool":
        """__nonzero__(self) -> bool"""
        return _TimeTagger.ULongLongVector___nonzero__(self)


    def __bool__(self) -> "bool":
        """__bool__(self) -> bool"""
        return _TimeTagger.ULongLongVector___bool__(self)


    def __len__(self) -> "std::vector< unsigned long long >::size_type":
        """__len__(self) -> std::vector< unsigned long long >::size_type"""
        return _TimeTagger.ULongLongVector___len__(self)


    def __getslice__(self, i: 'std::vector< unsigned long long >::difference_type', j: 'std::vector< unsigned long long >::difference_type') -> "std::vector< unsigned long long,std::allocator< unsigned long long > > *":
        """__getslice__(self, i, j) -> ULongLongVector"""
        return _TimeTagger.ULongLongVector___getslice__(self, i, j)


    def __setslice__(self, *args) -> "void":
        """
        __setslice__(self, i, j)
        __setslice__(self, i, j, v)
        """
        return _TimeTagger.ULongLongVector___setslice__(self, *args)


    def __delslice__(self, i: 'std::vector< unsigned long long >::difference_type', j: 'std::vector< unsigned long long >::difference_type') -> "void":
        """__delslice__(self, i, j)"""
        return _TimeTagger.ULongLongVector___delslice__(self, i, j)


    def __delitem__(self, *args) -> "void":
        """
        __delitem__(self, i)
        __delitem__(self, slice)
        """
        return _TimeTagger.ULongLongVector___delitem__(self, *args)


    def __getitem__(self, *args) -> "std::vector< unsigned long long >::value_type const &":
        """
        __getitem__(self, slice) -> ULongLongVector
        __getitem__(self, i) -> std::vector< unsigned long long >::value_type const &
        """
        return _TimeTagger.ULongLongVector___getitem__(self, *args)


    def __setitem__(self, *args) -> "void":
        """
        __setitem__(self, slice, v)
        __setitem__(self, slice)
        __setitem__(self, i, x)
        """
        return _TimeTagger.ULongLongVector___setitem__(self, *args)


    def pop(self) -> "std::vector< unsigned long long >::value_type":
        """pop(self) -> std::vector< unsigned long long >::value_type"""
        return _TimeTagger.ULongLongVector_pop(self)


    def append(self, x: 'std::vector< unsigned long long >::value_type const &') -> "void":
        """append(self, x)"""
        return _TimeTagger.ULongLongVector_append(self, x)


    def empty(self) -> "bool":
        """empty(self) -> bool"""
        return _TimeTagger.ULongLongVector_empty(self)


    def size(self) -> "std::vector< unsigned long long >::size_type":
        """size(self) -> std::vector< unsigned long long >::size_type"""
        return _TimeTagger.ULongLongVector_size(self)


    def swap(self, v: 'ULongLongVector') -> "void":
        """swap(self, v)"""
        return _TimeTagger.ULongLongVector_swap(self, v)


    def begin(self) -> "std::vector< unsigned long long >::iterator":
        """begin(self) -> std::vector< unsigned long long >::iterator"""
        return _TimeTagger.ULongLongVector_begin(self)


    def end(self) -> "std::vector< unsigned long long >::iterator":
        """end(self) -> std::vector< unsigned long long >::iterator"""
        return _TimeTagger.ULongLongVector_end(self)


    def rbegin(self) -> "std::vector< unsigned long long >::reverse_iterator":
        """rbegin(self) -> std::vector< unsigned long long >::reverse_iterator"""
        return _TimeTagger.ULongLongVector_rbegin(self)


    def rend(self) -> "std::vector< unsigned long long >::reverse_iterator":
        """rend(self) -> std::vector< unsigned long long >::reverse_iterator"""
        return _TimeTagger.ULongLongVector_rend(self)


    def clear(self) -> "void":
        """clear(self)"""
        return _TimeTagger.ULongLongVector_clear(self)


    def get_allocator(self) -> "std::vector< unsigned long long >::allocator_type":
        """get_allocator(self) -> std::vector< unsigned long long >::allocator_type"""
        return _TimeTagger.ULongLongVector_get_allocator(self)


    def pop_back(self) -> "void":
        """pop_back(self)"""
        return _TimeTagger.ULongLongVector_pop_back(self)


    def erase(self, *args) -> "std::vector< unsigned long long >::iterator":
        """
        erase(self, pos) -> std::vector< unsigned long long >::iterator
        erase(self, first, last) -> std::vector< unsigned long long >::iterator
        """
        return _TimeTagger.ULongLongVector_erase(self, *args)


    def __init__(self, *args):
        """
        __init__(self) -> ULongLongVector
        __init__(self, arg2) -> ULongLongVector
        __init__(self, size) -> ULongLongVector
        __init__(self, size, value) -> ULongLongVector
        """
        this = _TimeTagger.new_ULongLongVector(*args)
        try:
            self.this.append(this)
        except __builtin__.Exception:
            self.this = this

    def push_back(self, x: 'std::vector< unsigned long long >::value_type const &') -> "void":
        """push_back(self, x)"""
        return _TimeTagger.ULongLongVector_push_back(self, x)


    def front(self) -> "std::vector< unsigned long long >::value_type const &":
        """front(self) -> std::vector< unsigned long long >::value_type const &"""
        return _TimeTagger.ULongLongVector_front(self)


    def back(self) -> "std::vector< unsigned long long >::value_type const &":
        """back(self) -> std::vector< unsigned long long >::value_type const &"""
        return _TimeTagger.ULongLongVector_back(self)


    def assign(self, n: 'std::vector< unsigned long long >::size_type', x: 'std::vector< unsigned long long >::value_type const &') -> "void":
        """assign(self, n, x)"""
        return _TimeTagger.ULongLongVector_assign(self, n, x)


    def resize(self, *args) -> "void":
        """
        resize(self, new_size)
        resize(self, new_size, x)
        """
        return _TimeTagger.ULongLongVector_resize(self, *args)


    def insert(self, *args) -> "void":
        """
        insert(self, pos, x) -> std::vector< unsigned long long >::iterator
        insert(self, pos, n, x)
        """
        return _TimeTagger.ULongLongVector_insert(self, *args)


    def reserve(self, n: 'std::vector< unsigned long long >::size_type') -> "void":
        """reserve(self, n)"""
        return _TimeTagger.ULongLongVector_reserve(self, n)


    def capacity(self) -> "std::vector< unsigned long long >::size_type":
        """capacity(self) -> std::vector< unsigned long long >::size_type"""
        return _TimeTagger.ULongLongVector_capacity(self)

    __swig_destroy__ = _TimeTagger.delete_ULongLongVector
    __del__ = lambda self: None
ULongLongVector_swigregister = _TimeTagger.ULongLongVector_swigregister
ULongLongVector_swigregister(ULongLongVector)

class FloatVector(_object):
    """Proxy of C++ std::vector<(float)> class."""

    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, FloatVector, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, FloatVector, name)
    __repr__ = _swig_repr

    def iterator(self) -> "swig::SwigPyIterator *":
        """iterator(self) -> SwigPyIterator"""
        return _TimeTagger.FloatVector_iterator(self)

    def __iter__(self):
        return self.iterator()

    def __nonzero__(self) -> "bool":
        """__nonzero__(self) -> bool"""
        return _TimeTagger.FloatVector___nonzero__(self)


    def __bool__(self) -> "bool":
        """__bool__(self) -> bool"""
        return _TimeTagger.FloatVector___bool__(self)


    def __len__(self) -> "std::vector< float >::size_type":
        """__len__(self) -> std::vector< float >::size_type"""
        return _TimeTagger.FloatVector___len__(self)


    def __getslice__(self, i: 'std::vector< float >::difference_type', j: 'std::vector< float >::difference_type') -> "std::vector< float,std::allocator< float > > *":
        """__getslice__(self, i, j) -> FloatVector"""
        return _TimeTagger.FloatVector___getslice__(self, i, j)


    def __setslice__(self, *args) -> "void":
        """
        __setslice__(self, i, j)
        __setslice__(self, i, j, v)
        """
        return _TimeTagger.FloatVector___setslice__(self, *args)


    def __delslice__(self, i: 'std::vector< float >::difference_type', j: 'std::vector< float >::difference_type') -> "void":
        """__delslice__(self, i, j)"""
        return _TimeTagger.FloatVector___delslice__(self, i, j)


    def __delitem__(self, *args) -> "void":
        """
        __delitem__(self, i)
        __delitem__(self, slice)
        """
        return _TimeTagger.FloatVector___delitem__(self, *args)


    def __getitem__(self, *args) -> "std::vector< float >::value_type const &":
        """
        __getitem__(self, slice) -> FloatVector
        __getitem__(self, i) -> std::vector< float >::value_type const &
        """
        return _TimeTagger.FloatVector___getitem__(self, *args)


    def __setitem__(self, *args) -> "void":
        """
        __setitem__(self, slice, v)
        __setitem__(self, slice)
        __setitem__(self, i, x)
        """
        return _TimeTagger.FloatVector___setitem__(self, *args)


    def pop(self) -> "std::vector< float >::value_type":
        """pop(self) -> std::vector< float >::value_type"""
        return _TimeTagger.FloatVector_pop(self)


    def append(self, x: 'std::vector< float >::value_type const &') -> "void":
        """append(self, x)"""
        return _TimeTagger.FloatVector_append(self, x)


    def empty(self) -> "bool":
        """empty(self) -> bool"""
        return _TimeTagger.FloatVector_empty(self)


    def size(self) -> "std::vector< float >::size_type":
        """size(self) -> std::vector< float >::size_type"""
        return _TimeTagger.FloatVector_size(self)


    def swap(self, v: 'FloatVector') -> "void":
        """swap(self, v)"""
        return _TimeTagger.FloatVector_swap(self, v)


    def begin(self) -> "std::vector< float >::iterator":
        """begin(self) -> std::vector< float >::iterator"""
        return _TimeTagger.FloatVector_begin(self)


    def end(self) -> "std::vector< float >::iterator":
        """end(self) -> std::vector< float >::iterator"""
        return _TimeTagger.FloatVector_end(self)


    def rbegin(self) -> "std::vector< float >::reverse_iterator":
        """rbegin(self) -> std::vector< float >::reverse_iterator"""
        return _TimeTagger.FloatVector_rbegin(self)


    def rend(self) -> "std::vector< float >::reverse_iterator":
        """rend(self) -> std::vector< float >::reverse_iterator"""
        return _TimeTagger.FloatVector_rend(self)


    def clear(self) -> "void":
        """clear(self)"""
        return _TimeTagger.FloatVector_clear(self)


    def get_allocator(self) -> "std::vector< float >::allocator_type":
        """get_allocator(self) -> std::vector< float >::allocator_type"""
        return _TimeTagger.FloatVector_get_allocator(self)


    def pop_back(self) -> "void":
        """pop_back(self)"""
        return _TimeTagger.FloatVector_pop_back(self)


    def erase(self, *args) -> "std::vector< float >::iterator":
        """
        erase(self, pos) -> std::vector< float >::iterator
        erase(self, first, last) -> std::vector< float >::iterator
        """
        return _TimeTagger.FloatVector_erase(self, *args)


    def __init__(self, *args):
        """
        __init__(self) -> FloatVector
        __init__(self, arg2) -> FloatVector
        __init__(self, size) -> FloatVector
        __init__(self, size, value) -> FloatVector
        """
        this = _TimeTagger.new_FloatVector(*args)
        try:
            self.this.append(this)
        except __builtin__.Exception:
            self.this = this

    def push_back(self, x: 'std::vector< float >::value_type const &') -> "void":
        """push_back(self, x)"""
        return _TimeTagger.FloatVector_push_back(self, x)


    def front(self) -> "std::vector< float >::value_type const &":
        """front(self) -> std::vector< float >::value_type const &"""
        return _TimeTagger.FloatVector_front(self)


    def back(self) -> "std::vector< float >::value_type const &":
        """back(self) -> std::vector< float >::value_type const &"""
        return _TimeTagger.FloatVector_back(self)


    def assign(self, n: 'std::vector< float >::size_type', x: 'std::vector< float >::value_type const &') -> "void":
        """assign(self, n, x)"""
        return _TimeTagger.FloatVector_assign(self, n, x)


    def resize(self, *args) -> "void":
        """
        resize(self, new_size)
        resize(self, new_size, x)
        """
        return _TimeTagger.FloatVector_resize(self, *args)


    def insert(self, *args) -> "void":
        """
        insert(self, pos, x) -> std::vector< float >::iterator
        insert(self, pos, n, x)
        """
        return _TimeTagger.FloatVector_insert(self, *args)


    def reserve(self, n: 'std::vector< float >::size_type') -> "void":
        """reserve(self, n)"""
        return _TimeTagger.FloatVector_reserve(self, n)


    def capacity(self) -> "std::vector< float >::size_type":
        """capacity(self) -> std::vector< float >::size_type"""
        return _TimeTagger.FloatVector_capacity(self)

    __swig_destroy__ = _TimeTagger.delete_FloatVector
    __del__ = lambda self: None
FloatVector_swigregister = _TimeTagger.FloatVector_swigregister
FloatVector_swigregister(FloatVector)

class DoubleVector(_object):
    """Proxy of C++ std::vector<(double)> class."""

    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, DoubleVector, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, DoubleVector, name)
    __repr__ = _swig_repr

    def iterator(self) -> "swig::SwigPyIterator *":
        """iterator(self) -> SwigPyIterator"""
        return _TimeTagger.DoubleVector_iterator(self)

    def __iter__(self):
        return self.iterator()

    def __nonzero__(self) -> "bool":
        """__nonzero__(self) -> bool"""
        return _TimeTagger.DoubleVector___nonzero__(self)


    def __bool__(self) -> "bool":
        """__bool__(self) -> bool"""
        return _TimeTagger.DoubleVector___bool__(self)


    def __len__(self) -> "std::vector< double >::size_type":
        """__len__(self) -> std::vector< double >::size_type"""
        return _TimeTagger.DoubleVector___len__(self)


    def __getslice__(self, i: 'std::vector< double >::difference_type', j: 'std::vector< double >::difference_type') -> "std::vector< double,std::allocator< double > > *":
        """__getslice__(self, i, j) -> DoubleVector"""
        return _TimeTagger.DoubleVector___getslice__(self, i, j)


    def __setslice__(self, *args) -> "void":
        """
        __setslice__(self, i, j)
        __setslice__(self, i, j, v)
        """
        return _TimeTagger.DoubleVector___setslice__(self, *args)


    def __delslice__(self, i: 'std::vector< double >::difference_type', j: 'std::vector< double >::difference_type') -> "void":
        """__delslice__(self, i, j)"""
        return _TimeTagger.DoubleVector___delslice__(self, i, j)


    def __delitem__(self, *args) -> "void":
        """
        __delitem__(self, i)
        __delitem__(self, slice)
        """
        return _TimeTagger.DoubleVector___delitem__(self, *args)


    def __getitem__(self, *args) -> "std::vector< double >::value_type const &":
        """
        __getitem__(self, slice) -> DoubleVector
        __getitem__(self, i) -> std::vector< double >::value_type const &
        """
        return _TimeTagger.DoubleVector___getitem__(self, *args)


    def __setitem__(self, *args) -> "void":
        """
        __setitem__(self, slice, v)
        __setitem__(self, slice)
        __setitem__(self, i, x)
        """
        return _TimeTagger.DoubleVector___setitem__(self, *args)


    def pop(self) -> "std::vector< double >::value_type":
        """pop(self) -> std::vector< double >::value_type"""
        return _TimeTagger.DoubleVector_pop(self)


    def append(self, x: 'std::vector< double >::value_type const &') -> "void":
        """append(self, x)"""
        return _TimeTagger.DoubleVector_append(self, x)


    def empty(self) -> "bool":
        """empty(self) -> bool"""
        return _TimeTagger.DoubleVector_empty(self)


    def size(self) -> "std::vector< double >::size_type":
        """size(self) -> std::vector< double >::size_type"""
        return _TimeTagger.DoubleVector_size(self)


    def swap(self, v: 'DoubleVector') -> "void":
        """swap(self, v)"""
        return _TimeTagger.DoubleVector_swap(self, v)


    def begin(self) -> "std::vector< double >::iterator":
        """begin(self) -> std::vector< double >::iterator"""
        return _TimeTagger.DoubleVector_begin(self)


    def end(self) -> "std::vector< double >::iterator":
        """end(self) -> std::vector< double >::iterator"""
        return _TimeTagger.DoubleVector_end(self)


    def rbegin(self) -> "std::vector< double >::reverse_iterator":
        """rbegin(self) -> std::vector< double >::reverse_iterator"""
        return _TimeTagger.DoubleVector_rbegin(self)


    def rend(self) -> "std::vector< double >::reverse_iterator":
        """rend(self) -> std::vector< double >::reverse_iterator"""
        return _TimeTagger.DoubleVector_rend(self)


    def clear(self) -> "void":
        """clear(self)"""
        return _TimeTagger.DoubleVector_clear(self)


    def get_allocator(self) -> "std::vector< double >::allocator_type":
        """get_allocator(self) -> std::vector< double >::allocator_type"""
        return _TimeTagger.DoubleVector_get_allocator(self)


    def pop_back(self) -> "void":
        """pop_back(self)"""
        return _TimeTagger.DoubleVector_pop_back(self)


    def erase(self, *args) -> "std::vector< double >::iterator":
        """
        erase(self, pos) -> std::vector< double >::iterator
        erase(self, first, last) -> std::vector< double >::iterator
        """
        return _TimeTagger.DoubleVector_erase(self, *args)


    def __init__(self, *args):
        """
        __init__(self) -> DoubleVector
        __init__(self, arg2) -> DoubleVector
        __init__(self, size) -> DoubleVector
        __init__(self, size, value) -> DoubleVector
        """
        this = _TimeTagger.new_DoubleVector(*args)
        try:
            self.this.append(this)
        except __builtin__.Exception:
            self.this = this

    def push_back(self, x: 'std::vector< double >::value_type const &') -> "void":
        """push_back(self, x)"""
        return _TimeTagger.DoubleVector_push_back(self, x)


    def front(self) -> "std::vector< double >::value_type const &":
        """front(self) -> std::vector< double >::value_type const &"""
        return _TimeTagger.DoubleVector_front(self)


    def back(self) -> "std::vector< double >::value_type const &":
        """back(self) -> std::vector< double >::value_type const &"""
        return _TimeTagger.DoubleVector_back(self)


    def assign(self, n: 'std::vector< double >::size_type', x: 'std::vector< double >::value_type const &') -> "void":
        """assign(self, n, x)"""
        return _TimeTagger.DoubleVector_assign(self, n, x)


    def resize(self, *args) -> "void":
        """
        resize(self, new_size)
        resize(self, new_size, x)
        """
        return _TimeTagger.DoubleVector_resize(self, *args)


    def insert(self, *args) -> "void":
        """
        insert(self, pos, x) -> std::vector< double >::iterator
        insert(self, pos, n, x)
        """
        return _TimeTagger.DoubleVector_insert(self, *args)


    def reserve(self, n: 'std::vector< double >::size_type') -> "void":
        """reserve(self, n)"""
        return _TimeTagger.DoubleVector_reserve(self, n)


    def capacity(self) -> "std::vector< double >::size_type":
        """capacity(self) -> std::vector< double >::size_type"""
        return _TimeTagger.DoubleVector_capacity(self)

    __swig_destroy__ = _TimeTagger.delete_DoubleVector
    __del__ = lambda self: None
DoubleVector_swigregister = _TimeTagger.DoubleVector_swigregister
DoubleVector_swigregister(DoubleVector)

class StringVector(_object):
    """Proxy of C++ std::vector<(std::string)> class."""

    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, StringVector, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, StringVector, name)
    __repr__ = _swig_repr

    def iterator(self) -> "swig::SwigPyIterator *":
        """iterator(self) -> SwigPyIterator"""
        return _TimeTagger.StringVector_iterator(self)

    def __iter__(self):
        return self.iterator()

    def __nonzero__(self) -> "bool":
        """__nonzero__(self) -> bool"""
        return _TimeTagger.StringVector___nonzero__(self)


    def __bool__(self) -> "bool":
        """__bool__(self) -> bool"""
        return _TimeTagger.StringVector___bool__(self)


    def __len__(self) -> "std::vector< std::string >::size_type":
        """__len__(self) -> std::vector< std::string >::size_type"""
        return _TimeTagger.StringVector___len__(self)


    def __getslice__(self, i: 'std::vector< std::string >::difference_type', j: 'std::vector< std::string >::difference_type') -> "std::vector< std::string,std::allocator< std::string > > *":
        """__getslice__(self, i, j) -> StringVector"""
        return _TimeTagger.StringVector___getslice__(self, i, j)


    def __setslice__(self, *args) -> "void":
        """
        __setslice__(self, i, j)
        __setslice__(self, i, j, v)
        """
        return _TimeTagger.StringVector___setslice__(self, *args)


    def __delslice__(self, i: 'std::vector< std::string >::difference_type', j: 'std::vector< std::string >::difference_type') -> "void":
        """__delslice__(self, i, j)"""
        return _TimeTagger.StringVector___delslice__(self, i, j)


    def __delitem__(self, *args) -> "void":
        """
        __delitem__(self, i)
        __delitem__(self, slice)
        """
        return _TimeTagger.StringVector___delitem__(self, *args)


    def __getitem__(self, *args) -> "std::vector< std::string >::value_type const &":
        """
        __getitem__(self, slice) -> StringVector
        __getitem__(self, i) -> std::vector< std::string >::value_type const &
        """
        return _TimeTagger.StringVector___getitem__(self, *args)


    def __setitem__(self, *args) -> "void":
        """
        __setitem__(self, slice, v)
        __setitem__(self, slice)
        __setitem__(self, i, x)
        """
        return _TimeTagger.StringVector___setitem__(self, *args)


    def pop(self) -> "std::vector< std::string >::value_type":
        """pop(self) -> std::vector< std::string >::value_type"""
        return _TimeTagger.StringVector_pop(self)


    def append(self, x: 'std::vector< std::string >::value_type const &') -> "void":
        """append(self, x)"""
        return _TimeTagger.StringVector_append(self, x)


    def empty(self) -> "bool":
        """empty(self) -> bool"""
        return _TimeTagger.StringVector_empty(self)


    def size(self) -> "std::vector< std::string >::size_type":
        """size(self) -> std::vector< std::string >::size_type"""
        return _TimeTagger.StringVector_size(self)


    def swap(self, v: 'StringVector') -> "void":
        """swap(self, v)"""
        return _TimeTagger.StringVector_swap(self, v)


    def begin(self) -> "std::vector< std::string >::iterator":
        """begin(self) -> std::vector< std::string >::iterator"""
        return _TimeTagger.StringVector_begin(self)


    def end(self) -> "std::vector< std::string >::iterator":
        """end(self) -> std::vector< std::string >::iterator"""
        return _TimeTagger.StringVector_end(self)


    def rbegin(self) -> "std::vector< std::string >::reverse_iterator":
        """rbegin(self) -> std::vector< std::string >::reverse_iterator"""
        return _TimeTagger.StringVector_rbegin(self)


    def rend(self) -> "std::vector< std::string >::reverse_iterator":
        """rend(self) -> std::vector< std::string >::reverse_iterator"""
        return _TimeTagger.StringVector_rend(self)


    def clear(self) -> "void":
        """clear(self)"""
        return _TimeTagger.StringVector_clear(self)


    def get_allocator(self) -> "std::vector< std::string >::allocator_type":
        """get_allocator(self) -> std::vector< std::string >::allocator_type"""
        return _TimeTagger.StringVector_get_allocator(self)


    def pop_back(self) -> "void":
        """pop_back(self)"""
        return _TimeTagger.StringVector_pop_back(self)


    def erase(self, *args) -> "std::vector< std::string >::iterator":
        """
        erase(self, pos) -> std::vector< std::string >::iterator
        erase(self, first, last) -> std::vector< std::string >::iterator
        """
        return _TimeTagger.StringVector_erase(self, *args)


    def __init__(self, *args):
        """
        __init__(self) -> StringVector
        __init__(self, arg2) -> StringVector
        __init__(self, size) -> StringVector
        __init__(self, size, value) -> StringVector
        """
        this = _TimeTagger.new_StringVector(*args)
        try:
            self.this.append(this)
        except __builtin__.Exception:
            self.this = this

    def push_back(self, x: 'std::vector< std::string >::value_type const &') -> "void":
        """push_back(self, x)"""
        return _TimeTagger.StringVector_push_back(self, x)


    def front(self) -> "std::vector< std::string >::value_type const &":
        """front(self) -> std::vector< std::string >::value_type const &"""
        return _TimeTagger.StringVector_front(self)


    def back(self) -> "std::vector< std::string >::value_type const &":
        """back(self) -> std::vector< std::string >::value_type const &"""
        return _TimeTagger.StringVector_back(self)


    def assign(self, n: 'std::vector< std::string >::size_type', x: 'std::vector< std::string >::value_type const &') -> "void":
        """assign(self, n, x)"""
        return _TimeTagger.StringVector_assign(self, n, x)


    def resize(self, *args) -> "void":
        """
        resize(self, new_size)
        resize(self, new_size, x)
        """
        return _TimeTagger.StringVector_resize(self, *args)


    def insert(self, *args) -> "void":
        """
        insert(self, pos, x) -> std::vector< std::string >::iterator
        insert(self, pos, n, x)
        """
        return _TimeTagger.StringVector_insert(self, *args)


    def reserve(self, n: 'std::vector< std::string >::size_type') -> "void":
        """reserve(self, n)"""
        return _TimeTagger.StringVector_reserve(self, n)


    def capacity(self) -> "std::vector< std::string >::size_type":
        """capacity(self) -> std::vector< std::string >::size_type"""
        return _TimeTagger.StringVector_capacity(self)

    __swig_destroy__ = _TimeTagger.delete_StringVector
    __del__ = lambda self: None
StringVector_swigregister = _TimeTagger.StringVector_swigregister
StringVector_swigregister(StringVector)

class StringList(_object):
    """Proxy of C++ std::list<(std::string)> class."""

    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, StringList, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, StringList, name)
    __repr__ = _swig_repr

    def iterator(self) -> "swig::SwigPyIterator *":
        """iterator(self) -> SwigPyIterator"""
        return _TimeTagger.StringList_iterator(self)

    def __iter__(self):
        return self.iterator()

    def __nonzero__(self) -> "bool":
        """__nonzero__(self) -> bool"""
        return _TimeTagger.StringList___nonzero__(self)


    def __bool__(self) -> "bool":
        """__bool__(self) -> bool"""
        return _TimeTagger.StringList___bool__(self)


    def __len__(self) -> "std::list< std::string >::size_type":
        """__len__(self) -> std::list< std::string >::size_type"""
        return _TimeTagger.StringList___len__(self)


    def __getslice__(self, i: 'std::list< std::string >::difference_type', j: 'std::list< std::string >::difference_type') -> "std::list< std::string,std::allocator< std::string > > *":
        """__getslice__(self, i, j) -> StringList"""
        return _TimeTagger.StringList___getslice__(self, i, j)


    def __setslice__(self, *args) -> "void":
        """
        __setslice__(self, i, j)
        __setslice__(self, i, j, v)
        """
        return _TimeTagger.StringList___setslice__(self, *args)


    def __delslice__(self, i: 'std::list< std::string >::difference_type', j: 'std::list< std::string >::difference_type') -> "void":
        """__delslice__(self, i, j)"""
        return _TimeTagger.StringList___delslice__(self, i, j)


    def __delitem__(self, *args) -> "void":
        """
        __delitem__(self, i)
        __delitem__(self, slice)
        """
        return _TimeTagger.StringList___delitem__(self, *args)


    def __getitem__(self, *args) -> "std::list< std::string >::value_type const &":
        """
        __getitem__(self, slice) -> StringList
        __getitem__(self, i) -> std::list< std::string >::value_type const &
        """
        return _TimeTagger.StringList___getitem__(self, *args)


    def __setitem__(self, *args) -> "void":
        """
        __setitem__(self, slice, v)
        __setitem__(self, slice)
        __setitem__(self, i, x)
        """
        return _TimeTagger.StringList___setitem__(self, *args)


    def pop(self) -> "std::list< std::string >::value_type":
        """pop(self) -> std::list< std::string >::value_type"""
        return _TimeTagger.StringList_pop(self)


    def append(self, x: 'std::list< std::string >::value_type const &') -> "void":
        """append(self, x)"""
        return _TimeTagger.StringList_append(self, x)


    def empty(self) -> "bool":
        """empty(self) -> bool"""
        return _TimeTagger.StringList_empty(self)


    def size(self) -> "std::list< std::string >::size_type":
        """size(self) -> std::list< std::string >::size_type"""
        return _TimeTagger.StringList_size(self)


    def swap(self, v: 'StringList') -> "void":
        """swap(self, v)"""
        return _TimeTagger.StringList_swap(self, v)


    def begin(self) -> "std::list< std::string >::iterator":
        """begin(self) -> std::list< std::string >::iterator"""
        return _TimeTagger.StringList_begin(self)


    def end(self) -> "std::list< std::string >::iterator":
        """end(self) -> std::list< std::string >::iterator"""
        return _TimeTagger.StringList_end(self)


    def rbegin(self) -> "std::list< std::string >::reverse_iterator":
        """rbegin(self) -> std::list< std::string >::reverse_iterator"""
        return _TimeTagger.StringList_rbegin(self)


    def rend(self) -> "std::list< std::string >::reverse_iterator":
        """rend(self) -> std::list< std::string >::reverse_iterator"""
        return _TimeTagger.StringList_rend(self)


    def clear(self) -> "void":
        """clear(self)"""
        return _TimeTagger.StringList_clear(self)


    def get_allocator(self) -> "std::list< std::string >::allocator_type":
        """get_allocator(self) -> std::list< std::string >::allocator_type"""
        return _TimeTagger.StringList_get_allocator(self)


    def pop_back(self) -> "void":
        """pop_back(self)"""
        return _TimeTagger.StringList_pop_back(self)


    def erase(self, *args) -> "std::list< std::string >::iterator":
        """
        erase(self, pos) -> std::list< std::string >::iterator
        erase(self, first, last) -> std::list< std::string >::iterator
        """
        return _TimeTagger.StringList_erase(self, *args)


    def __init__(self, *args):
        """
        __init__(self) -> StringList
        __init__(self, arg2) -> StringList
        __init__(self, size) -> StringList
        __init__(self, size, value) -> StringList
        """
        this = _TimeTagger.new_StringList(*args)
        try:
            self.this.append(this)
        except __builtin__.Exception:
            self.this = this

    def push_back(self, x: 'std::list< std::string >::value_type const &') -> "void":
        """push_back(self, x)"""
        return _TimeTagger.StringList_push_back(self, x)


    def front(self) -> "std::list< std::string >::value_type const &":
        """front(self) -> std::list< std::string >::value_type const &"""
        return _TimeTagger.StringList_front(self)


    def back(self) -> "std::list< std::string >::value_type const &":
        """back(self) -> std::list< std::string >::value_type const &"""
        return _TimeTagger.StringList_back(self)


    def assign(self, n: 'std::list< std::string >::size_type', x: 'std::list< std::string >::value_type const &') -> "void":
        """assign(self, n, x)"""
        return _TimeTagger.StringList_assign(self, n, x)


    def resize(self, *args) -> "void":
        """
        resize(self, new_size)
        resize(self, new_size, x)
        """
        return _TimeTagger.StringList_resize(self, *args)


    def insert(self, *args) -> "void":
        """
        insert(self, pos, x) -> std::list< std::string >::iterator
        insert(self, pos, n, x)
        """
        return _TimeTagger.StringList_insert(self, *args)


    def pop_front(self) -> "void":
        """pop_front(self)"""
        return _TimeTagger.StringList_pop_front(self)


    def push_front(self, x: 'std::list< std::string >::value_type const &') -> "void":
        """push_front(self, x)"""
        return _TimeTagger.StringList_push_front(self, x)


    def reverse(self) -> "void":
        """reverse(self)"""
        return _TimeTagger.StringList_reverse(self)

    __swig_destroy__ = _TimeTagger.delete_StringList
    __del__ = lambda self: None
StringList_swigregister = _TimeTagger.StringList_swigregister
StringList_swigregister(StringList)

class EventVector(_object):
    """Proxy of C++ std::vector<(Event)> class."""

    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, EventVector, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, EventVector, name)
    __repr__ = _swig_repr

    def iterator(self) -> "swig::SwigPyIterator *":
        """iterator(self) -> SwigPyIterator"""
        return _TimeTagger.EventVector_iterator(self)

    def __iter__(self):
        return self.iterator()

    def __nonzero__(self) -> "bool":
        """__nonzero__(self) -> bool"""
        return _TimeTagger.EventVector___nonzero__(self)


    def __bool__(self) -> "bool":
        """__bool__(self) -> bool"""
        return _TimeTagger.EventVector___bool__(self)


    def __len__(self) -> "std::vector< Event >::size_type":
        """__len__(self) -> std::vector< Event >::size_type"""
        return _TimeTagger.EventVector___len__(self)


    def __getslice__(self, i: 'std::vector< Event >::difference_type', j: 'std::vector< Event >::difference_type') -> "std::vector< Event,std::allocator< Event > > *":
        """__getslice__(self, i, j) -> EventVector"""
        return _TimeTagger.EventVector___getslice__(self, i, j)


    def __setslice__(self, *args) -> "void":
        """
        __setslice__(self, i, j)
        __setslice__(self, i, j, v)
        """
        return _TimeTagger.EventVector___setslice__(self, *args)


    def __delslice__(self, i: 'std::vector< Event >::difference_type', j: 'std::vector< Event >::difference_type') -> "void":
        """__delslice__(self, i, j)"""
        return _TimeTagger.EventVector___delslice__(self, i, j)


    def __delitem__(self, *args) -> "void":
        """
        __delitem__(self, i)
        __delitem__(self, slice)
        """
        return _TimeTagger.EventVector___delitem__(self, *args)


    def __getitem__(self, *args) -> "std::vector< Event >::value_type const &":
        """
        __getitem__(self, slice) -> EventVector
        __getitem__(self, i) -> Event
        """
        return _TimeTagger.EventVector___getitem__(self, *args)


    def __setitem__(self, *args) -> "void":
        """
        __setitem__(self, slice, v)
        __setitem__(self, slice)
        __setitem__(self, i, x)
        """
        return _TimeTagger.EventVector___setitem__(self, *args)


    def pop(self) -> "std::vector< Event >::value_type":
        """pop(self) -> Event"""
        return _TimeTagger.EventVector_pop(self)


    def append(self, x: 'Event') -> "void":
        """append(self, x)"""
        return _TimeTagger.EventVector_append(self, x)


    def empty(self) -> "bool":
        """empty(self) -> bool"""
        return _TimeTagger.EventVector_empty(self)


    def size(self) -> "std::vector< Event >::size_type":
        """size(self) -> std::vector< Event >::size_type"""
        return _TimeTagger.EventVector_size(self)


    def swap(self, v: 'EventVector') -> "void":
        """swap(self, v)"""
        return _TimeTagger.EventVector_swap(self, v)


    def begin(self) -> "std::vector< Event >::iterator":
        """begin(self) -> std::vector< Event >::iterator"""
        return _TimeTagger.EventVector_begin(self)


    def end(self) -> "std::vector< Event >::iterator":
        """end(self) -> std::vector< Event >::iterator"""
        return _TimeTagger.EventVector_end(self)


    def rbegin(self) -> "std::vector< Event >::reverse_iterator":
        """rbegin(self) -> std::vector< Event >::reverse_iterator"""
        return _TimeTagger.EventVector_rbegin(self)


    def rend(self) -> "std::vector< Event >::reverse_iterator":
        """rend(self) -> std::vector< Event >::reverse_iterator"""
        return _TimeTagger.EventVector_rend(self)


    def clear(self) -> "void":
        """clear(self)"""
        return _TimeTagger.EventVector_clear(self)


    def get_allocator(self) -> "std::vector< Event >::allocator_type":
        """get_allocator(self) -> std::vector< Event >::allocator_type"""
        return _TimeTagger.EventVector_get_allocator(self)


    def pop_back(self) -> "void":
        """pop_back(self)"""
        return _TimeTagger.EventVector_pop_back(self)


    def erase(self, *args) -> "std::vector< Event >::iterator":
        """
        erase(self, pos) -> std::vector< Event >::iterator
        erase(self, first, last) -> std::vector< Event >::iterator
        """
        return _TimeTagger.EventVector_erase(self, *args)


    def __init__(self, *args):
        """
        __init__(self) -> EventVector
        __init__(self, arg2) -> EventVector
        __init__(self, size) -> EventVector
        __init__(self, size, value) -> EventVector
        """
        this = _TimeTagger.new_EventVector(*args)
        try:
            self.this.append(this)
        except __builtin__.Exception:
            self.this = this

    def push_back(self, x: 'Event') -> "void":
        """push_back(self, x)"""
        return _TimeTagger.EventVector_push_back(self, x)


    def front(self) -> "std::vector< Event >::value_type const &":
        """front(self) -> Event"""
        return _TimeTagger.EventVector_front(self)


    def back(self) -> "std::vector< Event >::value_type const &":
        """back(self) -> Event"""
        return _TimeTagger.EventVector_back(self)


    def assign(self, n: 'std::vector< Event >::size_type', x: 'Event') -> "void":
        """assign(self, n, x)"""
        return _TimeTagger.EventVector_assign(self, n, x)


    def resize(self, *args) -> "void":
        """
        resize(self, new_size)
        resize(self, new_size, x)
        """
        return _TimeTagger.EventVector_resize(self, *args)


    def insert(self, *args) -> "void":
        """
        insert(self, pos, x) -> std::vector< Event >::iterator
        insert(self, pos, n, x)
        """
        return _TimeTagger.EventVector_insert(self, *args)


    def reserve(self, n: 'std::vector< Event >::size_type') -> "void":
        """reserve(self, n)"""
        return _TimeTagger.EventVector_reserve(self, n)


    def capacity(self) -> "std::vector< Event >::size_type":
        """capacity(self) -> std::vector< Event >::size_type"""
        return _TimeTagger.EventVector_capacity(self)

    __swig_destroy__ = _TimeTagger.delete_EventVector
    __del__ = lambda self: None
EventVector_swigregister = _TimeTagger.EventVector_swigregister
EventVector_swigregister(EventVector)

class EventVectorVector(_object):
    """Proxy of C++ std::vector<(std::vector<(Event)>)> class."""

    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, EventVectorVector, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, EventVectorVector, name)
    __repr__ = _swig_repr

    def iterator(self) -> "swig::SwigPyIterator *":
        """iterator(self) -> SwigPyIterator"""
        return _TimeTagger.EventVectorVector_iterator(self)

    def __iter__(self):
        return self.iterator()

    def __nonzero__(self) -> "bool":
        """__nonzero__(self) -> bool"""
        return _TimeTagger.EventVectorVector___nonzero__(self)


    def __bool__(self) -> "bool":
        """__bool__(self) -> bool"""
        return _TimeTagger.EventVectorVector___bool__(self)


    def __len__(self) -> "std::vector< std::vector< Event > >::size_type":
        """__len__(self) -> std::vector< std::vector< Event > >::size_type"""
        return _TimeTagger.EventVectorVector___len__(self)


    def __getslice__(self, i: 'std::vector< std::vector< Event > >::difference_type', j: 'std::vector< std::vector< Event > >::difference_type') -> "std::vector< std::vector< Event,std::allocator< Event > >,std::allocator< std::vector< Event,std::allocator< Event > > > > *":
        """__getslice__(self, i, j) -> EventVectorVector"""
        return _TimeTagger.EventVectorVector___getslice__(self, i, j)


    def __setslice__(self, *args) -> "void":
        """
        __setslice__(self, i, j)
        __setslice__(self, i, j, v)
        """
        return _TimeTagger.EventVectorVector___setslice__(self, *args)


    def __delslice__(self, i: 'std::vector< std::vector< Event > >::difference_type', j: 'std::vector< std::vector< Event > >::difference_type') -> "void":
        """__delslice__(self, i, j)"""
        return _TimeTagger.EventVectorVector___delslice__(self, i, j)


    def __delitem__(self, *args) -> "void":
        """
        __delitem__(self, i)
        __delitem__(self, slice)
        """
        return _TimeTagger.EventVectorVector___delitem__(self, *args)


    def __getitem__(self, *args) -> "std::vector< std::vector< Event > >::value_type const &":
        """
        __getitem__(self, slice) -> EventVectorVector
        __getitem__(self, i) -> EventVector
        """
        return _TimeTagger.EventVectorVector___getitem__(self, *args)


    def __setitem__(self, *args) -> "void":
        """
        __setitem__(self, slice, v)
        __setitem__(self, slice)
        __setitem__(self, i, x)
        """
        return _TimeTagger.EventVectorVector___setitem__(self, *args)


    def pop(self) -> "std::vector< std::vector< Event > >::value_type":
        """pop(self) -> EventVector"""
        return _TimeTagger.EventVectorVector_pop(self)


    def append(self, x: 'EventVector') -> "void":
        """append(self, x)"""
        return _TimeTagger.EventVectorVector_append(self, x)


    def empty(self) -> "bool":
        """empty(self) -> bool"""
        return _TimeTagger.EventVectorVector_empty(self)


    def size(self) -> "std::vector< std::vector< Event > >::size_type":
        """size(self) -> std::vector< std::vector< Event > >::size_type"""
        return _TimeTagger.EventVectorVector_size(self)


    def swap(self, v: 'EventVectorVector') -> "void":
        """swap(self, v)"""
        return _TimeTagger.EventVectorVector_swap(self, v)


    def begin(self) -> "std::vector< std::vector< Event > >::iterator":
        """begin(self) -> std::vector< std::vector< Event > >::iterator"""
        return _TimeTagger.EventVectorVector_begin(self)


    def end(self) -> "std::vector< std::vector< Event > >::iterator":
        """end(self) -> std::vector< std::vector< Event > >::iterator"""
        return _TimeTagger.EventVectorVector_end(self)


    def rbegin(self) -> "std::vector< std::vector< Event > >::reverse_iterator":
        """rbegin(self) -> std::vector< std::vector< Event > >::reverse_iterator"""
        return _TimeTagger.EventVectorVector_rbegin(self)


    def rend(self) -> "std::vector< std::vector< Event > >::reverse_iterator":
        """rend(self) -> std::vector< std::vector< Event > >::reverse_iterator"""
        return _TimeTagger.EventVectorVector_rend(self)


    def clear(self) -> "void":
        """clear(self)"""
        return _TimeTagger.EventVectorVector_clear(self)


    def get_allocator(self) -> "std::vector< std::vector< Event > >::allocator_type":
        """get_allocator(self) -> std::vector< std::vector< Event > >::allocator_type"""
        return _TimeTagger.EventVectorVector_get_allocator(self)


    def pop_back(self) -> "void":
        """pop_back(self)"""
        return _TimeTagger.EventVectorVector_pop_back(self)


    def erase(self, *args) -> "std::vector< std::vector< Event > >::iterator":
        """
        erase(self, pos) -> std::vector< std::vector< Event > >::iterator
        erase(self, first, last) -> std::vector< std::vector< Event > >::iterator
        """
        return _TimeTagger.EventVectorVector_erase(self, *args)


    def __init__(self, *args):
        """
        __init__(self) -> EventVectorVector
        __init__(self, arg2) -> EventVectorVector
        __init__(self, size) -> EventVectorVector
        __init__(self, size, value) -> EventVectorVector
        """
        this = _TimeTagger.new_EventVectorVector(*args)
        try:
            self.this.append(this)
        except __builtin__.Exception:
            self.this = this

    def push_back(self, x: 'EventVector') -> "void":
        """push_back(self, x)"""
        return _TimeTagger.EventVectorVector_push_back(self, x)


    def front(self) -> "std::vector< std::vector< Event > >::value_type const &":
        """front(self) -> EventVector"""
        return _TimeTagger.EventVectorVector_front(self)


    def back(self) -> "std::vector< std::vector< Event > >::value_type const &":
        """back(self) -> EventVector"""
        return _TimeTagger.EventVectorVector_back(self)


    def assign(self, n: 'std::vector< std::vector< Event > >::size_type', x: 'EventVector') -> "void":
        """assign(self, n, x)"""
        return _TimeTagger.EventVectorVector_assign(self, n, x)


    def resize(self, *args) -> "void":
        """
        resize(self, new_size)
        resize(self, new_size, x)
        """
        return _TimeTagger.EventVectorVector_resize(self, *args)


    def insert(self, *args) -> "void":
        """
        insert(self, pos, x) -> std::vector< std::vector< Event > >::iterator
        insert(self, pos, n, x)
        """
        return _TimeTagger.EventVectorVector_insert(self, *args)


    def reserve(self, n: 'std::vector< std::vector< Event > >::size_type') -> "void":
        """reserve(self, n)"""
        return _TimeTagger.EventVectorVector_reserve(self, n)


    def capacity(self) -> "std::vector< std::vector< Event > >::size_type":
        """capacity(self) -> std::vector< std::vector< Event > >::size_type"""
        return _TimeTagger.EventVectorVector_capacity(self)

    __swig_destroy__ = _TimeTagger.delete_EventVectorVector
    __del__ = lambda self: None
EventVectorVector_swigregister = _TimeTagger.EventVectorVector_swigregister
EventVectorVector_swigregister(EventVectorVector)

class IntVectorVector(_object):
    """Proxy of C++ std::vector<(std::vector<(int)>)> class."""

    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, IntVectorVector, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, IntVectorVector, name)
    __repr__ = _swig_repr

    def iterator(self) -> "swig::SwigPyIterator *":
        """iterator(self) -> SwigPyIterator"""
        return _TimeTagger.IntVectorVector_iterator(self)

    def __iter__(self):
        return self.iterator()

    def __nonzero__(self) -> "bool":
        """__nonzero__(self) -> bool"""
        return _TimeTagger.IntVectorVector___nonzero__(self)


    def __bool__(self) -> "bool":
        """__bool__(self) -> bool"""
        return _TimeTagger.IntVectorVector___bool__(self)


    def __len__(self) -> "std::vector< std::vector< int > >::size_type":
        """__len__(self) -> std::vector< std::vector< int > >::size_type"""
        return _TimeTagger.IntVectorVector___len__(self)


    def __getslice__(self, i: 'std::vector< std::vector< int > >::difference_type', j: 'std::vector< std::vector< int > >::difference_type') -> "std::vector< std::vector< int,std::allocator< int > >,std::allocator< std::vector< int,std::allocator< int > > > > *":
        """__getslice__(self, i, j) -> IntVectorVector"""
        return _TimeTagger.IntVectorVector___getslice__(self, i, j)


    def __setslice__(self, *args) -> "void":
        """
        __setslice__(self, i, j)
        __setslice__(self, i, j, v)
        """
        return _TimeTagger.IntVectorVector___setslice__(self, *args)


    def __delslice__(self, i: 'std::vector< std::vector< int > >::difference_type', j: 'std::vector< std::vector< int > >::difference_type') -> "void":
        """__delslice__(self, i, j)"""
        return _TimeTagger.IntVectorVector___delslice__(self, i, j)


    def __delitem__(self, *args) -> "void":
        """
        __delitem__(self, i)
        __delitem__(self, slice)
        """
        return _TimeTagger.IntVectorVector___delitem__(self, *args)


    def __getitem__(self, *args) -> "std::vector< std::vector< int > >::value_type const &":
        """
        __getitem__(self, slice) -> IntVectorVector
        __getitem__(self, i) -> IntVector
        """
        return _TimeTagger.IntVectorVector___getitem__(self, *args)


    def __setitem__(self, *args) -> "void":
        """
        __setitem__(self, slice, v)
        __setitem__(self, slice)
        __setitem__(self, i, x)
        """
        return _TimeTagger.IntVectorVector___setitem__(self, *args)


    def pop(self) -> "std::vector< std::vector< int > >::value_type":
        """pop(self) -> IntVector"""
        return _TimeTagger.IntVectorVector_pop(self)


    def append(self, x: 'IntVector') -> "void":
        """append(self, x)"""
        return _TimeTagger.IntVectorVector_append(self, x)


    def empty(self) -> "bool":
        """empty(self) -> bool"""
        return _TimeTagger.IntVectorVector_empty(self)


    def size(self) -> "std::vector< std::vector< int > >::size_type":
        """size(self) -> std::vector< std::vector< int > >::size_type"""
        return _TimeTagger.IntVectorVector_size(self)


    def swap(self, v: 'IntVectorVector') -> "void":
        """swap(self, v)"""
        return _TimeTagger.IntVectorVector_swap(self, v)


    def begin(self) -> "std::vector< std::vector< int > >::iterator":
        """begin(self) -> std::vector< std::vector< int > >::iterator"""
        return _TimeTagger.IntVectorVector_begin(self)


    def end(self) -> "std::vector< std::vector< int > >::iterator":
        """end(self) -> std::vector< std::vector< int > >::iterator"""
        return _TimeTagger.IntVectorVector_end(self)


    def rbegin(self) -> "std::vector< std::vector< int > >::reverse_iterator":
        """rbegin(self) -> std::vector< std::vector< int > >::reverse_iterator"""
        return _TimeTagger.IntVectorVector_rbegin(self)


    def rend(self) -> "std::vector< std::vector< int > >::reverse_iterator":
        """rend(self) -> std::vector< std::vector< int > >::reverse_iterator"""
        return _TimeTagger.IntVectorVector_rend(self)


    def clear(self) -> "void":
        """clear(self)"""
        return _TimeTagger.IntVectorVector_clear(self)


    def get_allocator(self) -> "std::vector< std::vector< int > >::allocator_type":
        """get_allocator(self) -> std::vector< std::vector< int > >::allocator_type"""
        return _TimeTagger.IntVectorVector_get_allocator(self)


    def pop_back(self) -> "void":
        """pop_back(self)"""
        return _TimeTagger.IntVectorVector_pop_back(self)


    def erase(self, *args) -> "std::vector< std::vector< int > >::iterator":
        """
        erase(self, pos) -> std::vector< std::vector< int > >::iterator
        erase(self, first, last) -> std::vector< std::vector< int > >::iterator
        """
        return _TimeTagger.IntVectorVector_erase(self, *args)


    def __init__(self, *args):
        """
        __init__(self) -> IntVectorVector
        __init__(self, arg2) -> IntVectorVector
        __init__(self, size) -> IntVectorVector
        __init__(self, size, value) -> IntVectorVector
        """
        this = _TimeTagger.new_IntVectorVector(*args)
        try:
            self.this.append(this)
        except __builtin__.Exception:
            self.this = this

    def push_back(self, x: 'IntVector') -> "void":
        """push_back(self, x)"""
        return _TimeTagger.IntVectorVector_push_back(self, x)


    def front(self) -> "std::vector< std::vector< int > >::value_type const &":
        """front(self) -> IntVector"""
        return _TimeTagger.IntVectorVector_front(self)


    def back(self) -> "std::vector< std::vector< int > >::value_type const &":
        """back(self) -> IntVector"""
        return _TimeTagger.IntVectorVector_back(self)


    def assign(self, n: 'std::vector< std::vector< int > >::size_type', x: 'IntVector') -> "void":
        """assign(self, n, x)"""
        return _TimeTagger.IntVectorVector_assign(self, n, x)


    def resize(self, *args) -> "void":
        """
        resize(self, new_size)
        resize(self, new_size, x)
        """
        return _TimeTagger.IntVectorVector_resize(self, *args)


    def insert(self, *args) -> "void":
        """
        insert(self, pos, x) -> std::vector< std::vector< int > >::iterator
        insert(self, pos, n, x)
        """
        return _TimeTagger.IntVectorVector_insert(self, *args)


    def reserve(self, n: 'std::vector< std::vector< int > >::size_type') -> "void":
        """reserve(self, n)"""
        return _TimeTagger.IntVectorVector_reserve(self, n)


    def capacity(self) -> "std::vector< std::vector< int > >::size_type":
        """capacity(self) -> std::vector< std::vector< int > >::size_type"""
        return _TimeTagger.IntVectorVector_capacity(self)

    __swig_destroy__ = _TimeTagger.delete_IntVectorVector
    __del__ = lambda self: None
IntVectorVector_swigregister = _TimeTagger.IntVectorVector_swigregister
IntVectorVector_swigregister(IntVectorVector)

class UIntVectorVector(_object):
    """Proxy of C++ std::vector<(std::vector<(unsigned int)>)> class."""

    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, UIntVectorVector, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, UIntVectorVector, name)
    __repr__ = _swig_repr

    def iterator(self) -> "swig::SwigPyIterator *":
        """iterator(self) -> SwigPyIterator"""
        return _TimeTagger.UIntVectorVector_iterator(self)

    def __iter__(self):
        return self.iterator()

    def __nonzero__(self) -> "bool":
        """__nonzero__(self) -> bool"""
        return _TimeTagger.UIntVectorVector___nonzero__(self)


    def __bool__(self) -> "bool":
        """__bool__(self) -> bool"""
        return _TimeTagger.UIntVectorVector___bool__(self)


    def __len__(self) -> "std::vector< std::vector< unsigned int > >::size_type":
        """__len__(self) -> std::vector< std::vector< unsigned int > >::size_type"""
        return _TimeTagger.UIntVectorVector___len__(self)


    def __getslice__(self, i: 'std::vector< std::vector< unsigned int > >::difference_type', j: 'std::vector< std::vector< unsigned int > >::difference_type') -> "std::vector< std::vector< unsigned int,std::allocator< unsigned int > >,std::allocator< std::vector< unsigned int,std::allocator< unsigned int > > > > *":
        """__getslice__(self, i, j) -> UIntVectorVector"""
        return _TimeTagger.UIntVectorVector___getslice__(self, i, j)


    def __setslice__(self, *args) -> "void":
        """
        __setslice__(self, i, j)
        __setslice__(self, i, j, v)
        """
        return _TimeTagger.UIntVectorVector___setslice__(self, *args)


    def __delslice__(self, i: 'std::vector< std::vector< unsigned int > >::difference_type', j: 'std::vector< std::vector< unsigned int > >::difference_type') -> "void":
        """__delslice__(self, i, j)"""
        return _TimeTagger.UIntVectorVector___delslice__(self, i, j)


    def __delitem__(self, *args) -> "void":
        """
        __delitem__(self, i)
        __delitem__(self, slice)
        """
        return _TimeTagger.UIntVectorVector___delitem__(self, *args)


    def __getitem__(self, *args) -> "std::vector< std::vector< unsigned int > >::value_type const &":
        """
        __getitem__(self, slice) -> UIntVectorVector
        __getitem__(self, i) -> UIntVector
        """
        return _TimeTagger.UIntVectorVector___getitem__(self, *args)


    def __setitem__(self, *args) -> "void":
        """
        __setitem__(self, slice, v)
        __setitem__(self, slice)
        __setitem__(self, i, x)
        """
        return _TimeTagger.UIntVectorVector___setitem__(self, *args)


    def pop(self) -> "std::vector< std::vector< unsigned int > >::value_type":
        """pop(self) -> UIntVector"""
        return _TimeTagger.UIntVectorVector_pop(self)


    def append(self, x: 'UIntVector') -> "void":
        """append(self, x)"""
        return _TimeTagger.UIntVectorVector_append(self, x)


    def empty(self) -> "bool":
        """empty(self) -> bool"""
        return _TimeTagger.UIntVectorVector_empty(self)


    def size(self) -> "std::vector< std::vector< unsigned int > >::size_type":
        """size(self) -> std::vector< std::vector< unsigned int > >::size_type"""
        return _TimeTagger.UIntVectorVector_size(self)


    def swap(self, v: 'UIntVectorVector') -> "void":
        """swap(self, v)"""
        return _TimeTagger.UIntVectorVector_swap(self, v)


    def begin(self) -> "std::vector< std::vector< unsigned int > >::iterator":
        """begin(self) -> std::vector< std::vector< unsigned int > >::iterator"""
        return _TimeTagger.UIntVectorVector_begin(self)


    def end(self) -> "std::vector< std::vector< unsigned int > >::iterator":
        """end(self) -> std::vector< std::vector< unsigned int > >::iterator"""
        return _TimeTagger.UIntVectorVector_end(self)


    def rbegin(self) -> "std::vector< std::vector< unsigned int > >::reverse_iterator":
        """rbegin(self) -> std::vector< std::vector< unsigned int > >::reverse_iterator"""
        return _TimeTagger.UIntVectorVector_rbegin(self)


    def rend(self) -> "std::vector< std::vector< unsigned int > >::reverse_iterator":
        """rend(self) -> std::vector< std::vector< unsigned int > >::reverse_iterator"""
        return _TimeTagger.UIntVectorVector_rend(self)


    def clear(self) -> "void":
        """clear(self)"""
        return _TimeTagger.UIntVectorVector_clear(self)


    def get_allocator(self) -> "std::vector< std::vector< unsigned int > >::allocator_type":
        """get_allocator(self) -> std::vector< std::vector< unsigned int > >::allocator_type"""
        return _TimeTagger.UIntVectorVector_get_allocator(self)


    def pop_back(self) -> "void":
        """pop_back(self)"""
        return _TimeTagger.UIntVectorVector_pop_back(self)


    def erase(self, *args) -> "std::vector< std::vector< unsigned int > >::iterator":
        """
        erase(self, pos) -> std::vector< std::vector< unsigned int > >::iterator
        erase(self, first, last) -> std::vector< std::vector< unsigned int > >::iterator
        """
        return _TimeTagger.UIntVectorVector_erase(self, *args)


    def __init__(self, *args):
        """
        __init__(self) -> UIntVectorVector
        __init__(self, arg2) -> UIntVectorVector
        __init__(self, size) -> UIntVectorVector
        __init__(self, size, value) -> UIntVectorVector
        """
        this = _TimeTagger.new_UIntVectorVector(*args)
        try:
            self.this.append(this)
        except __builtin__.Exception:
            self.this = this

    def push_back(self, x: 'UIntVector') -> "void":
        """push_back(self, x)"""
        return _TimeTagger.UIntVectorVector_push_back(self, x)


    def front(self) -> "std::vector< std::vector< unsigned int > >::value_type const &":
        """front(self) -> UIntVector"""
        return _TimeTagger.UIntVectorVector_front(self)


    def back(self) -> "std::vector< std::vector< unsigned int > >::value_type const &":
        """back(self) -> UIntVector"""
        return _TimeTagger.UIntVectorVector_back(self)


    def assign(self, n: 'std::vector< std::vector< unsigned int > >::size_type', x: 'UIntVector') -> "void":
        """assign(self, n, x)"""
        return _TimeTagger.UIntVectorVector_assign(self, n, x)


    def resize(self, *args) -> "void":
        """
        resize(self, new_size)
        resize(self, new_size, x)
        """
        return _TimeTagger.UIntVectorVector_resize(self, *args)


    def insert(self, *args) -> "void":
        """
        insert(self, pos, x) -> std::vector< std::vector< unsigned int > >::iterator
        insert(self, pos, n, x)
        """
        return _TimeTagger.UIntVectorVector_insert(self, *args)


    def reserve(self, n: 'std::vector< std::vector< unsigned int > >::size_type') -> "void":
        """reserve(self, n)"""
        return _TimeTagger.UIntVectorVector_reserve(self, n)


    def capacity(self) -> "std::vector< std::vector< unsigned int > >::size_type":
        """capacity(self) -> std::vector< std::vector< unsigned int > >::size_type"""
        return _TimeTagger.UIntVectorVector_capacity(self)

    __swig_destroy__ = _TimeTagger.delete_UIntVectorVector
    __del__ = lambda self: None
UIntVectorVector_swigregister = _TimeTagger.UIntVectorVector_swigregister
UIntVectorVector_swigregister(UIntVectorVector)


def getVersion() -> "std::string":
    """getVersion() -> std::string"""
    return _TimeTagger.getVersion()
Resolution_Standard = _TimeTagger.Resolution_Standard
Resolution_HighResA = _TimeTagger.Resolution_HighResA
Resolution_HighResB = _TimeTagger.Resolution_HighResB
Resolution_HighResC = _TimeTagger.Resolution_HighResC
ChannelEdge_All = _TimeTagger.ChannelEdge_All
ChannelEdge_Rising = _TimeTagger.ChannelEdge_Rising
ChannelEdge_Falling = _TimeTagger.ChannelEdge_Falling
ChannelEdge_HighResAll = _TimeTagger.ChannelEdge_HighResAll
ChannelEdge_HighResRising = _TimeTagger.ChannelEdge_HighResRising
ChannelEdge_HighResFalling = _TimeTagger.ChannelEdge_HighResFalling
ChannelEdge_StandardAll = _TimeTagger.ChannelEdge_StandardAll
ChannelEdge_StandardRising = _TimeTagger.ChannelEdge_StandardRising
ChannelEdge_StandardFalling = _TimeTagger.ChannelEdge_StandardFalling
class SoftwareClockState(_object):
    """Proxy of C++ SoftwareClockState class."""

    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, SoftwareClockState, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, SoftwareClockState, name)
    __repr__ = _swig_repr
    __swig_setmethods__["clock_period"] = _TimeTagger.SoftwareClockState_clock_period_set
    __swig_getmethods__["clock_period"] = _TimeTagger.SoftwareClockState_clock_period_get
    if _newclass:
        clock_period = _swig_property(_TimeTagger.SoftwareClockState_clock_period_get, _TimeTagger.SoftwareClockState_clock_period_set)
    __swig_setmethods__["input_channel"] = _TimeTagger.SoftwareClockState_input_channel_set
    __swig_getmethods__["input_channel"] = _TimeTagger.SoftwareClockState_input_channel_get
    if _newclass:
        input_channel = _swig_property(_TimeTagger.SoftwareClockState_input_channel_get, _TimeTagger.SoftwareClockState_input_channel_set)
    __swig_setmethods__["ideal_clock_channel"] = _TimeTagger.SoftwareClockState_ideal_clock_channel_set
    __swig_getmethods__["ideal_clock_channel"] = _TimeTagger.SoftwareClockState_ideal_clock_channel_get
    if _newclass:
        ideal_clock_channel = _swig_property(_TimeTagger.SoftwareClockState_ideal_clock_channel_get, _TimeTagger.SoftwareClockState_ideal_clock_channel_set)
    __swig_setmethods__["averaging_periods"] = _TimeTagger.SoftwareClockState_averaging_periods_set
    __swig_getmethods__["averaging_periods"] = _TimeTagger.SoftwareClockState_averaging_periods_get
    if _newclass:
        averaging_periods = _swig_property(_TimeTagger.SoftwareClockState_averaging_periods_get, _TimeTagger.SoftwareClockState_averaging_periods_set)
    __swig_setmethods__["enabled"] = _TimeTagger.SoftwareClockState_enabled_set
    __swig_getmethods__["enabled"] = _TimeTagger.SoftwareClockState_enabled_get
    if _newclass:
        enabled = _swig_property(_TimeTagger.SoftwareClockState_enabled_get, _TimeTagger.SoftwareClockState_enabled_set)
    __swig_setmethods__["is_locked"] = _TimeTagger.SoftwareClockState_is_locked_set
    __swig_getmethods__["is_locked"] = _TimeTagger.SoftwareClockState_is_locked_get
    if _newclass:
        is_locked = _swig_property(_TimeTagger.SoftwareClockState_is_locked_get, _TimeTagger.SoftwareClockState_is_locked_set)
    __swig_setmethods__["error_counter"] = _TimeTagger.SoftwareClockState_error_counter_set
    __swig_getmethods__["error_counter"] = _TimeTagger.SoftwareClockState_error_counter_get
    if _newclass:
        error_counter = _swig_property(_TimeTagger.SoftwareClockState_error_counter_get, _TimeTagger.SoftwareClockState_error_counter_set)
    __swig_setmethods__["last_ideal_clock_event"] = _TimeTagger.SoftwareClockState_last_ideal_clock_event_set
    __swig_getmethods__["last_ideal_clock_event"] = _TimeTagger.SoftwareClockState_last_ideal_clock_event_get
    if _newclass:
        last_ideal_clock_event = _swig_property(_TimeTagger.SoftwareClockState_last_ideal_clock_event_get, _TimeTagger.SoftwareClockState_last_ideal_clock_event_set)
    __swig_setmethods__["period_error"] = _TimeTagger.SoftwareClockState_period_error_set
    __swig_getmethods__["period_error"] = _TimeTagger.SoftwareClockState_period_error_get
    if _newclass:
        period_error = _swig_property(_TimeTagger.SoftwareClockState_period_error_get, _TimeTagger.SoftwareClockState_period_error_set)
    __swig_setmethods__["phase_error_estimation"] = _TimeTagger.SoftwareClockState_phase_error_estimation_set
    __swig_getmethods__["phase_error_estimation"] = _TimeTagger.SoftwareClockState_phase_error_estimation_get
    if _newclass:
        phase_error_estimation = _swig_property(_TimeTagger.SoftwareClockState_phase_error_estimation_get, _TimeTagger.SoftwareClockState_phase_error_estimation_set)

    def __init__(self):
        """__init__(self) -> SoftwareClockState"""
        this = _TimeTagger.new_SoftwareClockState()
        try:
            self.this.append(this)
        except __builtin__.Exception:
            self.this = this
    __swig_destroy__ = _TimeTagger.delete_SoftwareClockState
    __del__ = lambda self: None
SoftwareClockState_swigregister = _TimeTagger.SoftwareClockState_swigregister
SoftwareClockState_swigregister(SoftwareClockState)
cvar = _TimeTagger.cvar
CHANNEL_UNUSED = cvar.CHANNEL_UNUSED
CHANNEL_UNUSED_OLD = cvar.CHANNEL_UNUSED_OLD
TT_CHANNEL_NUMBER_SCHEME_AUTO = cvar.TT_CHANNEL_NUMBER_SCHEME_AUTO
TT_CHANNEL_NUMBER_SCHEME_ZERO = cvar.TT_CHANNEL_NUMBER_SCHEME_ZERO
TT_CHANNEL_NUMBER_SCHEME_ONE = cvar.TT_CHANNEL_NUMBER_SCHEME_ONE
TT_CHANNEL_RISING_AND_FALLING_EDGES = cvar.TT_CHANNEL_RISING_AND_FALLING_EDGES
TT_CHANNEL_RISING_EDGES = cvar.TT_CHANNEL_RISING_EDGES
TT_CHANNEL_FALLING_EDGES = cvar.TT_CHANNEL_FALLING_EDGES


def createTimeTagger(*args, **kwargs) -> "TimeTagger *":
    """createTimeTagger(serial, resolution) -> TimeTagger"""
    return _TimeTagger.createTimeTagger(*args, **kwargs)

def createTimeTaggerVirtual() -> "TimeTaggerVirtual *":
    """createTimeTaggerVirtual() -> TimeTaggerVirtual"""
    return _TimeTagger.createTimeTaggerVirtual()

def createTimeTaggerNetwork(*args, **kwargs) -> "TimeTaggerNetwork *":
    """createTimeTaggerNetwork(address) -> TimeTaggerNetwork"""
    return _TimeTagger.createTimeTaggerNetwork(*args, **kwargs)

def setCustomBitFileName(bitFileName: 'std::string const &') -> "void":
    """setCustomBitFileName(bitFileName)"""
    return _TimeTagger.setCustomBitFileName(bitFileName)

def scanTimeTagger() -> "std::vector< std::string,std::allocator< std::string > >":
    """scanTimeTagger() -> StringVector"""
    return _TimeTagger.scanTimeTagger()

def __getTimeTaggerServerInfo(*args, **kwargs) -> "std::string":
    """__getTimeTaggerServerInfo(address) -> std::string"""
    return _TimeTagger.__getTimeTaggerServerInfo(*args, **kwargs)

def scanTimeTaggerServers() -> "std::vector< std::string,std::allocator< std::string > >":
    """scanTimeTaggerServers() -> StringVector"""
    return _TimeTagger.scanTimeTaggerServers()

def getTimeTaggerModel(serial: 'std::string const &') -> "std::string":
    """getTimeTaggerModel(serial) -> std::string"""
    return _TimeTagger.getTimeTaggerModel(serial)

def setTimeTaggerChannelNumberScheme(scheme: 'int') -> "void":
    """setTimeTaggerChannelNumberScheme(scheme)"""
    return _TimeTagger.setTimeTaggerChannelNumberScheme(scheme)

def getTimeTaggerChannelNumberScheme() -> "int":
    """getTimeTaggerChannelNumberScheme() -> int"""
    return _TimeTagger.getTimeTaggerChannelNumberScheme()

def hasTimeTaggerVirtualLicense() -> "bool":
    """hasTimeTaggerVirtualLicense() -> bool"""
    return _TimeTagger.hasTimeTaggerVirtualLicense()

def flashLicense(serial: 'std::string const &', license: 'std::string const &') -> "void":
    """flashLicense(serial, license)"""
    return _TimeTagger.flashLicense(serial, license)

def __extractDeviceLicense(license: 'std::string const &') -> "std::string":
    """__extractDeviceLicense(license) -> std::string"""
    return _TimeTagger.__extractDeviceLicense(license)
LOGGER_ERROR = _TimeTagger.LOGGER_ERROR
LOGGER_WARNING = _TimeTagger.LOGGER_WARNING
LOGGER_INFO = _TimeTagger.LOGGER_INFO
class CustomLogger(_object):
    """Proxy of C++ CustomLogger class."""

    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, CustomLogger, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, CustomLogger, name)
    __repr__ = _swig_repr

    def __init__(self):
        """__init__(self) -> CustomLogger"""
        if self.__class__ == CustomLogger:
            _self = None
        else:
            _self = self
        this = _TimeTagger.new_CustomLogger(_self, )
        try:
            self.this.append(this)
        except __builtin__.Exception:
            self.this = this
    __swig_destroy__ = _TimeTagger.delete_CustomLogger
    __del__ = lambda self: None

    def enable(self) -> "void":
        """enable(self)"""
        return _TimeTagger.CustomLogger_enable(self)


    def disable(self) -> "void":
        """disable(self)"""
        return _TimeTagger.CustomLogger_disable(self)


    def Log(self, level: 'int', msg: 'std::string const &') -> "void":
        """Log(self, level, msg)"""
        return _TimeTagger.CustomLogger_Log(self, level, msg)

    def __disown__(self):
        self.this.disown()
        _TimeTagger.disown_CustomLogger(self)
        return weakref_proxy(self)
CustomLogger_swigregister = _TimeTagger.CustomLogger_swigregister
CustomLogger_swigregister(CustomLogger)

class TimeTaggerBase(_object):
    """Proxy of C++ TimeTaggerBase class."""

    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, TimeTaggerBase, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, TimeTaggerBase, name)

    def __init__(self, *args, **kwargs):
        raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr

    def getFence(self, alloc_fence: 'bool'=True) -> "unsigned int":
        """getFence(self, alloc_fence=True) -> unsigned int"""
        return _TimeTagger.TimeTaggerBase_getFence(self, alloc_fence)


    def __waitForFence(self, fence: 'unsigned int', timeout: 'int64_t'=-1) -> "bool":
        """__waitForFence(self, fence, timeout=-1) -> bool"""
        return _TimeTagger.TimeTaggerBase___waitForFence(self, fence, timeout)


    def __sync(self, timeout: 'int64_t'=-1) -> "bool":
        """__sync(self, timeout=-1) -> bool"""
        return _TimeTagger.TimeTaggerBase___sync(self, timeout)


    def getInvertedChannel(self, channel: 'int') -> "int":
        """getInvertedChannel(self, channel) -> int"""
        return _TimeTagger.TimeTaggerBase_getInvertedChannel(self, channel)


    def isUnusedChannel(self, channel: 'int') -> "bool":
        """isUnusedChannel(self, channel) -> bool"""
        return _TimeTagger.TimeTaggerBase_isUnusedChannel(self, channel)


    def __getConfiguration(self) -> "std::string":
        """__getConfiguration(self) -> std::string"""
        return _TimeTagger.TimeTaggerBase___getConfiguration(self)


    def setInputDelay(self, channel: 'int', delay: 'long long') -> "void":
        """setInputDelay(self, channel, delay)"""
        return _TimeTagger.TimeTaggerBase_setInputDelay(self, channel, delay)


    def setDelayHardware(self, channel: 'int', delay: 'long long') -> "void":
        """setDelayHardware(self, channel, delay)"""
        return _TimeTagger.TimeTaggerBase_setDelayHardware(self, channel, delay)


    def setDelaySoftware(self, channel: 'int', delay: 'long long') -> "void":
        """setDelaySoftware(self, channel, delay)"""
        return _TimeTagger.TimeTaggerBase_setDelaySoftware(self, channel, delay)


    def getInputDelay(self, channel: 'int') -> "long long":
        """getInputDelay(self, channel) -> long long"""
        return _TimeTagger.TimeTaggerBase_getInputDelay(self, channel)


    def getDelaySoftware(self, channel: 'int') -> "long long":
        """getDelaySoftware(self, channel) -> long long"""
        return _TimeTagger.TimeTaggerBase_getDelaySoftware(self, channel)


    def getDelayHardware(self, channel: 'int') -> "long long":
        """getDelayHardware(self, channel) -> long long"""
        return _TimeTagger.TimeTaggerBase_getDelayHardware(self, channel)


    def setDeadtime(self, channel: 'int', deadtime: 'long long') -> "long long":
        """setDeadtime(self, channel, deadtime) -> long long"""
        return _TimeTagger.TimeTaggerBase_setDeadtime(self, channel, deadtime)


    def getDeadtime(self, channel: 'int') -> "long long":
        """getDeadtime(self, channel) -> long long"""
        return _TimeTagger.TimeTaggerBase_getDeadtime(self, channel)


    def setTestSignal(self, *args) -> "void":
        """
        setTestSignal(self, channel, enabled)
        setTestSignal(self, channel, enabled)
        """
        return _TimeTagger.TimeTaggerBase_setTestSignal(self, *args)


    def getTestSignal(self, channel: 'int') -> "bool":
        """getTestSignal(self, channel) -> bool"""
        return _TimeTagger.TimeTaggerBase_getTestSignal(self, channel)


    def setSoftwareClock(self, input_channel: 'int', input_frequency: 'double'=10e6, averaging_periods: 'double'=1000, wait_until_locked: 'bool'=True) -> "void":
        """setSoftwareClock(self, input_channel, input_frequency=10e6, averaging_periods=1000, wait_until_locked=True)"""
        return _TimeTagger.TimeTaggerBase_setSoftwareClock(self, input_channel, input_frequency, averaging_periods, wait_until_locked)


    def disableSoftwareClock(self) -> "void":
        """disableSoftwareClock(self)"""
        return _TimeTagger.TimeTaggerBase_disableSoftwareClock(self)


    def getSoftwareClockState(self) -> "SoftwareClockState":
        """getSoftwareClockState(self) -> SoftwareClockState"""
        return _TimeTagger.TimeTaggerBase_getSoftwareClockState(self)


    def getOverflows(self) -> "long long":
        """getOverflows(self) -> long long"""
        return _TimeTagger.TimeTaggerBase_getOverflows(self)


    def clearOverflows(self) -> "void":
        """clearOverflows(self)"""
        return _TimeTagger.TimeTaggerBase_clearOverflows(self)


    def getOverflowsAndClear(self) -> "long long":
        """getOverflowsAndClear(self) -> long long"""
        return _TimeTagger.TimeTaggerBase_getOverflowsAndClear(self)


    def sync(self, timeout=-1):
        r"""sync(self, timeout=-1) -> bool"""
        fence = self.getFence()
        return self.waitForFence(fence, timeout)


    def waitForFence(self, fence, timeout=-1):
        r"""waitForFence(self, fence, timeout=-1) -> bool"""
        return _timeout_handler(lambda t: self.__waitForFence(fence, t), timeout)


    def getConfiguration(self, *args, **kargs):
        r"""getConfiguration(...) -> json"""
        import json
        return json.loads(self.__getConfiguration(*args, **kargs))


    def __enter__(self):
        return self

    def __exit__(self, type, value, tb):
        if self.thisown:
            self.__swig_destroy__(self)
            self.this = None
        return False

TimeTaggerBase_swigregister = _TimeTagger.TimeTaggerBase_swigregister
TimeTaggerBase_swigregister(TimeTaggerBase)

class TimeTaggerVirtual(TimeTaggerBase):
    """Proxy of C++ TimeTaggerVirtual class."""

    __swig_setmethods__ = {}
    for _s in [TimeTaggerBase]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, TimeTaggerVirtual, name, value)
    __swig_getmethods__ = {}
    for _s in [TimeTaggerBase]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, TimeTaggerVirtual, name)

    def __init__(self, *args, **kwargs):
        raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr

    def replay(self, file: 'std::string const &', begin: 'long long'=0, duration: 'long long'=-1, queue: 'bool'=True) -> "uint64_t":
        """replay(self, file, begin=0, duration=-1, queue=True) -> uint64_t"""
        return _TimeTagger.TimeTaggerVirtual_replay(self, file, begin, duration, queue)


    def stop(self) -> "void":
        """stop(self)"""
        return _TimeTagger.TimeTaggerVirtual_stop(self)


    def reset(self) -> "void":
        """reset(self)"""
        return _TimeTagger.TimeTaggerVirtual_reset(self)


    def __waitForCompletion(self, ID: 'uint64_t'=0, timeout: 'int64_t'=-1) -> "bool":
        """__waitForCompletion(self, ID=0, timeout=-1) -> bool"""
        return _TimeTagger.TimeTaggerVirtual___waitForCompletion(self, ID, timeout)


    def setReplaySpeed(self, speed: 'double') -> "void":
        """setReplaySpeed(self, speed)"""
        return _TimeTagger.TimeTaggerVirtual_setReplaySpeed(self, speed)


    def getReplaySpeed(self) -> "double":
        """getReplaySpeed(self) -> double"""
        return _TimeTagger.TimeTaggerVirtual_getReplaySpeed(self)


    def setConditionalFilter(self, trigger: 'IntVector', filtered: 'IntVector') -> "void":
        """setConditionalFilter(self, trigger, filtered)"""
        return _TimeTagger.TimeTaggerVirtual_setConditionalFilter(self, trigger, filtered)


    def clearConditionalFilter(self) -> "void":
        """clearConditionalFilter(self)"""
        return _TimeTagger.TimeTaggerVirtual_clearConditionalFilter(self)


    def getConditionalFilterTrigger(self) -> "std::vector< int,std::allocator< int > >":
        """getConditionalFilterTrigger(self) -> IntVector"""
        return _TimeTagger.TimeTaggerVirtual_getConditionalFilterTrigger(self)


    def getConditionalFilterFiltered(self) -> "std::vector< int,std::allocator< int > >":
        """getConditionalFilterFiltered(self) -> IntVector"""
        return _TimeTagger.TimeTaggerVirtual_getConditionalFilterFiltered(self)


    def waitForCompletion(self, ID=0, timeout=-1):
        r"""waitForCompletion(self, ID=0, timeout=-1) -> bool"""
        return _timeout_handler(lambda t: self.__waitForCompletion(ID, t), timeout)

    __swig_destroy__ = _TimeTagger.delete_TimeTaggerVirtual
    __del__ = lambda self: None
TimeTaggerVirtual_swigregister = _TimeTagger.TimeTaggerVirtual_swigregister
TimeTaggerVirtual_swigregister(TimeTaggerVirtual)

AccessMode_Listen = _TimeTagger.AccessMode_Listen
AccessMode_Control = _TimeTagger.AccessMode_Control
AccessMode_SynchronousControl = _TimeTagger.AccessMode_SynchronousControl
class TimeTaggerNetwork(TimeTaggerBase):
    """Proxy of C++ TimeTaggerNetwork class."""

    __swig_setmethods__ = {}
    for _s in [TimeTaggerBase]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, TimeTaggerNetwork, name, value)
    __swig_getmethods__ = {}
    for _s in [TimeTaggerBase]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, TimeTaggerNetwork, name)

    def __init__(self, *args, **kwargs):
        raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr

    def isConnected(self) -> "bool":
        """isConnected(self) -> bool"""
        return _TimeTagger.TimeTaggerNetwork_isConnected(self)


    def setTriggerLevel(self, channel: 'int', voltage: 'double') -> "void":
        """setTriggerLevel(self, channel, voltage)"""
        return _TimeTagger.TimeTaggerNetwork_setTriggerLevel(self, channel, voltage)


    def getTriggerLevel(self, channel: 'int') -> "double":
        """getTriggerLevel(self, channel) -> double"""
        return _TimeTagger.TimeTaggerNetwork_getTriggerLevel(self, channel)


    def setConditionalFilter(self, trigger: 'IntVector', filtered: 'IntVector', hardwareDelayCompensation: 'bool'=True) -> "void":
        """setConditionalFilter(self, trigger, filtered, hardwareDelayCompensation=True)"""
        return _TimeTagger.TimeTaggerNetwork_setConditionalFilter(self, trigger, filtered, hardwareDelayCompensation)


    def clearConditionalFilter(self) -> "void":
        """clearConditionalFilter(self)"""
        return _TimeTagger.TimeTaggerNetwork_clearConditionalFilter(self)


    def getConditionalFilterTrigger(self) -> "std::vector< int,std::allocator< int > >":
        """getConditionalFilterTrigger(self) -> IntVector"""
        return _TimeTagger.TimeTaggerNetwork_getConditionalFilterTrigger(self)


    def getConditionalFilterFiltered(self) -> "std::vector< int,std::allocator< int > >":
        """getConditionalFilterFiltered(self) -> IntVector"""
        return _TimeTagger.TimeTaggerNetwork_getConditionalFilterFiltered(self)


    def setTestSignalDivider(self, divider: 'int') -> "void":
        """setTestSignalDivider(self, divider)"""
        return _TimeTagger.TimeTaggerNetwork_setTestSignalDivider(self, divider)


    def getTestSignalDivider(self) -> "int":
        """getTestSignalDivider(self) -> int"""
        return _TimeTagger.TimeTaggerNetwork_getTestSignalDivider(self)


    def getTestSignal(self, channel: 'int') -> "bool":
        """getTestSignal(self, channel) -> bool"""
        return _TimeTagger.TimeTaggerNetwork_getTestSignal(self, channel)


    def setDelayClient(self, channel: 'int', time: 'long long') -> "void":
        """setDelayClient(self, channel, time)"""
        return _TimeTagger.TimeTaggerNetwork_setDelayClient(self, channel, time)


    def getDelayClient(self, channel: 'int') -> "long long":
        """getDelayClient(self, channel) -> long long"""
        return _TimeTagger.TimeTaggerNetwork_getDelayClient(self, channel)


    def getHardwareDelayCompensation(self, channel: 'int') -> "long long":
        """getHardwareDelayCompensation(self, channel) -> long long"""
        return _TimeTagger.TimeTaggerNetwork_getHardwareDelayCompensation(self, channel)


    def setNormalization(self, channels: 'IntVector', state: 'bool') -> "void":
        """setNormalization(self, channels, state)"""
        return _TimeTagger.TimeTaggerNetwork_setNormalization(self, channels, state)


    def getNormalization(self, channel: 'int') -> "bool":
        """getNormalization(self, channel) -> bool"""
        return _TimeTagger.TimeTaggerNetwork_getNormalization(self, channel)


    def setHardwareBufferSize(self, size: 'int') -> "void":
        """setHardwareBufferSize(self, size)"""
        return _TimeTagger.TimeTaggerNetwork_setHardwareBufferSize(self, size)


    def getHardwareBufferSize(self) -> "int":
        """getHardwareBufferSize(self) -> int"""
        return _TimeTagger.TimeTaggerNetwork_getHardwareBufferSize(self)


    def setStreamBlockSize(self, max_events: 'int', max_latency: 'int') -> "void":
        """setStreamBlockSize(self, max_events, max_latency)"""
        return _TimeTagger.TimeTaggerNetwork_setStreamBlockSize(self, max_events, max_latency)


    def getStreamBlockSizeEvents(self) -> "int":
        """getStreamBlockSizeEvents(self) -> int"""
        return _TimeTagger.TimeTaggerNetwork_getStreamBlockSizeEvents(self)


    def getStreamBlockSizeLatency(self) -> "int":
        """getStreamBlockSizeLatency(self) -> int"""
        return _TimeTagger.TimeTaggerNetwork_getStreamBlockSizeLatency(self)


    def setEventDivider(self, channel: 'int', divider: 'unsigned int') -> "void":
        """setEventDivider(self, channel, divider)"""
        return _TimeTagger.TimeTaggerNetwork_setEventDivider(self, channel, divider)


    def getEventDivider(self, channel: 'int') -> "unsigned int":
        """getEventDivider(self, channel) -> unsigned int"""
        return _TimeTagger.TimeTaggerNetwork_getEventDivider(self, channel)


    def getSerial(self) -> "std::string":
        """getSerial(self) -> std::string"""
        return _TimeTagger.TimeTaggerNetwork_getSerial(self)


    def getModel(self) -> "std::string":
        """getModel(self) -> std::string"""
        return _TimeTagger.TimeTaggerNetwork_getModel(self)


    def getChannelNumberScheme(self) -> "int":
        """getChannelNumberScheme(self) -> int"""
        return _TimeTagger.TimeTaggerNetwork_getChannelNumberScheme(self)


    def getDACRange(self) -> "std::vector< double,std::allocator< double > >":
        """getDACRange(self) -> DoubleVector"""
        return _TimeTagger.TimeTaggerNetwork_getDACRange(self)


    def getChannelList(self, *args, **kwargs) -> "std::vector< int,std::allocator< int > >":
        """getChannelList(self, type) -> IntVector"""
        return _TimeTagger.TimeTaggerNetwork_getChannelList(self, *args, **kwargs)


    def getPsPerClock(self) -> "long long":
        """getPsPerClock(self) -> long long"""
        return _TimeTagger.TimeTaggerNetwork_getPsPerClock(self)


    def getPcbVersion(self) -> "std::string":
        """getPcbVersion(self) -> std::string"""
        return _TimeTagger.TimeTaggerNetwork_getPcbVersion(self)


    def getFirmwareVersion(self) -> "std::string":
        """getFirmwareVersion(self) -> std::string"""
        return _TimeTagger.TimeTaggerNetwork_getFirmwareVersion(self)


    def __getSensorData(self) -> "std::string":
        """__getSensorData(self) -> std::string"""
        return _TimeTagger.TimeTaggerNetwork___getSensorData(self)


    def setLED(self, bitmask: 'uint32_t') -> "void":
        """setLED(self, bitmask)"""
        return _TimeTagger.TimeTaggerNetwork_setLED(self, bitmask)


    def __getDeviceLicense(self) -> "std::string":
        """__getDeviceLicense(self) -> std::string"""
        return _TimeTagger.TimeTaggerNetwork___getDeviceLicense(self)


    def setSoundFrequency(self, freq_hz: 'uint32_t') -> "void":
        """setSoundFrequency(self, freq_hz)"""
        return _TimeTagger.TimeTaggerNetwork_setSoundFrequency(self, freq_hz)


    def setTimeTaggerNetworkStreamCompression(self, active: 'bool') -> "void":
        """setTimeTaggerNetworkStreamCompression(self, active)"""
        return _TimeTagger.TimeTaggerNetwork_setTimeTaggerNetworkStreamCompression(self, active)


    def getOverflowsClient(self) -> "long long":
        """getOverflowsClient(self) -> long long"""
        return _TimeTagger.TimeTaggerNetwork_getOverflowsClient(self)


    def clearOverflowsClient(self) -> "void":
        """clearOverflowsClient(self)"""
        return _TimeTagger.TimeTaggerNetwork_clearOverflowsClient(self)


    def getOverflowsAndClearClient(self) -> "long long":
        """getOverflowsAndClearClient(self) -> long long"""
        return _TimeTagger.TimeTaggerNetwork_getOverflowsAndClearClient(self)


    def setInputImpedanceHigh(self, channel: 'int', high_impedance: 'bool') -> "void":
        """setInputImpedanceHigh(self, channel, high_impedance)"""
        return _TimeTagger.TimeTaggerNetwork_setInputImpedanceHigh(self, channel, high_impedance)


    def getInputImpedanceHigh(self, channel: 'int') -> "bool":
        """getInputImpedanceHigh(self, channel) -> bool"""
        return _TimeTagger.TimeTaggerNetwork_getInputImpedanceHigh(self, channel)


    def setInputHysteresis(self, channel: 'int', value: 'int') -> "void":
        """setInputHysteresis(self, channel, value)"""
        return _TimeTagger.TimeTaggerNetwork_setInputHysteresis(self, channel, value)


    def getInputHysteresis(self, channel: 'int') -> "int":
        """getInputHysteresis(self, channel) -> int"""
        return _TimeTagger.TimeTaggerNetwork_getInputHysteresis(self, channel)


    def getDeviceLicense(self, *args, **kargs):
        r"""getDeviceLicense(...) -> json"""
        import json
        return json.loads(self.__getDeviceLicense(*args, **kargs))


    def getSensorData(self, *args, **kargs):
        r"""getSensorData(...) -> json"""
        import json
        return json.loads(self.__getSensorData(*args, **kargs))

    __swig_destroy__ = _TimeTagger.delete_TimeTaggerNetwork
    __del__ = lambda self: None
TimeTaggerNetwork_swigregister = _TimeTagger.TimeTaggerNetwork_swigregister
TimeTaggerNetwork_swigregister(TimeTaggerNetwork)

class TimeTagger(TimeTaggerBase):
    """Proxy of C++ TimeTagger class."""

    __swig_setmethods__ = {}
    for _s in [TimeTaggerBase]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, TimeTagger, name, value)
    __swig_getmethods__ = {}
    for _s in [TimeTaggerBase]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, TimeTagger, name)

    def __init__(self, *args, **kwargs):
        raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr

    def reset(self) -> "void":
        """reset(self)"""
        return _TimeTagger.TimeTagger_reset(self)


    def isChannelRegistered(self, chan: 'int') -> "bool":
        """isChannelRegistered(self, chan) -> bool"""
        return _TimeTagger.TimeTagger_isChannelRegistered(self, chan)


    def setTestSignalDivider(self, divider: 'int') -> "void":
        """setTestSignalDivider(self, divider)"""
        return _TimeTagger.TimeTagger_setTestSignalDivider(self, divider)


    def getTestSignalDivider(self) -> "int":
        """getTestSignalDivider(self) -> int"""
        return _TimeTagger.TimeTagger_getTestSignalDivider(self)


    def xtra_setAuxOutSignal(self, channel: 'int', divider: 'int', duty_cycle: 'double'=0.5) -> "void":
        """xtra_setAuxOutSignal(self, channel, divider, duty_cycle=0.5)"""
        return _TimeTagger.TimeTagger_xtra_setAuxOutSignal(self, channel, divider, duty_cycle)


    def xtra_getAuxOutSignalDivider(self, channel: 'int') -> "int":
        """xtra_getAuxOutSignalDivider(self, channel) -> int"""
        return _TimeTagger.TimeTagger_xtra_getAuxOutSignalDivider(self, channel)


    def xtra_getAuxOutSignalDutyCycle(self, channel: 'int') -> "double":
        """xtra_getAuxOutSignalDutyCycle(self, channel) -> double"""
        return _TimeTagger.TimeTagger_xtra_getAuxOutSignalDutyCycle(self, channel)


    def xtra_setAuxOut(self, channel: 'int', enabled: 'bool') -> "void":
        """xtra_setAuxOut(self, channel, enabled)"""
        return _TimeTagger.TimeTagger_xtra_setAuxOut(self, channel, enabled)


    def xtra_getAuxOut(self, channel: 'int') -> "bool":
        """xtra_getAuxOut(self, channel) -> bool"""
        return _TimeTagger.TimeTagger_xtra_getAuxOut(self, channel)


    def setTriggerLevel(self, channel: 'int', voltage: 'double') -> "void":
        """setTriggerLevel(self, channel, voltage)"""
        return _TimeTagger.TimeTagger_setTriggerLevel(self, channel, voltage)


    def getTriggerLevel(self, channel: 'int') -> "double":
        """getTriggerLevel(self, channel) -> double"""
        return _TimeTagger.TimeTagger_getTriggerLevel(self, channel)


    def xtra_measureTriggerLevel(self, channel: 'int') -> "double":
        """xtra_measureTriggerLevel(self, channel) -> double"""
        return _TimeTagger.TimeTagger_xtra_measureTriggerLevel(self, channel)


    def getHardwareDelayCompensation(self, channel: 'int') -> "long long":
        """getHardwareDelayCompensation(self, channel) -> long long"""
        return _TimeTagger.TimeTagger_getHardwareDelayCompensation(self, channel)


    def setInputMux(self, channel: 'int', mux_mode: 'int') -> "void":
        """setInputMux(self, channel, mux_mode)"""
        return _TimeTagger.TimeTagger_setInputMux(self, channel, mux_mode)


    def getInputMux(self, channel: 'int') -> "int":
        """getInputMux(self, channel) -> int"""
        return _TimeTagger.TimeTagger_getInputMux(self, channel)


    def setConditionalFilter(self, trigger: 'IntVector', filtered: 'IntVector', hardwareDelayCompensation: 'bool'=True) -> "void":
        """setConditionalFilter(self, trigger, filtered, hardwareDelayCompensation=True)"""
        return _TimeTagger.TimeTagger_setConditionalFilter(self, trigger, filtered, hardwareDelayCompensation)


    def clearConditionalFilter(self) -> "void":
        """clearConditionalFilter(self)"""
        return _TimeTagger.TimeTagger_clearConditionalFilter(self)


    def getConditionalFilterTrigger(self) -> "std::vector< int,std::allocator< int > >":
        """getConditionalFilterTrigger(self) -> IntVector"""
        return _TimeTagger.TimeTagger_getConditionalFilterTrigger(self)


    def getConditionalFilterFiltered(self) -> "std::vector< int,std::allocator< int > >":
        """getConditionalFilterFiltered(self) -> IntVector"""
        return _TimeTagger.TimeTagger_getConditionalFilterFiltered(self)


    def setNormalization(self, channels: 'IntVector', state: 'bool') -> "void":
        """setNormalization(self, channels, state)"""
        return _TimeTagger.TimeTagger_setNormalization(self, channels, state)


    def getNormalization(self, channel: 'int') -> "bool":
        """getNormalization(self, channel) -> bool"""
        return _TimeTagger.TimeTagger_getNormalization(self, channel)


    def setHardwareBufferSize(self, size: 'int') -> "void":
        """setHardwareBufferSize(self, size)"""
        return _TimeTagger.TimeTagger_setHardwareBufferSize(self, size)


    def getHardwareBufferSize(self) -> "int":
        """getHardwareBufferSize(self) -> int"""
        return _TimeTagger.TimeTagger_getHardwareBufferSize(self)


    def setStreamBlockSize(self, max_events: 'int', max_latency: 'int') -> "void":
        """setStreamBlockSize(self, max_events, max_latency)"""
        return _TimeTagger.TimeTagger_setStreamBlockSize(self, max_events, max_latency)


    def getStreamBlockSizeEvents(self) -> "int":
        """getStreamBlockSizeEvents(self) -> int"""
        return _TimeTagger.TimeTagger_getStreamBlockSizeEvents(self)


    def getStreamBlockSizeLatency(self) -> "int":
        """getStreamBlockSizeLatency(self) -> int"""
        return _TimeTagger.TimeTagger_getStreamBlockSizeLatency(self)


    def setEventDivider(self, channel: 'int', divider: 'unsigned int') -> "void":
        """setEventDivider(self, channel, divider)"""
        return _TimeTagger.TimeTagger_setEventDivider(self, channel, divider)


    def getEventDivider(self, channel: 'int') -> "unsigned int":
        """getEventDivider(self, channel) -> unsigned int"""
        return _TimeTagger.TimeTagger_getEventDivider(self, channel)


    def autoCalibration(self) -> "void":
        """autoCalibration(self)"""
        return _TimeTagger.TimeTagger_autoCalibration(self)


    def getSerial(self) -> "std::string":
        """getSerial(self) -> std::string"""
        return _TimeTagger.TimeTagger_getSerial(self)


    def getModel(self) -> "std::string":
        """getModel(self) -> std::string"""
        return _TimeTagger.TimeTagger_getModel(self)


    def getChannelNumberScheme(self) -> "int":
        """getChannelNumberScheme(self) -> int"""
        return _TimeTagger.TimeTagger_getChannelNumberScheme(self)


    def getDACRange(self) -> "std::vector< double,std::allocator< double > >":
        """getDACRange(self) -> DoubleVector"""
        return _TimeTagger.TimeTagger_getDACRange(self)


    def getDistributionCount(self) -> "void":
        """getDistributionCount(self)"""
        return _TimeTagger.TimeTagger_getDistributionCount(self)


    def getDistributionPSecs(self) -> "void":
        """getDistributionPSecs(self)"""
        return _TimeTagger.TimeTagger_getDistributionPSecs(self)


    def getChannelList(self, *args, **kwargs) -> "std::vector< int,std::allocator< int > >":
        """getChannelList(self, type) -> IntVector"""
        return _TimeTagger.TimeTagger_getChannelList(self, *args, **kwargs)


    def getPsPerClock(self) -> "long long":
        """getPsPerClock(self) -> long long"""
        return _TimeTagger.TimeTagger_getPsPerClock(self)


    def getPcbVersion(self) -> "std::string":
        """getPcbVersion(self) -> std::string"""
        return _TimeTagger.TimeTagger_getPcbVersion(self)


    def getFirmwareVersion(self) -> "std::string":
        """getFirmwareVersion(self) -> std::string"""
        return _TimeTagger.TimeTagger_getFirmwareVersion(self)


    def xtra_setClockSource(self, source: 'int') -> "void":
        """xtra_setClockSource(self, source)"""
        return _TimeTagger.TimeTagger_xtra_setClockSource(self, source)


    def xtra_getClockSource(self) -> "int":
        """xtra_getClockSource(self) -> int"""
        return _TimeTagger.TimeTagger_xtra_getClockSource(self)


    def xtra_setClockAutoSelect(self, enabled: 'bool') -> "void":
        """xtra_setClockAutoSelect(self, enabled)"""
        return _TimeTagger.TimeTagger_xtra_setClockAutoSelect(self, enabled)


    def xtra_getClockAutoSelect(self) -> "bool":
        """xtra_getClockAutoSelect(self) -> bool"""
        return _TimeTagger.TimeTagger_xtra_getClockAutoSelect(self)


    def xtra_setClockOut(self, enabled: 'bool') -> "void":
        """xtra_setClockOut(self, enabled)"""
        return _TimeTagger.TimeTagger_xtra_setClockOut(self, enabled)


    def __getSensorData(self) -> "std::string":
        """__getSensorData(self) -> std::string"""
        return _TimeTagger.TimeTagger___getSensorData(self)


    def setLED(self, bitmask: 'uint32_t') -> "void":
        """setLED(self, bitmask)"""
        return _TimeTagger.TimeTagger_setLED(self, bitmask)


    def disableLEDs(self, disabled: 'bool') -> "void":
        """disableLEDs(self, disabled)"""
        return _TimeTagger.TimeTagger_disableLEDs(self, disabled)


    def __getDeviceLicense(self) -> "std::string":
        """__getDeviceLicense(self) -> std::string"""
        return _TimeTagger.TimeTagger___getDeviceLicense(self)


    def factoryAccess(self, pw: 'uint32_t', addr: 'uint32_t', data: 'uint32_t', mask: 'uint32_t', use_wb: 'bool'=False) -> "uint32_t":
        """factoryAccess(self, pw, addr, data, mask, use_wb=False) -> uint32_t"""
        return _TimeTagger.TimeTagger_factoryAccess(self, pw, addr, data, mask, use_wb)


    def setSoundFrequency(self, freq_hz: 'uint32_t') -> "void":
        """setSoundFrequency(self, freq_hz)"""
        return _TimeTagger.TimeTagger_setSoundFrequency(self, freq_hz)


    def startServer(self, *args, **kwargs) -> "void":
        """startServer(self, access_mode, channels, port=41101)"""
        return _TimeTagger.TimeTagger_startServer(self, *args, **kwargs)


    def isServerRunning(self) -> "bool":
        """isServerRunning(self) -> bool"""
        return _TimeTagger.TimeTagger_isServerRunning(self)


    def stopServer(self) -> "void":
        """stopServer(self)"""
        return _TimeTagger.TimeTagger_stopServer(self)


    def setTimeTaggerNetworkStreamCompression(self, active: 'bool') -> "void":
        """setTimeTaggerNetworkStreamCompression(self, active)"""
        return _TimeTagger.TimeTagger_setTimeTaggerNetworkStreamCompression(self, active)


    def setInputImpedanceHigh(self, channel: 'int', high_impedance: 'bool') -> "void":
        """setInputImpedanceHigh(self, channel, high_impedance)"""
        return _TimeTagger.TimeTagger_setInputImpedanceHigh(self, channel, high_impedance)


    def getInputImpedanceHigh(self, channel: 'int') -> "bool":
        """getInputImpedanceHigh(self, channel) -> bool"""
        return _TimeTagger.TimeTagger_getInputImpedanceHigh(self, channel)


    def setInputHysteresis(self, channel: 'int', value: 'int') -> "void":
        """setInputHysteresis(self, channel, value)"""
        return _TimeTagger.TimeTagger_setInputHysteresis(self, channel, value)


    def getInputHysteresis(self, channel: 'int') -> "int":
        """getInputHysteresis(self, channel) -> int"""
        return _TimeTagger.TimeTagger_getInputHysteresis(self, channel)


    def getDeviceLicense(self, *args, **kargs):
        r"""getDeviceLicense(...) -> json"""
        import json
        return json.loads(self.__getDeviceLicense(*args, **kargs))


    def getSensorData(self, *args, **kargs):
        r"""getSensorData(...) -> json"""
        import json
        return json.loads(self.__getSensorData(*args, **kargs))

    __swig_destroy__ = _TimeTagger.delete_TimeTagger
    __del__ = lambda self: None
TimeTagger_swigregister = _TimeTagger.TimeTagger_swigregister
TimeTagger_swigregister(TimeTagger)

class Tag(_object):
    """Proxy of C++ Tag class."""

    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, Tag, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, Tag, name)
    __repr__ = _swig_repr
    Type_TimeTag = _TimeTagger.Tag_Type_TimeTag
    Type_Error = _TimeTagger.Tag_Type_Error
    Type_OverflowBegin = _TimeTagger.Tag_Type_OverflowBegin
    Type_OverflowEnd = _TimeTagger.Tag_Type_OverflowEnd
    Type_MissedEvents = _TimeTagger.Tag_Type_MissedEvents
    __swig_setmethods__["type"] = _TimeTagger.Tag_type_set
    __swig_getmethods__["type"] = _TimeTagger.Tag_type_get
    if _newclass:
        type = _swig_property(_TimeTagger.Tag_type_get, _TimeTagger.Tag_type_set)
    __swig_setmethods__["reserved"] = _TimeTagger.Tag_reserved_set
    __swig_getmethods__["reserved"] = _TimeTagger.Tag_reserved_get
    if _newclass:
        reserved = _swig_property(_TimeTagger.Tag_reserved_get, _TimeTagger.Tag_reserved_set)
    __swig_setmethods__["missed_events"] = _TimeTagger.Tag_missed_events_set
    __swig_getmethods__["missed_events"] = _TimeTagger.Tag_missed_events_get
    if _newclass:
        missed_events = _swig_property(_TimeTagger.Tag_missed_events_get, _TimeTagger.Tag_missed_events_set)
    __swig_setmethods__["channel"] = _TimeTagger.Tag_channel_set
    __swig_getmethods__["channel"] = _TimeTagger.Tag_channel_get
    if _newclass:
        channel = _swig_property(_TimeTagger.Tag_channel_get, _TimeTagger.Tag_channel_set)
    __swig_setmethods__["time"] = _TimeTagger.Tag_time_set
    __swig_getmethods__["time"] = _TimeTagger.Tag_time_get
    if _newclass:
        time = _swig_property(_TimeTagger.Tag_time_get, _TimeTagger.Tag_time_set)

    def __init__(self):
        """__init__(self) -> Tag"""
        this = _TimeTagger.new_Tag()
        try:
            self.this.append(this)
        except __builtin__.Exception:
            self.this = this
    __swig_destroy__ = _TimeTagger.delete_Tag
    __del__ = lambda self: None
Tag_swigregister = _TimeTagger.Tag_swigregister
Tag_swigregister(Tag)

class IteratorBase(_object):
    """Proxy of C++ IteratorBase class."""

    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, IteratorBase, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, IteratorBase, name)

    def __init__(self, *args, **kwargs):
        raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _TimeTagger.delete_IteratorBase
    __del__ = lambda self: None

    def start(self) -> "void":
        """start(self)"""
        return _TimeTagger.IteratorBase_start(self)


    def startFor(self, capture_duration: 'long long', clear: 'bool'=True) -> "void":
        """startFor(self, capture_duration, clear=True)"""
        return _TimeTagger.IteratorBase_startFor(self, capture_duration, clear)


    def __waitUntilFinished(self, timeout: 'int64_t'=-1) -> "bool":
        """__waitUntilFinished(self, timeout=-1) -> bool"""
        return _TimeTagger.IteratorBase___waitUntilFinished(self, timeout)


    def stop(self) -> "void":
        """stop(self)"""
        return _TimeTagger.IteratorBase_stop(self)


    def clear(self) -> "void":
        """clear(self)"""
        return _TimeTagger.IteratorBase_clear(self)


    def isRunning(self) -> "bool":
        """isRunning(self) -> bool"""
        return _TimeTagger.IteratorBase_isRunning(self)


    def getCaptureDuration(self) -> "long long":
        """getCaptureDuration(self) -> long long"""
        return _TimeTagger.IteratorBase_getCaptureDuration(self)


    def __getConfiguration(self) -> "std::string":
        """__getConfiguration(self) -> std::string"""
        return _TimeTagger.IteratorBase___getConfiguration(self)


    def waitUntilFinished(self, timeout=-1):
        r"""waitUntilFinished(self, timeout=-1) -> bool"""
        return _timeout_handler(self.__waitUntilFinished, timeout)


    def getConfiguration(self, *args, **kargs):
        r"""getConfiguration(...) -> json"""
        import json
        return json.loads(self.__getConfiguration(*args, **kargs))


    def __enter__(self):
        return self

    def __exit__(self, type, value, tb):
        if self.thisown:
            self.__swig_destroy__(self)
            self.this = None
        return False

IteratorBase_swigregister = _TimeTagger.IteratorBase_swigregister
IteratorBase_swigregister(IteratorBase)

LanguageUsed_Cpp = _TimeTagger.LanguageUsed_Cpp
LanguageUsed_Python = _TimeTagger.LanguageUsed_Python
LanguageUsed_Csharp = _TimeTagger.LanguageUsed_Csharp
LanguageUsed_Matlab = _TimeTagger.LanguageUsed_Matlab
LanguageUsed_Labview = _TimeTagger.LanguageUsed_Labview
LanguageUsed_Mathematica = _TimeTagger.LanguageUsed_Mathematica
LanguageUsed_Unknown = _TimeTagger.LanguageUsed_Unknown
FrontendType_Undefined = _TimeTagger.FrontendType_Undefined
FrontendType_WebApp = _TimeTagger.FrontendType_WebApp
FrontendType_Firefly = _TimeTagger.FrontendType_Firefly
FrontendType_Pyro5RPC = _TimeTagger.FrontendType_Pyro5RPC
FrontendType_UserFrontend = _TimeTagger.FrontendType_UserFrontend

def setLanguageInfo(pw: 'std::uint32_t', language: 'LanguageUsed', version: 'std::string') -> "void":
    """setLanguageInfo(pw, language, version)"""
    return _TimeTagger.setLanguageInfo(pw, language, version)

def setFrontend(frontend: 'FrontendType') -> "void":
    """setFrontend(frontend)"""
    return _TimeTagger.setFrontend(frontend)
UsageStatisticsStatus_Disabled = _TimeTagger.UsageStatisticsStatus_Disabled
UsageStatisticsStatus_Collecting = _TimeTagger.UsageStatisticsStatus_Collecting
UsageStatisticsStatus_CollectingAndUploading = _TimeTagger.UsageStatisticsStatus_CollectingAndUploading

def setUsageStatisticsStatus(new_status: 'UsageStatisticsStatus') -> "void":
    """setUsageStatisticsStatus(new_status)"""
    return _TimeTagger.setUsageStatisticsStatus(new_status)

def getUsageStatisticsStatus() -> "UsageStatisticsStatus":
    """getUsageStatisticsStatus() -> UsageStatisticsStatus"""
    return _TimeTagger.getUsageStatisticsStatus()

def getUsageStatisticsReport() -> "std::string":
    """getUsageStatisticsReport() -> std::string"""
    return _TimeTagger.getUsageStatisticsReport()

def mergeStreamFiles(output_filename: 'std::string const &', input_filenames: 'StringVector', channel_offsets: 'IntVector', time_offsets: 'LongLongVector', overlap_only: 'bool') -> "void":
    """mergeStreamFiles(output_filename, input_filenames, channel_offsets, time_offsets, overlap_only)"""
    return _TimeTagger.mergeStreamFiles(output_filename, input_filenames, channel_offsets, time_offsets, overlap_only)
class Combiner(IteratorBase):
    """Proxy of C++ Combiner class."""

    __swig_setmethods__ = {}
    for _s in [IteratorBase]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Combiner, name, value)
    __swig_getmethods__ = {}
    for _s in [IteratorBase]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, Combiner, name)
    __repr__ = _swig_repr

    def __init__(self, tagger: 'TimeTaggerBase', channels: 'IntVector'):
        """__init__(self, tagger, channels) -> Combiner"""
        this = _TimeTagger.new_Combiner(tagger, channels)
        try:
            self.this.append(this)
        except __builtin__.Exception:
            self.this = this
    __swig_destroy__ = _TimeTagger.delete_Combiner
    __del__ = lambda self: None

    def getChannelCounts(self) -> "void":
        """getChannelCounts(self)"""
        return _TimeTagger.Combiner_getChannelCounts(self)


    def getData(self) -> "void":
        """getData(self)"""
        return _TimeTagger.Combiner_getData(self)


    def getChannel(self) -> "int":
        """getChannel(self) -> int"""
        return _TimeTagger.Combiner_getChannel(self)

Combiner_swigregister = _TimeTagger.Combiner_swigregister
Combiner_swigregister(Combiner)

class CountBetweenMarkers(IteratorBase):
    """Proxy of C++ CountBetweenMarkers class."""

    __swig_setmethods__ = {}
    for _s in [IteratorBase]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, CountBetweenMarkers, name, value)
    __swig_getmethods__ = {}
    for _s in [IteratorBase]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, CountBetweenMarkers, name)
    __repr__ = _swig_repr

    def __init__(self, *args, **kwargs):
        """__init__(self, tagger, click_channel, begin_channel, end_channel, n_values=1000) -> CountBetweenMarkers"""
        this = _TimeTagger.new_CountBetweenMarkers(*args, **kwargs)
        try:
            self.this.append(this)
        except __builtin__.Exception:
            self.this = this
    __swig_destroy__ = _TimeTagger.delete_CountBetweenMarkers
    __del__ = lambda self: None

    def ready(self) -> "bool":
        """ready(self) -> bool"""
        return _TimeTagger.CountBetweenMarkers_ready(self)


    def getData(self) -> "void":
        """getData(self)"""
        return _TimeTagger.CountBetweenMarkers_getData(self)


    def getBinWidths(self) -> "void":
        """getBinWidths(self)"""
        return _TimeTagger.CountBetweenMarkers_getBinWidths(self)


    def getIndex(self) -> "void":
        """getIndex(self)"""
        return _TimeTagger.CountBetweenMarkers_getIndex(self)

CountBetweenMarkers_swigregister = _TimeTagger.CountBetweenMarkers_swigregister
CountBetweenMarkers_swigregister(CountBetweenMarkers)

class CounterData(_object):
    """Proxy of C++ CounterData class."""

    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, CounterData, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, CounterData, name)

    def __init__(self, *args, **kwargs):
        raise AttributeError("No constructor defined")
    __repr__ = _swig_repr
    __swig_destroy__ = _TimeTagger.delete_CounterData
    __del__ = lambda self: None

    def getData(self) -> "void":
        """getData(self)"""
        return _TimeTagger.CounterData_getData(self)


    def getDataNormalized(self) -> "void":
        """getDataNormalized(self)"""
        return _TimeTagger.CounterData_getDataNormalized(self)


    def getDataTotalCounts(self) -> "void":
        """getDataTotalCounts(self)"""
        return _TimeTagger.CounterData_getDataTotalCounts(self)


    def getIndex(self) -> "void":
        """getIndex(self)"""
        return _TimeTagger.CounterData_getIndex(self)


    def getTime(self) -> "void":
        """getTime(self)"""
        return _TimeTagger.CounterData_getTime(self)


    def getOverflowMask(self) -> "void":
        """getOverflowMask(self)"""
        return _TimeTagger.CounterData_getOverflowMask(self)


    def getChannels(self) -> "void":
        """getChannels(self)"""
        return _TimeTagger.CounterData_getChannels(self)

    __swig_getmethods__["size"] = _TimeTagger.CounterData_size_get
    if _newclass:
        size = _swig_property(_TimeTagger.CounterData_size_get)
    __swig_getmethods__["dropped_bins"] = _TimeTagger.CounterData_dropped_bins_get
    if _newclass:
        dropped_bins = _swig_property(_TimeTagger.CounterData_dropped_bins_get)
    __swig_getmethods__["overflow"] = _TimeTagger.CounterData_overflow_get
    if _newclass:
        overflow = _swig_property(_TimeTagger.CounterData_overflow_get)

    def __enter__(self):
        return self

    def __exit__(self, type, value, tb):
        if self.thisown:
            self.__swig_destroy__(self)
            self.this = None
        return False

CounterData_swigregister = _TimeTagger.CounterData_swigregister
CounterData_swigregister(CounterData)

class Counter(IteratorBase):
    """Proxy of C++ Counter class."""

    __swig_setmethods__ = {}
    for _s in [IteratorBase]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Counter, name, value)
    __swig_getmethods__ = {}
    for _s in [IteratorBase]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, Counter, name)
    __repr__ = _swig_repr

    def __init__(self, tagger: 'TimeTaggerBase', channels: 'IntVector', binwidth: 'long long'=1000000000, n_values: 'int32_t'=1):
        """__init__(self, tagger, channels, binwidth=1000000000, n_values=1) -> Counter"""
        this = _TimeTagger.new_Counter(tagger, channels, binwidth, n_values)
        try:
            self.this.append(this)
        except __builtin__.Exception:
            self.this = this
    __swig_destroy__ = _TimeTagger.delete_Counter
    __del__ = lambda self: None

    def getData(self, rolling: 'bool'=True) -> "void":
        """getData(self, rolling=True)"""
        return _TimeTagger.Counter_getData(self, rolling)


    def getDataNormalized(self, rolling: 'bool'=True) -> "void":
        """getDataNormalized(self, rolling=True)"""
        return _TimeTagger.Counter_getDataNormalized(self, rolling)


    def getDataTotalCounts(self) -> "void":
        """getDataTotalCounts(self)"""
        return _TimeTagger.Counter_getDataTotalCounts(self)


    def getIndex(self) -> "void":
        """getIndex(self)"""
        return _TimeTagger.Counter_getIndex(self)


    def getDataObject(self, remove: 'bool'=False) -> "CounterData":
        """getDataObject(self, remove=False) -> CounterData"""
        return _TimeTagger.Counter_getDataObject(self, remove)

Counter_swigregister = _TimeTagger.Counter_swigregister
Counter_swigregister(Counter)

CoincidenceTimestamp_Last = _TimeTagger.CoincidenceTimestamp_Last
CoincidenceTimestamp_Average = _TimeTagger.CoincidenceTimestamp_Average
CoincidenceTimestamp_First = _TimeTagger.CoincidenceTimestamp_First
CoincidenceTimestamp_ListedFirst = _TimeTagger.CoincidenceTimestamp_ListedFirst
class Coincidences(IteratorBase):
    """Proxy of C++ Coincidences class."""

    __swig_setmethods__ = {}
    for _s in [IteratorBase]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Coincidences, name, value)
    __swig_getmethods__ = {}
    for _s in [IteratorBase]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, Coincidences, name)
    __repr__ = _swig_repr

    def __init__(self, *args, **kwargs):
        """__init__(self, tagger, coincidenceGroups, coincidenceWindow, timestamp) -> Coincidences"""
        this = _TimeTagger.new_Coincidences(*args, **kwargs)
        try:
            self.this.append(this)
        except __builtin__.Exception:
            self.this = this
    __swig_destroy__ = _TimeTagger.delete_Coincidences
    __del__ = lambda self: None

    def getChannels(self) -> "std::vector< int,std::allocator< int > >":
        """getChannels(self) -> IntVector"""
        return _TimeTagger.Coincidences_getChannels(self)


    def setCoincidenceWindow(self, coincidenceWindow: 'long long') -> "void":
        """setCoincidenceWindow(self, coincidenceWindow)"""
        return _TimeTagger.Coincidences_setCoincidenceWindow(self, coincidenceWindow)

Coincidences_swigregister = _TimeTagger.Coincidences_swigregister
Coincidences_swigregister(Coincidences)

class Coincidence(Coincidences):
    """Proxy of C++ Coincidence class."""

    __swig_setmethods__ = {}
    for _s in [Coincidences]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Coincidence, name, value)
    __swig_getmethods__ = {}
    for _s in [Coincidences]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, Coincidence, name)
    __repr__ = _swig_repr

    def __init__(self, *args, **kwargs):
        """__init__(self, tagger, channels, coincidenceWindow=1000, timestamp) -> Coincidence"""
        this = _TimeTagger.new_Coincidence(*args, **kwargs)
        try:
            self.this.append(this)
        except __builtin__.Exception:
            self.this = this

    def getChannel(self) -> "int":
        """getChannel(self) -> int"""
        return _TimeTagger.Coincidence_getChannel(self)

    __swig_destroy__ = _TimeTagger.delete_Coincidence
    __del__ = lambda self: None
Coincidence_swigregister = _TimeTagger.Coincidence_swigregister
Coincidence_swigregister(Coincidence)

class Countrate(IteratorBase):
    """Proxy of C++ Countrate class."""

    __swig_setmethods__ = {}
    for _s in [IteratorBase]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Countrate, name, value)
    __swig_getmethods__ = {}
    for _s in [IteratorBase]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, Countrate, name)
    __repr__ = _swig_repr

    def __init__(self, tagger: 'TimeTaggerBase', channels: 'IntVector'):
        """__init__(self, tagger, channels) -> Countrate"""
        this = _TimeTagger.new_Countrate(tagger, channels)
        try:
            self.this.append(this)
        except __builtin__.Exception:
            self.this = this
    __swig_destroy__ = _TimeTagger.delete_Countrate
    __del__ = lambda self: None

    def getData(self) -> "void":
        """getData(self)"""
        return _TimeTagger.Countrate_getData(self)


    def getCountsTotal(self) -> "void":
        """getCountsTotal(self)"""
        return _TimeTagger.Countrate_getCountsTotal(self)

Countrate_swigregister = _TimeTagger.Countrate_swigregister
Countrate_swigregister(Countrate)

class DelayedChannel(IteratorBase):
    """Proxy of C++ DelayedChannel class."""

    __swig_setmethods__ = {}
    for _s in [IteratorBase]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, DelayedChannel, name, value)
    __swig_getmethods__ = {}
    for _s in [IteratorBase]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, DelayedChannel, name)
    __repr__ = _swig_repr

    def __init__(self, tagger: 'TimeTaggerBase', input_channel: 'int', delay: 'long long'):
        """__init__(self, tagger, input_channel, delay) -> DelayedChannel"""
        this = _TimeTagger.new_DelayedChannel(tagger, input_channel, delay)
        try:
            self.this.append(this)
        except __builtin__.Exception:
            self.this = this
    __swig_destroy__ = _TimeTagger.delete_DelayedChannel
    __del__ = lambda self: None

    def getChannel(self) -> "int":
        """getChannel(self) -> int"""
        return _TimeTagger.DelayedChannel_getChannel(self)


    def setDelay(self, delay: 'long long') -> "void":
        """setDelay(self, delay)"""
        return _TimeTagger.DelayedChannel_setDelay(self, delay)

DelayedChannel_swigregister = _TimeTagger.DelayedChannel_swigregister
DelayedChannel_swigregister(DelayedChannel)

class TriggerOnCountrate(IteratorBase):
    """Proxy of C++ TriggerOnCountrate class."""

    __swig_setmethods__ = {}
    for _s in [IteratorBase]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, TriggerOnCountrate, name, value)
    __swig_getmethods__ = {}
    for _s in [IteratorBase]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, TriggerOnCountrate, name)
    __repr__ = _swig_repr

    def __init__(self, tagger: 'TimeTaggerBase', input_channel: 'int', reference_countrate: 'double', hysteresis: 'double', time_window: 'long long'):
        """__init__(self, tagger, input_channel, reference_countrate, hysteresis, time_window) -> TriggerOnCountrate"""
        this = _TimeTagger.new_TriggerOnCountrate(tagger, input_channel, reference_countrate, hysteresis, time_window)
        try:
            self.this.append(this)
        except __builtin__.Exception:
            self.this = this
    __swig_destroy__ = _TimeTagger.delete_TriggerOnCountrate
    __del__ = lambda self: None

    def getChannelAbove(self) -> "int":
        """getChannelAbove(self) -> int"""
        return _TimeTagger.TriggerOnCountrate_getChannelAbove(self)


    def getChannelBelow(self) -> "int":
        """getChannelBelow(self) -> int"""
        return _TimeTagger.TriggerOnCountrate_getChannelBelow(self)


    def getChannels(self) -> "std::vector< int,std::allocator< int > >":
        """getChannels(self) -> IntVector"""
        return _TimeTagger.TriggerOnCountrate_getChannels(self)


    def isAbove(self) -> "bool":
        """isAbove(self) -> bool"""
        return _TimeTagger.TriggerOnCountrate_isAbove(self)


    def isBelow(self) -> "bool":
        """isBelow(self) -> bool"""
        return _TimeTagger.TriggerOnCountrate_isBelow(self)


    def getCurrentCountrate(self) -> "double":
        """getCurrentCountrate(self) -> double"""
        return _TimeTagger.TriggerOnCountrate_getCurrentCountrate(self)


    def injectCurrentState(self) -> "bool":
        """injectCurrentState(self) -> bool"""
        return _TimeTagger.TriggerOnCountrate_injectCurrentState(self)

TriggerOnCountrate_swigregister = _TimeTagger.TriggerOnCountrate_swigregister
TriggerOnCountrate_swigregister(TriggerOnCountrate)

GatedChannelInitial_Closed = _TimeTagger.GatedChannelInitial_Closed
GatedChannelInitial_Open = _TimeTagger.GatedChannelInitial_Open
class GatedChannel(IteratorBase):
    """Proxy of C++ GatedChannel class."""

    __swig_setmethods__ = {}
    for _s in [IteratorBase]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, GatedChannel, name, value)
    __swig_getmethods__ = {}
    for _s in [IteratorBase]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, GatedChannel, name)
    __repr__ = _swig_repr

    def __init__(self, *args, **kwargs):
        """__init__(self, tagger, input_channel, gate_start_channel, gate_stop_channel, initial) -> GatedChannel"""
        this = _TimeTagger.new_GatedChannel(*args, **kwargs)
        try:
            self.this.append(this)
        except __builtin__.Exception:
            self.this = this
    __swig_destroy__ = _TimeTagger.delete_GatedChannel
    __del__ = lambda self: None

    def getChannel(self) -> "int":
        """getChannel(self) -> int"""
        return _TimeTagger.GatedChannel_getChannel(self)

GatedChannel_swigregister = _TimeTagger.GatedChannel_swigregister
GatedChannel_swigregister(GatedChannel)

class FrequencyMultiplier(IteratorBase):
    """Proxy of C++ FrequencyMultiplier class."""

    __swig_setmethods__ = {}
    for _s in [IteratorBase]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, FrequencyMultiplier, name, value)
    __swig_getmethods__ = {}
    for _s in [IteratorBase]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, FrequencyMultiplier, name)
    __repr__ = _swig_repr

    def __init__(self, tagger: 'TimeTaggerBase', input_channel: 'int', multiplier: 'int32_t'):
        """__init__(self, tagger, input_channel, multiplier) -> FrequencyMultiplier"""
        this = _TimeTagger.new_FrequencyMultiplier(tagger, input_channel, multiplier)
        try:
            self.this.append(this)
        except __builtin__.Exception:
            self.this = this
    __swig_destroy__ = _TimeTagger.delete_FrequencyMultiplier
    __del__ = lambda self: None

    def getChannel(self) -> "int":
        """getChannel(self) -> int"""
        return _TimeTagger.FrequencyMultiplier_getChannel(self)


    def getMultiplier(self) -> "int32_t":
        """getMultiplier(self) -> int32_t"""
        return _TimeTagger.FrequencyMultiplier_getMultiplier(self)

FrequencyMultiplier_swigregister = _TimeTagger.FrequencyMultiplier_swigregister
FrequencyMultiplier_swigregister(FrequencyMultiplier)

class Iterator(IteratorBase):
    """Proxy of C++ Iterator class."""

    __swig_setmethods__ = {}
    for _s in [IteratorBase]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Iterator, name, value)
    __swig_getmethods__ = {}
    for _s in [IteratorBase]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, Iterator, name)
    __repr__ = _swig_repr

    def __init__(self, tagger: 'TimeTaggerBase', channel: 'int'):
        """__init__(self, tagger, channel) -> Iterator"""
        this = _TimeTagger.new_Iterator(tagger, channel)
        try:
            self.this.append(this)
        except __builtin__.Exception:
            self.this = this
    __swig_destroy__ = _TimeTagger.delete_Iterator
    __del__ = lambda self: None

    def next(self) -> "long long":
        """next(self) -> long long"""
        return _TimeTagger.Iterator_next(self)


    def size(self) -> "uint64_t":
        """size(self) -> uint64_t"""
        return _TimeTagger.Iterator_size(self)

Iterator_swigregister = _TimeTagger.Iterator_swigregister
Iterator_swigregister(Iterator)

class TimeTagStreamBuffer(_object):
    """Proxy of C++ TimeTagStreamBuffer class."""

    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, TimeTagStreamBuffer, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, TimeTagStreamBuffer, name)

    def __init__(self, *args, **kwargs):
        raise AttributeError("No constructor defined")
    __repr__ = _swig_repr
    __swig_destroy__ = _TimeTagger.delete_TimeTagStreamBuffer
    __del__ = lambda self: None

    def getOverflows(self) -> "void":
        """getOverflows(self)"""
        return _TimeTagger.TimeTagStreamBuffer_getOverflows(self)


    def getChannels(self) -> "void":
        """getChannels(self)"""
        return _TimeTagger.TimeTagStreamBuffer_getChannels(self)


    def getTimestamps(self) -> "void":
        """getTimestamps(self)"""
        return _TimeTagger.TimeTagStreamBuffer_getTimestamps(self)


    def getMissedEvents(self) -> "void":
        """getMissedEvents(self)"""
        return _TimeTagger.TimeTagStreamBuffer_getMissedEvents(self)


    def getEventTypes(self) -> "void":
        """getEventTypes(self)"""
        return _TimeTagger.TimeTagStreamBuffer_getEventTypes(self)

    __swig_setmethods__["size"] = _TimeTagger.TimeTagStreamBuffer_size_set
    __swig_getmethods__["size"] = _TimeTagger.TimeTagStreamBuffer_size_get
    if _newclass:
        size = _swig_property(_TimeTagger.TimeTagStreamBuffer_size_get, _TimeTagger.TimeTagStreamBuffer_size_set)
    __swig_setmethods__["hasOverflows"] = _TimeTagger.TimeTagStreamBuffer_hasOverflows_set
    __swig_getmethods__["hasOverflows"] = _TimeTagger.TimeTagStreamBuffer_hasOverflows_get
    if _newclass:
        hasOverflows = _swig_property(_TimeTagger.TimeTagStreamBuffer_hasOverflows_get, _TimeTagger.TimeTagStreamBuffer_hasOverflows_set)
    __swig_setmethods__["tStart"] = _TimeTagger.TimeTagStreamBuffer_tStart_set
    __swig_getmethods__["tStart"] = _TimeTagger.TimeTagStreamBuffer_tStart_get
    if _newclass:
        tStart = _swig_property(_TimeTagger.TimeTagStreamBuffer_tStart_get, _TimeTagger.TimeTagStreamBuffer_tStart_set)
    __swig_setmethods__["tGetData"] = _TimeTagger.TimeTagStreamBuffer_tGetData_set
    __swig_getmethods__["tGetData"] = _TimeTagger.TimeTagStreamBuffer_tGetData_get
    if _newclass:
        tGetData = _swig_property(_TimeTagger.TimeTagStreamBuffer_tGetData_get, _TimeTagger.TimeTagStreamBuffer_tGetData_set)

    def __enter__(self):
        return self

    def __exit__(self, type, value, tb):
        if self.thisown:
            self.__swig_destroy__(self)
            self.this = None
        return False

TimeTagStreamBuffer_swigregister = _TimeTagger.TimeTagStreamBuffer_swigregister
TimeTagStreamBuffer_swigregister(TimeTagStreamBuffer)

class TimeTagStream(IteratorBase):
    """Proxy of C++ TimeTagStream class."""

    __swig_setmethods__ = {}
    for _s in [IteratorBase]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, TimeTagStream, name, value)
    __swig_getmethods__ = {}
    for _s in [IteratorBase]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, TimeTagStream, name)
    __repr__ = _swig_repr

    def __init__(self, tagger: 'TimeTaggerBase', n_max_events: 'uint64_t', channels: 'IntVector'):
        """__init__(self, tagger, n_max_events, channels) -> TimeTagStream"""
        this = _TimeTagger.new_TimeTagStream(tagger, n_max_events, channels)
        try:
            self.this.append(this)
        except __builtin__.Exception:
            self.this = this
    __swig_destroy__ = _TimeTagger.delete_TimeTagStream
    __del__ = lambda self: None

    def getCounts(self) -> "uint64_t":
        """getCounts(self) -> uint64_t"""
        return _TimeTagger.TimeTagStream_getCounts(self)


    def getData(self) -> "TimeTagStreamBuffer":
        """getData(self) -> TimeTagStreamBuffer"""
        return _TimeTagger.TimeTagStream_getData(self)

TimeTagStream_swigregister = _TimeTagger.TimeTagStream_swigregister
TimeTagStream_swigregister(TimeTagStream)

class Dump(IteratorBase):
    """Proxy of C++ Dump class."""

    __swig_setmethods__ = {}
    for _s in [IteratorBase]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Dump, name, value)
    __swig_getmethods__ = {}
    for _s in [IteratorBase]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, Dump, name)
    __repr__ = _swig_repr

    def __init__(self, *args, **kwargs):
        """__init__(self, tagger, filename, max_tags, channels) -> Dump"""
        this = _TimeTagger.new_Dump(*args, **kwargs)
        try:
            self.this.append(this)
        except __builtin__.Exception:
            self.this = this
    __swig_destroy__ = _TimeTagger.delete_Dump
    __del__ = lambda self: None
Dump_swigregister = _TimeTagger.Dump_swigregister
Dump_swigregister(Dump)

class StartStop(IteratorBase):
    """Proxy of C++ StartStop class."""

    __swig_setmethods__ = {}
    for _s in [IteratorBase]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, StartStop, name, value)
    __swig_getmethods__ = {}
    for _s in [IteratorBase]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, StartStop, name)
    __repr__ = _swig_repr

    def __init__(self, *args, **kwargs):
        """__init__(self, tagger, click_channel, start_channel, binwidth=1000) -> StartStop"""
        this = _TimeTagger.new_StartStop(*args, **kwargs)
        try:
            self.this.append(this)
        except __builtin__.Exception:
            self.this = this
    __swig_destroy__ = _TimeTagger.delete_StartStop
    __del__ = lambda self: None

    def getData(self) -> "void":
        """getData(self)"""
        return _TimeTagger.StartStop_getData(self)

StartStop_swigregister = _TimeTagger.StartStop_swigregister
StartStop_swigregister(StartStop)

class TimeDifferences(IteratorBase):
    """Proxy of C++ TimeDifferences class."""

    __swig_setmethods__ = {}
    for _s in [IteratorBase]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, TimeDifferences, name, value)
    __swig_getmethods__ = {}
    for _s in [IteratorBase]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, TimeDifferences, name)
    __repr__ = _swig_repr

    def __init__(self, *args, **kwargs):
        """__init__(self, tagger, click_channel, start_channel, next_channel, sync_channel, binwidth=1000, n_bins=1000, n_histograms=1) -> TimeDifferences"""
        this = _TimeTagger.new_TimeDifferences(*args, **kwargs)
        try:
            self.this.append(this)
        except __builtin__.Exception:
            self.this = this
    __swig_destroy__ = _TimeTagger.delete_TimeDifferences
    __del__ = lambda self: None

    def getData(self) -> "void":
        """getData(self)"""
        return _TimeTagger.TimeDifferences_getData(self)


    def getIndex(self) -> "void":
        """getIndex(self)"""
        return _TimeTagger.TimeDifferences_getIndex(self)


    def setMaxCounts(self, max_counts: 'uint64_t') -> "void":
        """setMaxCounts(self, max_counts)"""
        return _TimeTagger.TimeDifferences_setMaxCounts(self, max_counts)


    def getCounts(self) -> "uint64_t":
        """getCounts(self) -> uint64_t"""
        return _TimeTagger.TimeDifferences_getCounts(self)


    def getHistogramIndex(self) -> "int32_t":
        """getHistogramIndex(self) -> int32_t"""
        return _TimeTagger.TimeDifferences_getHistogramIndex(self)


    def ready(self) -> "bool":
        """ready(self) -> bool"""
        return _TimeTagger.TimeDifferences_ready(self)

TimeDifferences_swigregister = _TimeTagger.TimeDifferences_swigregister
TimeDifferences_swigregister(TimeDifferences)

class Histogram2D(IteratorBase):
    """Proxy of C++ Histogram2D class."""

    __swig_setmethods__ = {}
    for _s in [IteratorBase]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Histogram2D, name, value)
    __swig_getmethods__ = {}
    for _s in [IteratorBase]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, Histogram2D, name)
    __repr__ = _swig_repr

    def __init__(self, tagger: 'TimeTaggerBase', start_channel: 'int', stop_channel_1: 'int', stop_channel_2: 'int', binwidth_1: 'long long', binwidth_2: 'long long', n_bins_1: 'int32_t', n_bins_2: 'int32_t'):
        """__init__(self, tagger, start_channel, stop_channel_1, stop_channel_2, binwidth_1, binwidth_2, n_bins_1, n_bins_2) -> Histogram2D"""
        this = _TimeTagger.new_Histogram2D(tagger, start_channel, stop_channel_1, stop_channel_2, binwidth_1, binwidth_2, n_bins_1, n_bins_2)
        try:
            self.this.append(this)
        except __builtin__.Exception:
            self.this = this
    __swig_destroy__ = _TimeTagger.delete_Histogram2D
    __del__ = lambda self: None

    def getData(self) -> "void":
        """getData(self)"""
        return _TimeTagger.Histogram2D_getData(self)


    def getIndex(self) -> "void":
        """getIndex(self)"""
        return _TimeTagger.Histogram2D_getIndex(self)


    def getIndex_1(self) -> "void":
        """getIndex_1(self)"""
        return _TimeTagger.Histogram2D_getIndex_1(self)


    def getIndex_2(self) -> "void":
        """getIndex_2(self)"""
        return _TimeTagger.Histogram2D_getIndex_2(self)

Histogram2D_swigregister = _TimeTagger.Histogram2D_swigregister
Histogram2D_swigregister(Histogram2D)

class HistogramND(IteratorBase):
    """Proxy of C++ HistogramND class."""

    __swig_setmethods__ = {}
    for _s in [IteratorBase]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, HistogramND, name, value)
    __swig_getmethods__ = {}
    for _s in [IteratorBase]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, HistogramND, name)
    __repr__ = _swig_repr

    def __init__(self, tagger: 'TimeTaggerBase', start_channel: 'int', stop_channels: 'IntVector', binwidths: 'LongLongVector', n_bins: 'IntVector'):
        """__init__(self, tagger, start_channel, stop_channels, binwidths, n_bins) -> HistogramND"""
        this = _TimeTagger.new_HistogramND(tagger, start_channel, stop_channels, binwidths, n_bins)
        try:
            self.this.append(this)
        except __builtin__.Exception:
            self.this = this
    __swig_destroy__ = _TimeTagger.delete_HistogramND
    __del__ = lambda self: None

    def getData(self) -> "void":
        """getData(self)"""
        return _TimeTagger.HistogramND_getData(self)


    def getIndex(self, dim: 'int32_t'=0) -> "void":
        """getIndex(self, dim=0)"""
        return _TimeTagger.HistogramND_getIndex(self, dim)

HistogramND_swigregister = _TimeTagger.HistogramND_swigregister
HistogramND_swigregister(HistogramND)

class TimeDifferencesND(IteratorBase):
    """Proxy of C++ TimeDifferencesND class."""

    __swig_setmethods__ = {}
    for _s in [IteratorBase]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, TimeDifferencesND, name, value)
    __swig_getmethods__ = {}
    for _s in [IteratorBase]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, TimeDifferencesND, name)
    __repr__ = _swig_repr

    def __init__(self, tagger: 'TimeTaggerBase', click_channel: 'int', start_channel: 'int', next_channels: 'IntVector', sync_channels: 'IntVector', n_histograms: 'IntVector', binwidth: 'long long', n_bins: 'int32_t'):
        """__init__(self, tagger, click_channel, start_channel, next_channels, sync_channels, n_histograms, binwidth, n_bins) -> TimeDifferencesND"""
        this = _TimeTagger.new_TimeDifferencesND(tagger, click_channel, start_channel, next_channels, sync_channels, n_histograms, binwidth, n_bins)
        try:
            self.this.append(this)
        except __builtin__.Exception:
            self.this = this
    __swig_destroy__ = _TimeTagger.delete_TimeDifferencesND
    __del__ = lambda self: None

    def getData(self) -> "void":
        """getData(self)"""
        return _TimeTagger.TimeDifferencesND_getData(self)


    def getIndex(self) -> "void":
        """getIndex(self)"""
        return _TimeTagger.TimeDifferencesND_getIndex(self)

TimeDifferencesND_swigregister = _TimeTagger.TimeDifferencesND_swigregister
TimeDifferencesND_swigregister(TimeDifferencesND)

class Histogram(IteratorBase):
    """Proxy of C++ Histogram class."""

    __swig_setmethods__ = {}
    for _s in [IteratorBase]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Histogram, name, value)
    __swig_getmethods__ = {}
    for _s in [IteratorBase]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, Histogram, name)
    __repr__ = _swig_repr

    def __init__(self, *args, **kwargs):
        """__init__(self, tagger, click_channel, start_channel, binwidth=1000, n_bins=1000) -> Histogram"""
        this = _TimeTagger.new_Histogram(*args, **kwargs)
        try:
            self.this.append(this)
        except __builtin__.Exception:
            self.this = this
    __swig_destroy__ = _TimeTagger.delete_Histogram
    __del__ = lambda self: None

    def getData(self) -> "void":
        """getData(self)"""
        return _TimeTagger.Histogram_getData(self)


    def getIndex(self) -> "void":
        """getIndex(self)"""
        return _TimeTagger.Histogram_getIndex(self)


    def __enter__(self):
        return self

    def __exit__(self, type, value, tb):
        if self.thisown:
            self.__swig_destroy__(self)
            self.this = None
        return False

Histogram_swigregister = _TimeTagger.Histogram_swigregister
Histogram_swigregister(Histogram)

class HistogramLogBins(IteratorBase):
    """Proxy of C++ HistogramLogBins class."""

    __swig_setmethods__ = {}
    for _s in [IteratorBase]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, HistogramLogBins, name, value)
    __swig_getmethods__ = {}
    for _s in [IteratorBase]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, HistogramLogBins, name)
    __repr__ = _swig_repr

    def __init__(self, tagger: 'TimeTaggerBase', click_channel: 'int', start_channel: 'int', exp_start: 'double', exp_stop: 'double', n_bins: 'int32_t'):
        """__init__(self, tagger, click_channel, start_channel, exp_start, exp_stop, n_bins) -> HistogramLogBins"""
        this = _TimeTagger.new_HistogramLogBins(tagger, click_channel, start_channel, exp_start, exp_stop, n_bins)
        try:
            self.this.append(this)
        except __builtin__.Exception:
            self.this = this
    __swig_destroy__ = _TimeTagger.delete_HistogramLogBins
    __del__ = lambda self: None

    def getData(self) -> "void":
        """getData(self)"""
        return _TimeTagger.HistogramLogBins_getData(self)


    def getDataNormalizedCountsPerPs(self) -> "void":
        """getDataNormalizedCountsPerPs(self)"""
        return _TimeTagger.HistogramLogBins_getDataNormalizedCountsPerPs(self)


    def getDataNormalizedG2(self) -> "void":
        """getDataNormalizedG2(self)"""
        return _TimeTagger.HistogramLogBins_getDataNormalizedG2(self)


    def getBinEdges(self) -> "void":
        """getBinEdges(self)"""
        return _TimeTagger.HistogramLogBins_getBinEdges(self)

HistogramLogBins_swigregister = _TimeTagger.HistogramLogBins_swigregister
HistogramLogBins_swigregister(HistogramLogBins)

class Correlation(IteratorBase):
    """Proxy of C++ Correlation class."""

    __swig_setmethods__ = {}
    for _s in [IteratorBase]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Correlation, name, value)
    __swig_getmethods__ = {}
    for _s in [IteratorBase]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, Correlation, name)
    __repr__ = _swig_repr

    def __init__(self, *args, **kwargs):
        """__init__(self, tagger, channel_1, channel_2, binwidth=1000, n_bins=1000) -> Correlation"""
        this = _TimeTagger.new_Correlation(*args, **kwargs)
        try:
            self.this.append(this)
        except __builtin__.Exception:
            self.this = this
    __swig_destroy__ = _TimeTagger.delete_Correlation
    __del__ = lambda self: None

    def getData(self) -> "void":
        """getData(self)"""
        return _TimeTagger.Correlation_getData(self)


    def getDataNormalized(self) -> "void":
        """getDataNormalized(self)"""
        return _TimeTagger.Correlation_getDataNormalized(self)


    def getIndex(self) -> "void":
        """getIndex(self)"""
        return _TimeTagger.Correlation_getIndex(self)

Correlation_swigregister = _TimeTagger.Correlation_swigregister
Correlation_swigregister(Correlation)

UNKNOWN = _TimeTagger.UNKNOWN
HIGH = _TimeTagger.HIGH
LOW = _TimeTagger.LOW
class Event(_object):
    """Proxy of C++ Event class."""

    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, Event, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, Event, name)
    __repr__ = _swig_repr
    __swig_setmethods__["time"] = _TimeTagger.Event_time_set
    __swig_getmethods__["time"] = _TimeTagger.Event_time_get
    if _newclass:
        time = _swig_property(_TimeTagger.Event_time_get, _TimeTagger.Event_time_set)
    __swig_setmethods__["state"] = _TimeTagger.Event_state_set
    __swig_getmethods__["state"] = _TimeTagger.Event_state_get
    if _newclass:
        state = _swig_property(_TimeTagger.Event_state_get, _TimeTagger.Event_state_set)

    def __init__(self):
        """__init__(self) -> Event"""
        this = _TimeTagger.new_Event()
        try:
            self.this.append(this)
        except __builtin__.Exception:
            self.this = this
    __swig_destroy__ = _TimeTagger.delete_Event
    __del__ = lambda self: None
Event_swigregister = _TimeTagger.Event_swigregister
Event_swigregister(Event)

class Scope(IteratorBase):
    """Proxy of C++ Scope class."""

    __swig_setmethods__ = {}
    for _s in [IteratorBase]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Scope, name, value)
    __swig_getmethods__ = {}
    for _s in [IteratorBase]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, Scope, name)
    __repr__ = _swig_repr

    def __init__(self, tagger: 'TimeTaggerBase', event_channels: 'IntVector', trigger_channel: 'int', window_size: 'long long'=1000000000, n_traces: 'int32_t'=1, n_max_events: 'int32_t'=1000):
        """__init__(self, tagger, event_channels, trigger_channel, window_size=1000000000, n_traces=1, n_max_events=1000) -> Scope"""
        this = _TimeTagger.new_Scope(tagger, event_channels, trigger_channel, window_size, n_traces, n_max_events)
        try:
            self.this.append(this)
        except __builtin__.Exception:
            self.this = this
    __swig_destroy__ = _TimeTagger.delete_Scope
    __del__ = lambda self: None

    def ready(self) -> "bool":
        """ready(self) -> bool"""
        return _TimeTagger.Scope_ready(self)


    def triggered(self) -> "int32_t":
        """triggered(self) -> int32_t"""
        return _TimeTagger.Scope_triggered(self)


    def getData(self) -> "std::vector< std::vector< Event,std::allocator< Event > >,std::allocator< std::vector< Event,std::allocator< Event > > > >":
        """getData(self) -> EventVectorVector"""
        return _TimeTagger.Scope_getData(self)


    def getWindowSize(self) -> "long long":
        """getWindowSize(self) -> long long"""
        return _TimeTagger.Scope_getWindowSize(self)

Scope_swigregister = _TimeTagger.Scope_swigregister
Scope_swigregister(Scope)

class SynchronizedMeasurements(_object):
    """Proxy of C++ SynchronizedMeasurements class."""

    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, SynchronizedMeasurements, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, SynchronizedMeasurements, name)
    __repr__ = _swig_repr

    def __init__(self, tagger: 'TimeTaggerBase'):
        """__init__(self, tagger) -> SynchronizedMeasurements"""
        this = _TimeTagger.new_SynchronizedMeasurements(tagger)
        try:
            self.this.append(this)
        except __builtin__.Exception:
            self.this = this
    __swig_destroy__ = _TimeTagger.delete_SynchronizedMeasurements
    __del__ = lambda self: None

    def registerMeasurement(self, measurement: 'IteratorBase') -> "void":
        """registerMeasurement(self, measurement)"""
        return _TimeTagger.SynchronizedMeasurements_registerMeasurement(self, measurement)


    def unregisterMeasurement(self, measurement: 'IteratorBase') -> "void":
        """unregisterMeasurement(self, measurement)"""
        return _TimeTagger.SynchronizedMeasurements_unregisterMeasurement(self, measurement)


    def clear(self) -> "void":
        """clear(self)"""
        return _TimeTagger.SynchronizedMeasurements_clear(self)


    def start(self) -> "void":
        """start(self)"""
        return _TimeTagger.SynchronizedMeasurements_start(self)


    def stop(self) -> "void":
        """stop(self)"""
        return _TimeTagger.SynchronizedMeasurements_stop(self)


    def startFor(self, capture_duration: 'long long', clear: 'bool'=True) -> "void":
        """startFor(self, capture_duration, clear=True)"""
        return _TimeTagger.SynchronizedMeasurements_startFor(self, capture_duration, clear)


    def __waitUntilFinished(self, timeout: 'int64_t'=-1) -> "bool":
        """__waitUntilFinished(self, timeout=-1) -> bool"""
        return _TimeTagger.SynchronizedMeasurements___waitUntilFinished(self, timeout)


    def isRunning(self) -> "bool":
        """isRunning(self) -> bool"""
        return _TimeTagger.SynchronizedMeasurements_isRunning(self)


    def getTagger(self) -> "TimeTaggerBase *":
        """getTagger(self) -> TimeTaggerBase"""
        return _TimeTagger.SynchronizedMeasurements_getTagger(self)


    def waitUntilFinished(self, timeout=-1):
        r"""waitUntilFinished(self, timeout=-1) -> bool"""
        return _timeout_handler(self.__waitUntilFinished, timeout)


    def __enter__(self):
        return self

    def __exit__(self, type, value, tb):
        if self.thisown:
            self.__swig_destroy__(self)
            self.this = None
        return False

SynchronizedMeasurements_swigregister = _TimeTagger.SynchronizedMeasurements_swigregister
SynchronizedMeasurements_swigregister(SynchronizedMeasurements)

class ConstantFractionDiscriminator(IteratorBase):
    """Proxy of C++ ConstantFractionDiscriminator class."""

    __swig_setmethods__ = {}
    for _s in [IteratorBase]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, ConstantFractionDiscriminator, name, value)
    __swig_getmethods__ = {}
    for _s in [IteratorBase]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, ConstantFractionDiscriminator, name)
    __repr__ = _swig_repr

    def __init__(self, tagger: 'TimeTaggerBase', channels: 'IntVector', search_window: 'long long'):
        """__init__(self, tagger, channels, search_window) -> ConstantFractionDiscriminator"""
        this = _TimeTagger.new_ConstantFractionDiscriminator(tagger, channels, search_window)
        try:
            self.this.append(this)
        except __builtin__.Exception:
            self.this = this
    __swig_destroy__ = _TimeTagger.delete_ConstantFractionDiscriminator
    __del__ = lambda self: None

    def getChannels(self) -> "std::vector< int,std::allocator< int > >":
        """getChannels(self) -> IntVector"""
        return _TimeTagger.ConstantFractionDiscriminator_getChannels(self)

ConstantFractionDiscriminator_swigregister = _TimeTagger.ConstantFractionDiscriminator_swigregister
ConstantFractionDiscriminator_swigregister(ConstantFractionDiscriminator)

class FileWriter(IteratorBase):
    """Proxy of C++ FileWriter class."""

    __swig_setmethods__ = {}
    for _s in [IteratorBase]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, FileWriter, name, value)
    __swig_getmethods__ = {}
    for _s in [IteratorBase]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, FileWriter, name)
    __repr__ = _swig_repr

    def __init__(self, tagger: 'TimeTaggerBase', filename: 'std::string const &', channels: 'IntVector'):
        """__init__(self, tagger, filename, channels) -> FileWriter"""
        this = _TimeTagger.new_FileWriter(tagger, filename, channels)
        try:
            self.this.append(this)
        except __builtin__.Exception:
            self.this = this
    __swig_destroy__ = _TimeTagger.delete_FileWriter
    __del__ = lambda self: None

    def split(self, *args, **kwargs) -> "void":
        """split(self, new_filename)"""
        return _TimeTagger.FileWriter_split(self, *args, **kwargs)


    def setMaxFileSize(self, max_file_size: 'uint64_t') -> "void":
        """setMaxFileSize(self, max_file_size)"""
        return _TimeTagger.FileWriter_setMaxFileSize(self, max_file_size)


    def getMaxFileSize(self) -> "uint64_t":
        """getMaxFileSize(self) -> uint64_t"""
        return _TimeTagger.FileWriter_getMaxFileSize(self)


    def getTotalEvents(self) -> "uint64_t":
        """getTotalEvents(self) -> uint64_t"""
        return _TimeTagger.FileWriter_getTotalEvents(self)


    def getTotalSize(self) -> "uint64_t":
        """getTotalSize(self) -> uint64_t"""
        return _TimeTagger.FileWriter_getTotalSize(self)


    def setMarker(self, marker: 'std::string const &') -> "void":
        """setMarker(self, marker)"""
        return _TimeTagger.FileWriter_setMarker(self, marker)

FileWriter_swigregister = _TimeTagger.FileWriter_swigregister
FileWriter_swigregister(FileWriter)

class FileReader(_object):
    """Proxy of C++ FileReader class."""

    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, FileReader, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, FileReader, name)
    __repr__ = _swig_repr

    def __init__(self, *args):
        """
        __init__(self, filenames) -> FileReader
        __init__(self, filename) -> FileReader
        """
        this = _TimeTagger.new_FileReader(*args)
        try:
            self.this.append(this)
        except __builtin__.Exception:
            self.this = this
    __swig_destroy__ = _TimeTagger.delete_FileReader
    __del__ = lambda self: None

    def hasData(self) -> "bool":
        """hasData(self) -> bool"""
        return _TimeTagger.FileReader_hasData(self)


    def getData(self, n_events: 'uint64_t') -> "TimeTagStreamBuffer":
        """getData(self, n_events) -> TimeTagStreamBuffer"""
        return _TimeTagger.FileReader_getData(self, n_events)


    def __getConfiguration(self) -> "std::string":
        """__getConfiguration(self) -> std::string"""
        return _TimeTagger.FileReader___getConfiguration(self)


    def getChannelList(self) -> "std::vector< int,std::allocator< int > >":
        """getChannelList(self) -> IntVector"""
        return _TimeTagger.FileReader_getChannelList(self)


    def getLastMarker(self) -> "std::string":
        """getLastMarker(self) -> std::string"""
        return _TimeTagger.FileReader_getLastMarker(self)


    def getConfiguration(self, *args, **kargs):
        r"""getConfiguration(...) -> json"""
        import json
        return json.loads(self.__getConfiguration(*args, **kargs))


    def __enter__(self):
        return self

    def __exit__(self, type, value, tb):
        if self.thisown:
            self.__swig_destroy__(self)
            self.this = None
        return False

FileReader_swigregister = _TimeTagger.FileReader_swigregister
FileReader_swigregister(FileReader)

class EventGenerator(IteratorBase):
    """Proxy of C++ EventGenerator class."""

    __swig_setmethods__ = {}
    for _s in [IteratorBase]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, EventGenerator, name, value)
    __swig_getmethods__ = {}
    for _s in [IteratorBase]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, EventGenerator, name)
    __repr__ = _swig_repr

    def __init__(self, *args, **kwargs):
        """__init__(self, tagger, trigger_channel, pattern, trigger_divider=1, divider_offset=0, stop_channel) -> EventGenerator"""
        this = _TimeTagger.new_EventGenerator(*args, **kwargs)
        try:
            self.this.append(this)
        except __builtin__.Exception:
            self.this = this
    __swig_destroy__ = _TimeTagger.delete_EventGenerator
    __del__ = lambda self: None

    def getChannel(self) -> "int":
        """getChannel(self) -> int"""
        return _TimeTagger.EventGenerator_getChannel(self)

EventGenerator_swigregister = _TimeTagger.EventGenerator_swigregister
EventGenerator_swigregister(EventGenerator)

class CustomMeasurementBase(IteratorBase):
    """Proxy of C++ CustomMeasurementBase class."""

    __swig_setmethods__ = {}
    for _s in [IteratorBase]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, CustomMeasurementBase, name, value)
    __swig_getmethods__ = {}
    for _s in [IteratorBase]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, CustomMeasurementBase, name)
    __repr__ = _swig_repr

    def __init__(self, tagger: 'TimeTaggerBase'):
        """__init__(self, tagger) -> CustomMeasurementBase"""
        if self.__class__ == CustomMeasurementBase:
            _self = None
        else:
            _self = self
        this = _TimeTagger.new_CustomMeasurementBase(_self, tagger)
        try:
            self.this.append(this)
        except __builtin__.Exception:
            self.this = this
    __swig_destroy__ = _TimeTagger.delete_CustomMeasurementBase
    __del__ = lambda self: None

    def stop_all_custom_measurements() -> "void":
        """stop_all_custom_measurements()"""
        return _TimeTagger.CustomMeasurementBase_stop_all_custom_measurements()

    stop_all_custom_measurements = staticmethod(stop_all_custom_measurements)

    def register_channel(self, channel: 'int') -> "void":
        """register_channel(self, channel)"""
        return _TimeTagger.CustomMeasurementBase_register_channel(self, channel)


    def unregister_channel(self, channel: 'int') -> "void":
        """unregister_channel(self, channel)"""
        return _TimeTagger.CustomMeasurementBase_unregister_channel(self, channel)


    def finalize_init(self) -> "void":
        """finalize_init(self)"""
        return _TimeTagger.CustomMeasurementBase_finalize_init(self)


    def is_running(self) -> "bool":
        """is_running(self) -> bool"""
        return _TimeTagger.CustomMeasurementBase_is_running(self)


    def _lock(self) -> "void":
        """_lock(self)"""
        return _TimeTagger.CustomMeasurementBase__lock(self)


    def _unlock(self) -> "void":
        """_unlock(self)"""
        return _TimeTagger.CustomMeasurementBase__unlock(self)


    def next_impl(self, incoming_tags: 'std::vector< Tag,std::allocator< Tag > > &', begin_time: 'long long', end_time: 'long long') -> "bool":
        """next_impl(self, incoming_tags, begin_time, end_time) -> bool"""
        return _TimeTagger.CustomMeasurementBase_next_impl(self, incoming_tags, begin_time, end_time)


    def next_impl_cs(self, tags_ptr: 'void *', num_tags: 'uint64_t', begin_time: 'long long', end_time: 'long long') -> "void":
        """next_impl_cs(self, tags_ptr, num_tags, begin_time, end_time)"""
        return _TimeTagger.CustomMeasurementBase_next_impl_cs(self, tags_ptr, num_tags, begin_time, end_time)


    def clear_impl(self) -> "void":
        """clear_impl(self)"""
        return _TimeTagger.CustomMeasurementBase_clear_impl(self)


    def on_start(self) -> "void":
        """on_start(self)"""
        return _TimeTagger.CustomMeasurementBase_on_start(self)


    def on_stop(self) -> "void":
        """on_stop(self)"""
        return _TimeTagger.CustomMeasurementBase_on_stop(self)

    def __disown__(self):
        self.this.disown()
        _TimeTagger.disown_CustomMeasurementBase(self)
        return weakref_proxy(self)
CustomMeasurementBase_swigregister = _TimeTagger.CustomMeasurementBase_swigregister
CustomMeasurementBase_swigregister(CustomMeasurementBase)

def CustomMeasurementBase_stop_all_custom_measurements() -> "void":
    """CustomMeasurementBase_stop_all_custom_measurements()"""
    return _TimeTagger.CustomMeasurementBase_stop_all_custom_measurements()

class FlimAbstract(IteratorBase):
    """Proxy of C++ FlimAbstract class."""

    __swig_setmethods__ = {}
    for _s in [IteratorBase]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, FlimAbstract, name, value)
    __swig_getmethods__ = {}
    for _s in [IteratorBase]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, FlimAbstract, name)

    def __init__(self, *args, **kwargs):
        raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _TimeTagger.delete_FlimAbstract
    __del__ = lambda self: None

    def isAcquiring(self) -> "bool":
        """isAcquiring(self) -> bool"""
        return _TimeTagger.FlimAbstract_isAcquiring(self)

FlimAbstract_swigregister = _TimeTagger.FlimAbstract_swigregister
FlimAbstract_swigregister(FlimAbstract)

class FlimBase(FlimAbstract):
    """Proxy of C++ FlimBase class."""

    __swig_setmethods__ = {}
    for _s in [FlimAbstract]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, FlimBase, name, value)
    __swig_getmethods__ = {}
    for _s in [FlimAbstract]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, FlimBase, name)
    __repr__ = _swig_repr

    def __init__(self, *args, **kwargs):
        """__init__(self, tagger, start_channel, click_channel, pixel_begin_channel, n_pixels, n_bins, binwidth, pixel_end_channel, frame_begin_channel, finish_after_outputframe=0, n_frame_average=1, pre_initialize=True) -> FlimBase"""
        if self.__class__ == FlimBase:
            _self = None
        else:
            _self = self
        this = _TimeTagger.new_FlimBase(_self, *args, **kwargs)
        try:
            self.this.append(this)
        except __builtin__.Exception:
            self.this = this
    __swig_destroy__ = _TimeTagger.delete_FlimBase
    __del__ = lambda self: None

    def initialize(self) -> "void":
        """initialize(self)"""
        return _TimeTagger.FlimBase_initialize(self)


    def frameReady(self, frame_number: 'uint32_t', data: 'UIntVector', pixel_begin_times: 'LongLongVector', pixel_end_times: 'LongLongVector', frame_begin_time: 'long long', frame_end_time: 'long long') -> "void":
        """frameReady(self, frame_number, data, pixel_begin_times, pixel_end_times, frame_begin_time, frame_end_time)"""
        return _TimeTagger.FlimBase_frameReady(self, frame_number, data, pixel_begin_times, pixel_end_times, frame_begin_time, frame_end_time)

    def __disown__(self):
        self.this.disown()
        _TimeTagger.disown_FlimBase(self)
        return weakref_proxy(self)
FlimBase_swigregister = _TimeTagger.FlimBase_swigregister
FlimBase_swigregister(FlimBase)

class FlimFrameInfo(_object):
    """Proxy of C++ FlimFrameInfo class."""

    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, FlimFrameInfo, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, FlimFrameInfo, name)

    def __init__(self, *args, **kwargs):
        raise AttributeError("No constructor defined")
    __repr__ = _swig_repr
    __swig_destroy__ = _TimeTagger.delete_FlimFrameInfo
    __del__ = lambda self: None

    def getFrameNumber(self) -> "int32_t":
        """getFrameNumber(self) -> int32_t"""
        return _TimeTagger.FlimFrameInfo_getFrameNumber(self)


    def isValid(self) -> "bool":
        """isValid(self) -> bool"""
        return _TimeTagger.FlimFrameInfo_isValid(self)


    def getPixelPosition(self) -> "uint32_t":
        """getPixelPosition(self) -> uint32_t"""
        return _TimeTagger.FlimFrameInfo_getPixelPosition(self)


    def getHistograms(self) -> "void":
        """getHistograms(self)"""
        return _TimeTagger.FlimFrameInfo_getHistograms(self)


    def getIntensities(self) -> "void":
        """getIntensities(self)"""
        return _TimeTagger.FlimFrameInfo_getIntensities(self)


    def getSummedCounts(self) -> "void":
        """getSummedCounts(self)"""
        return _TimeTagger.FlimFrameInfo_getSummedCounts(self)


    def getPixelBegins(self) -> "void":
        """getPixelBegins(self)"""
        return _TimeTagger.FlimFrameInfo_getPixelBegins(self)


    def getPixelEnds(self) -> "void":
        """getPixelEnds(self)"""
        return _TimeTagger.FlimFrameInfo_getPixelEnds(self)

    __swig_setmethods__["pixels"] = _TimeTagger.FlimFrameInfo_pixels_set
    __swig_getmethods__["pixels"] = _TimeTagger.FlimFrameInfo_pixels_get
    if _newclass:
        pixels = _swig_property(_TimeTagger.FlimFrameInfo_pixels_get, _TimeTagger.FlimFrameInfo_pixels_set)
    __swig_setmethods__["bins"] = _TimeTagger.FlimFrameInfo_bins_set
    __swig_getmethods__["bins"] = _TimeTagger.FlimFrameInfo_bins_get
    if _newclass:
        bins = _swig_property(_TimeTagger.FlimFrameInfo_bins_get, _TimeTagger.FlimFrameInfo_bins_set)
    __swig_setmethods__["frame_number"] = _TimeTagger.FlimFrameInfo_frame_number_set
    __swig_getmethods__["frame_number"] = _TimeTagger.FlimFrameInfo_frame_number_get
    if _newclass:
        frame_number = _swig_property(_TimeTagger.FlimFrameInfo_frame_number_get, _TimeTagger.FlimFrameInfo_frame_number_set)
    __swig_setmethods__["pixel_position"] = _TimeTagger.FlimFrameInfo_pixel_position_set
    __swig_getmethods__["pixel_position"] = _TimeTagger.FlimFrameInfo_pixel_position_get
    if _newclass:
        pixel_position = _swig_property(_TimeTagger.FlimFrameInfo_pixel_position_get, _TimeTagger.FlimFrameInfo_pixel_position_set)
    __swig_setmethods__["valid"] = _TimeTagger.FlimFrameInfo_valid_set
    __swig_getmethods__["valid"] = _TimeTagger.FlimFrameInfo_valid_get
    if _newclass:
        valid = _swig_property(_TimeTagger.FlimFrameInfo_valid_get, _TimeTagger.FlimFrameInfo_valid_set)

    def __enter__(self):
        return self

    def __exit__(self, type, value, tb):
        if self.thisown:
            self.__swig_destroy__(self)
            self.this = None
        return False

FlimFrameInfo_swigregister = _TimeTagger.FlimFrameInfo_swigregister
FlimFrameInfo_swigregister(FlimFrameInfo)

class Flim(FlimAbstract):
    """Proxy of C++ Flim class."""

    __swig_setmethods__ = {}
    for _s in [FlimAbstract]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Flim, name, value)
    __swig_getmethods__ = {}
    for _s in [FlimAbstract]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, Flim, name)
    __repr__ = _swig_repr

    def __init__(self, *args, **kwargs):
        """__init__(self, tagger, start_channel, click_channel, pixel_begin_channel, n_pixels, n_bins, binwidth, pixel_end_channel, frame_begin_channel, finish_after_outputframe=0, n_frame_average=1, pre_initialize=True) -> Flim"""
        if self.__class__ == Flim:
            _self = None
        else:
            _self = self
        this = _TimeTagger.new_Flim(_self, *args, **kwargs)
        try:
            self.this.append(this)
        except __builtin__.Exception:
            self.this = this
    __swig_destroy__ = _TimeTagger.delete_Flim
    __del__ = lambda self: None

    def initialize(self) -> "void":
        """initialize(self)"""
        return _TimeTagger.Flim_initialize(self)


    def getReadyFrame(self, index: 'int32_t'=-1) -> "void":
        """getReadyFrame(self, index=-1)"""
        return _TimeTagger.Flim_getReadyFrame(self, index)


    def getReadyFrameIntensity(self, index: 'int32_t'=-1) -> "void":
        """getReadyFrameIntensity(self, index=-1)"""
        return _TimeTagger.Flim_getReadyFrameIntensity(self, index)


    def getCurrentFrame(self) -> "void":
        """getCurrentFrame(self)"""
        return _TimeTagger.Flim_getCurrentFrame(self)


    def getCurrentFrameIntensity(self) -> "void":
        """getCurrentFrameIntensity(self)"""
        return _TimeTagger.Flim_getCurrentFrameIntensity(self)


    def getSummedFrames(self, only_ready_frames: 'bool'=True, clear_summed: 'bool'=False) -> "void":
        """getSummedFrames(self, only_ready_frames=True, clear_summed=False)"""
        return _TimeTagger.Flim_getSummedFrames(self, only_ready_frames, clear_summed)


    def getSummedFramesIntensity(self, only_ready_frames: 'bool'=True, clear_summed: 'bool'=False) -> "void":
        """getSummedFramesIntensity(self, only_ready_frames=True, clear_summed=False)"""
        return _TimeTagger.Flim_getSummedFramesIntensity(self, only_ready_frames, clear_summed)


    def getReadyFrameEx(self, index: 'int32_t'=-1) -> "FlimFrameInfo":
        """getReadyFrameEx(self, index=-1) -> FlimFrameInfo"""
        return _TimeTagger.Flim_getReadyFrameEx(self, index)


    def getCurrentFrameEx(self) -> "FlimFrameInfo":
        """getCurrentFrameEx(self) -> FlimFrameInfo"""
        return _TimeTagger.Flim_getCurrentFrameEx(self)


    def getSummedFramesEx(self, only_ready_frames: 'bool'=True, clear_summed: 'bool'=False) -> "FlimFrameInfo":
        """getSummedFramesEx(self, only_ready_frames=True, clear_summed=False) -> FlimFrameInfo"""
        return _TimeTagger.Flim_getSummedFramesEx(self, only_ready_frames, clear_summed)


    def getFramesAcquired(self) -> "uint32_t":
        """getFramesAcquired(self) -> uint32_t"""
        return _TimeTagger.Flim_getFramesAcquired(self)


    def getIndex(self) -> "void":
        """getIndex(self)"""
        return _TimeTagger.Flim_getIndex(self)


    def frameReady(self, frame_number: 'uint32_t', data: 'UIntVector', pixel_begin_times: 'LongLongVector', pixel_end_times: 'LongLongVector', frame_begin_time: 'long long', frame_end_time: 'long long') -> "void":
        """frameReady(self, frame_number, data, pixel_begin_times, pixel_end_times, frame_begin_time, frame_end_time)"""
        return _TimeTagger.Flim_frameReady(self, frame_number, data, pixel_begin_times, pixel_end_times, frame_begin_time, frame_end_time)

    def __disown__(self):
        self.this.disown()
        _TimeTagger.disown_Flim(self)
        return weakref_proxy(self)
Flim_swigregister = _TimeTagger.Flim_swigregister
Flim_swigregister(Flim)

class Sampler(IteratorBase):
    """Proxy of C++ Sampler class."""

    __swig_setmethods__ = {}
    for _s in [IteratorBase]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Sampler, name, value)
    __swig_getmethods__ = {}
    for _s in [IteratorBase]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, Sampler, name)
    __repr__ = _swig_repr

    def __init__(self, tagger: 'TimeTaggerBase', trigger: 'int', channels: 'IntVector', max_triggers: 'size_t'):
        """__init__(self, tagger, trigger, channels, max_triggers) -> Sampler"""
        this = _TimeTagger.new_Sampler(tagger, trigger, channels, max_triggers)
        try:
            self.this.append(this)
        except __builtin__.Exception:
            self.this = this
    __swig_destroy__ = _TimeTagger.delete_Sampler
    __del__ = lambda self: None

    def getData(self) -> "void":
        """getData(self)"""
        return _TimeTagger.Sampler_getData(self)


    def getDataAsMask(self) -> "void":
        """getDataAsMask(self)"""
        return _TimeTagger.Sampler_getDataAsMask(self)

Sampler_swigregister = _TimeTagger.Sampler_swigregister
Sampler_swigregister(Sampler)

class SyntheticSingleTag(IteratorBase):
    """Proxy of C++ SyntheticSingleTag class."""

    __swig_setmethods__ = {}
    for _s in [IteratorBase]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, SyntheticSingleTag, name, value)
    __swig_getmethods__ = {}
    for _s in [IteratorBase]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, SyntheticSingleTag, name)
    __repr__ = _swig_repr

    def __init__(self, *args, **kwargs):
        """__init__(self, tagger, base_channel) -> SyntheticSingleTag"""
        this = _TimeTagger.new_SyntheticSingleTag(*args, **kwargs)
        try:
            self.this.append(this)
        except __builtin__.Exception:
            self.this = this
    __swig_destroy__ = _TimeTagger.delete_SyntheticSingleTag
    __del__ = lambda self: None

    def trigger(self) -> "void":
        """trigger(self)"""
        return _TimeTagger.SyntheticSingleTag_trigger(self)


    def getChannel(self) -> "int":
        """getChannel(self) -> int"""
        return _TimeTagger.SyntheticSingleTag_getChannel(self)

SyntheticSingleTag_swigregister = _TimeTagger.SyntheticSingleTag_swigregister
SyntheticSingleTag_swigregister(SyntheticSingleTag)

class FrequencyStabilityData(_object):
    """Proxy of C++ FrequencyStabilityData class."""

    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, FrequencyStabilityData, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, FrequencyStabilityData, name)

    def __init__(self, *args, **kwargs):
        raise AttributeError("No constructor defined")
    __repr__ = _swig_repr
    __swig_destroy__ = _TimeTagger.delete_FrequencyStabilityData
    __del__ = lambda self: None

    def getSTDD(self) -> "void":
        """getSTDD(self)"""
        return _TimeTagger.FrequencyStabilityData_getSTDD(self)


    def getADEV(self) -> "void":
        """getADEV(self)"""
        return _TimeTagger.FrequencyStabilityData_getADEV(self)


    def getMDEV(self) -> "void":
        """getMDEV(self)"""
        return _TimeTagger.FrequencyStabilityData_getMDEV(self)


    def getTDEV(self) -> "void":
        """getTDEV(self)"""
        return _TimeTagger.FrequencyStabilityData_getTDEV(self)


    def getHDEV(self) -> "void":
        """getHDEV(self)"""
        return _TimeTagger.FrequencyStabilityData_getHDEV(self)


    def getADEVScaled(self) -> "void":
        """getADEVScaled(self)"""
        return _TimeTagger.FrequencyStabilityData_getADEVScaled(self)


    def getHDEVScaled(self) -> "void":
        """getHDEVScaled(self)"""
        return _TimeTagger.FrequencyStabilityData_getHDEVScaled(self)


    def getTau(self) -> "void":
        """getTau(self)"""
        return _TimeTagger.FrequencyStabilityData_getTau(self)


    def getTracePhase(self) -> "void":
        """getTracePhase(self)"""
        return _TimeTagger.FrequencyStabilityData_getTracePhase(self)


    def getTraceFrequency(self) -> "void":
        """getTraceFrequency(self)"""
        return _TimeTagger.FrequencyStabilityData_getTraceFrequency(self)


    def getTraceFrequencyAbsolute(self, input_frequency: 'double'=0.0) -> "void":
        """getTraceFrequencyAbsolute(self, input_frequency=0.0)"""
        return _TimeTagger.FrequencyStabilityData_getTraceFrequencyAbsolute(self, input_frequency)


    def getTraceIndex(self) -> "void":
        """getTraceIndex(self)"""
        return _TimeTagger.FrequencyStabilityData_getTraceIndex(self)


    def __enter__(self):
        return self

    def __exit__(self, type, value, tb):
        if self.thisown:
            self.__swig_destroy__(self)
            self.this = None
        return False

FrequencyStabilityData_swigregister = _TimeTagger.FrequencyStabilityData_swigregister
FrequencyStabilityData_swigregister(FrequencyStabilityData)

class FrequencyStability(IteratorBase):
    """Proxy of C++ FrequencyStability class."""

    __swig_setmethods__ = {}
    for _s in [IteratorBase]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, FrequencyStability, name, value)
    __swig_getmethods__ = {}
    for _s in [IteratorBase]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, FrequencyStability, name)
    __repr__ = _swig_repr

    def __init__(self, tagger: 'TimeTaggerBase', channel: 'int', steps: 'ULongVector', average: 'long long'=1000, trace_len: 'uint64_t'=1000):
        """__init__(self, tagger, channel, steps, average=1000, trace_len=1000) -> FrequencyStability"""
        this = _TimeTagger.new_FrequencyStability(tagger, channel, steps, average, trace_len)
        try:
            self.this.append(this)
        except __builtin__.Exception:
            self.this = this
    __swig_destroy__ = _TimeTagger.delete_FrequencyStability
    __del__ = lambda self: None

    def getDataObject(self) -> "FrequencyStabilityData":
        """getDataObject(self) -> FrequencyStabilityData"""
        return _TimeTagger.FrequencyStability_getDataObject(self)

FrequencyStability_swigregister = _TimeTagger.FrequencyStability_swigregister
FrequencyStability_swigregister(FrequencyStability)


class CustomMeasurement(CustomMeasurementBase):
  INCOMING_TAGS_DTYPE = numpy.dtype({'names':['type','missed_events','channel','time'], 'formats':['u1','<u2','<i4','<i8'], 'offsets':[0,2,4,8], 'itemsize':16}, align=True)

  def __init__(self, time_tagger):
    CustomMeasurementBase.__init__(self, time_tagger)
    self.showError = True

    class TTMutex(object):
      def __init__(self, iter):
        self.iter = iter
      def __enter__(self):
        self.iter._lock()
        return self
      def __exit__(self, type, value, tb):
        self.iter._unlock()
        return False
    self.mutex = TTMutex(self)

  def stop(self, *args, **kwargs):
    if self.this:
      CustomMeasurementBase.stop(self, *args, **kwargs)

  def __exit__(self, *args, **kwargs):
    if self.this:
      self.stop()
    return CustomMeasurementBase.__exit__(self, *args, **kwargs)

  def process(self, incoming_tags, begin_time, end_time):
    if self.showError:
        print("ERROR: The process() method of the Python-CustomMeasurement must be overwritten!")
        self.showError = False
    pass

  def next_impl(self, incoming_tags, begin_time, end_time):
    tags = incoming_tags.view(self.INCOMING_TAGS_DTYPE)
    try:
      self.process(tags, begin_time, end_time)
    except Exception as inst:
      import traceback
      traceback.print_exc()
      raise inst

    return False

# Stop all custom measurements on shutdown. Else the virtual function might still be called while the interpreter is going to shut down.
__import__('atexit').register(CustomMeasurementBase.stop_all_custom_measurements)

def setLogger(callback):
  """
  Sets the notifier callback which is called for each log message

  :param callback: The callback for the log message, like lambda level, msg: print(msg)
  :return: returns nothing
  """
  class PyLogger(CustomLogger):
    def __init__(self, callback):
      CustomLogger.__init__(self)
      self.callback = callback
      self.enable()
    def Log(self, level, message):
      self.callback(level, message)
  setLogger.logger = None
  if callback:
    setLogger.logger = PyLogger(callback)
setLogger.logger = None

def freeTimeTagger(tagger):
    r"""freeTimeTagger(tagger) -> bool"""
    if not isinstance(tagger, TimeTaggerBase):
        raise TypeError('in method \'freeTimeTagger\', argument 1 of type \'TimeTaggerBase\'')
    if tagger.this and tagger.thisown:
        tagger.__swig_destroy__(tagger)
        tagger.this = None
        return True
    return False


try:
  from enum import IntEnum
except:
  IntEnum = object
try:
  from enum import IntFlag
except:
  IntFlag = IntEnum

class CoincidenceTimestamp(IntEnum):
  Last = CoincidenceTimestamp_Last
  Average = CoincidenceTimestamp_Average
  First = CoincidenceTimestamp_First
  ListedFirst = CoincidenceTimestamp_ListedFirst

class Resolution(IntEnum):
  Standard = Resolution_Standard
  HighResA = Resolution_HighResA
  HighResB = Resolution_HighResB
  HighResC = Resolution_HighResC

class ChannelEdge(IntFlag):
  All = ChannelEdge_All
  Rising = ChannelEdge_Rising
  Falling = ChannelEdge_Falling
  HighResAll = ChannelEdge_HighResAll
  HighResRising = ChannelEdge_HighResRising
  HighResFalling = ChannelEdge_HighResFalling
  StandardAll = ChannelEdge_StandardAll
  StandardRising = ChannelEdge_StandardRising
  StandardFalling = ChannelEdge_StandardFalling

class UsageStatisticsStatus(IntEnum):
  Disabled = UsageStatisticsStatus_Disabled
  Collecting = UsageStatisticsStatus_Collecting
  CollectingAndUploading = UsageStatisticsStatus_CollectingAndUploading

class FrontendType(IntEnum):
  Undefined = FrontendType_Undefined
  WebApp = FrontendType_WebApp
  Firefly = FrontendType_Firefly
  Pyro5RPC = FrontendType_Pyro5RPC
  UserFrontend = FrontendType_UserFrontend

class LanguageUsed(IntEnum):
  Cpp = LanguageUsed_Cpp
  Python = LanguageUsed_Python
  Csharp = LanguageUsed_Csharp
  Matlab = LanguageUsed_Matlab
  Labview = LanguageUsed_Labview
  Mathematica = LanguageUsed_Mathematica
  Unknown = LanguageUsed_Unknown

class AccessMode(IntFlag):
  Listen = AccessMode_Listen
  Control = AccessMode_Control
  SynchronousControl = AccessMode_SynchronousControl

class TagType(IntEnum):
  TimeTag = Tag.Type_TimeTag
  Error = Tag.Type_Error
  OverflowBegin = Tag.Type_OverflowBegin
  OverflowEnd = Tag.Type_OverflowEnd
  MissedEvents = Tag.Type_MissedEvents

class GatedChannelInitial(IntEnum):
  Closed = GatedChannelInitial_Closed
  Open = GatedChannelInitial_Open

del IntEnum
del IntFlag

# This file is compatible with both classic and new-style classes.


